<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<c:set var="resourceReadOnly" value="${currentResource.moduleParams.readOnly}"/>
<template:include view="hidden.header"/>
<c:set var="isEmpty" value="true"/>
<c:set var="docspaceNode" value="${renderContext.mainResource.node.parent}"/>

<c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-collections-add')}">
    <jcr:sql var="queryResults" sql="select * from [docnt:collection] where ischildnode('${functions:sqlencode(currentUser.localPath)}/collections') order by [jcr:title] asc" />
    <c:if test="${not empty docspaceNode}">
        <c:if test="${queryResults.nodes.size > 0}">
            <c:set var="hasCollection" value="true"/>
        </c:if>
    </c:if>
</c:if>

<script type="text/javascript">
    var CollectionManager = {
        createCollection : function() {
            var box = bootbox.dialog({
                title: wsfi18n['wsf.collections.create'],
                message: '<form id="formCreateCollection" name="createCollection" class="single-submit-form">' +
                '<input type="text" class="input-block-level" value="" name="collection"/>' +
                '</form>',
                buttons: {
                    danger: {
                        label: wsfi18n['wsf.label.cancel'],
                        className: 'btn-default',
                        callback: function() {}
                    },
                    success: {
                        label: wsfi18n['docnt_assignedCollections.create'],
                        className: 'btn btn-primary',
                        callback: function() {
                            showLoading(wsfi18n['wsf.title.workInProgress']);
                            var str = document.getElementById("formCreateCollection").elements["collection"].value;
                            var uuids = ['${renderContext.mainResource.node.identifier}'];
                            var data = {
                                'jcr:title':str,
                                'docspaceIdentifier':'${renderContext.mainResource.node.parent.identifier}',
                                'action':'addCollection',
                                'uuids':uuids
                            };
                            $.post('<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.manageCollection.do"/>', data,
                                    function (result) {
                                        var redirectUrl = '<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.${renderContext.mainResource.template}.html"/>';
                                        if (result.collection != undefined) {
                                            redirectUrl += "?collection=" + encodeURIComponent(decodeURIComponent(result.collection));
                                        }
                                        location.replace(redirectUrl);
                                    }, "json");
                        }
                    }
                }
            });
            $(document).on('shown.bs.modal', function() {
                var elem = document.forms['createCollection'].elements['collection'].focus();
            });
            box.modal("show");
            return false;
        },
        manageCollection : function() {
            <c:if test="${jcr:hasPermission(renderContext.mainResource.node, 'docspace-collections-add')}">
            var form =  '<div id="manageCollectionForm">' +
                            <c:if test="${not empty docspaceNode}">
                                '<form name="manageCollection" class="form-horizontal single-submit-form">' +
                                    <c:forEach items="${queryResults.nodes}" var="node">
                                        '<div class="control-group">' +
                                            <c:set var="hasCollection" value="true"/>
                                            '<label class="control-label" for="manageCollection-' + '${node.identifier}' + '">' +
                                                '${functions:escapeJavaScript(node.displayableName)}' +
                                            '</label>' +
                                            '<div class="controls">' +
                                                '<input id="manageCollection-${node.identifier}" type="checkbox" name="collectionCheckbox" value="${node.identifier}"/>' +
                                            '</div>' +
                                        '</div>' +
                                    </c:forEach>
                                '</form>' +
                            </c:if>
                        '</div>';
            bootbox.dialog({
                title: wsfi18n['docnt_assignedCollections.addToCollection'],
                message: form,
                buttons: {
                    danger: {
                        label: wsfi18n['wsf.label.cancel'],
                        className: 'btn-default',
                        callback: function() {}
                    },
                    success: {
                        label: wsfi18n['wsf.label.ok'],
                        className: 'btn btn-primary',
                        callback: function() {
                            showLoading(wsfi18n['wsf.title.workInProgress']);
                            var uuids = ['${renderContext.mainResource.node.identifier}'];
                            var datas = {
                                'uuids':uuids,
                                'uuidsAddCollections':getColToEdit(true),
                                'uuidsRemoveCollections':getColToEdit(false),
                                'action':'editCollection'
                            };
                            $.post('<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.manageCollection.do"/>', datas,
                                    function (result) {
                                        location.reload(true);
                                    })
                        }
                    }
                }
            });
            (function () {
                var i = 0;
                while (i < document.forms.manageCollection.elements.collectionCheckbox.length) {
                    document.forms.manageCollection.elements.collectionCheckbox[i].checked = false;
                    i++;
                }
                var uuids = ['${renderContext.mainResource.node.identifier}'];
                var datas = {
                    'action':'getCollection',
                    'docspaceIdentifier':'${docspaceNode.identifier}',
                    'uuids':uuids
                };
                $.ajax({
                    url: '<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.manageCollection.do"/>',
                    type: 'POST',
                    dataType: 'json',
                    data: datas,
                    async: false,
                    success: function (result) {
                        i = 0;
                        el = document.forms.manageCollection.elements.collectionCheckbox;
                        while (i < el.length) {
                            if (result[el[i].value]) {
                                el[i].checked = true;
                            }
                            i++;
                        }
                    }
                });
            })();
            </c:if>
            return false;
        }
    }
</script>
<c:choose>
    <c:when test="${moduleMap.liveOnly eq 'true' && !renderContext.liveMode}">
        <c:if test="${renderContext.editModeConfigName eq 'studiomode'}">
            <div class="area-liveOnly">
                <fmt:message key="wsf.label.contentCreationOnlyLive"/>
            </div>
        </c:if>
        <c:if test="${!(renderContext.editModeConfigName eq 'studiomode')}">
            <template:addResources type="javascript" resources="jquery.min.js"/>
            <div id="liveList${currentNode.identifier}"></div>
            <script type="text/javascript">
                $('#liveList${currentNode.identifier}').load('<c:url value="${url.baseLive}${functions:escapeJavaScript(functions:escapePath(currentNode.path))}.html.ajax"/>');
            </script>
        </c:if>
    </c:when>
    <c:otherwise>
        <c:if test="${not empty moduleMap.currentList}">
            <ul class="unstyled">
                <c:forEach items="${moduleMap.currentList}" var="subchild" begin="${moduleMap.begin}"
                           end="${moduleMap.end}">
                    <li><template:module node="${subchild}" view="assigned"
                                         editable="${moduleMap.editable && !resourceReadOnly}"/></li>
                    <c:set var="isEmpty" value="false"/>
                </c:forEach>
            </ul>
        </c:if>
        <c:if test="${not omitFormatting}">
            <div class="clearfix"></div>
        </c:if>
        <c:if test="${moduleMap.editable and renderContext.editMode && !resourceReadOnly}">
            <template:module path="*"/>
        </c:if>
        <c:if test="${not empty moduleMap.emptyListMessage and renderContext.editMode and isEmpty}">
            ${moduleMap.emptyListMessage}
        </c:if>

        <div class="row-fluid">
            <c:if test="${jcr:hasPermission(renderContext.mainResource.node.parent, 'docspace-collections-add')}">
                    <a class="btn btn-default fa fa-bookmark" id="createCollection" href="#createCollectionForm"
                       onclick="return CollectionManager.createCollection()" title='<fmt:message key="docnt_assignedCollections.create"/>'>
                    </a>

                    <c:if test="${not empty hasCollection}">
                        <a class="btn btn-default fa fa-bookmark-o" id="manageCollection" href="#manageCollectionForm"
                           onclick="return CollectionManager.manageCollection()" title='<fmt:message key="docnt_assignedCollections.addToCollection"/>'>
                        </a>
                    </c:if>
            </c:if>
        </div>
        <template:include view="hidden.footer"/>
    </c:otherwise>
</c:choose>