<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="ui" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="prop" type="org.jahia.services.content.JCRPropertyWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="contribute.min.css"/>

<template:addResources type="javascript" resources="jquery.min.js,jquery.jeditable.js"/>
<template:addResources type="javascript" resources="ckeditor.js"/>
<template:addResources type="javascript" resources="jquery.jeditable.ckeditor.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js"/>
<c:set var="locale" value="${renderContext.mainResource.locale}"/>
<template:addResources type="javascript" resources="wsf_contribute.js"/>
<template:addResources type="javascript" resources="i18n/contributedefault-${currentResource.locale}.js"/>
<template:addResources type="javascript" resources="adapters/jquery.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>

<utility:useConstants var="jcrPropertyTypes" className="org.jahia.services.content.nodetypes.ExtendedPropertyType"
                      scope="application"/>
<utility:useConstants var="selectorType" className="org.jahia.services.content.nodetypes.SelectorType"
                      scope="application"/>

<template:addResources>
<script type="text/javascript">
    $(document).ready(function() {
        var collapse = document.getElementById("collapse1");
        var collapseInner = collapse.children[0];
        var allElements = collapseInner.children;
        collapseInner.appendChild(allElements[2]);
    });
</script>
</template:addResources>

<c:set var="nodeLocked" value="${jcr:isLockedAndCannotBeEdited(boundComponent)}"/>
<c:if test="${empty currentResource.moduleParams.contentType}">
    <c:set var="contentType" value="content"/>
</c:if>
<c:if test="${not empty currentResource.moduleParams.contentType}">
    <c:set var="contentType" value="${currentResource.moduleParams.contentType}"/>
</c:if>
<c:set var="boundComponent" value="${ui:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>
<jsp:useBean id="displayedFields" class="java.util.HashMap"/>
<c:forEach items="${boundComponent.nodeTypes}" var="typeName">
    <jcr:nodeType name="${typeName}" var="type"/>
    <c:if test="${!nodeLocked and !renderContext.ajaxRequest and jcr:hasPermission(boundComponent, 'jcr:modifyProperties_default')}">
        <c:set var="initEditFields" value="initEditFields('${boundComponent.identifier}');"/>
        <template:addResources>
            <script>
                $(document).ready(function() {
                    ${initEditFields}
                    refreshMoment();
                });
            </script>
        </template:addResources>
    </c:if>
    <template:addResources>
        <style>
            img {
                border: none;
            }
        </style>
    </template:addResources>
    <dl>
        <c:forEach items="${type.propertyDefinitions}" var="propertyDefinition">
            <%--//${propertyDefinition.name}</br>--%>
            <c:set var="scriptPropName" value="${fn:replace(propertyDefinition.name,':','_')}"/>
            <c:if test="${propertyDefinition.name eq 'jcr:title' and propertyDefinition.itemType eq contentType and not fn:contains(displayedFields,scriptPropName)}">
                <c:set var="prop" value="${boundComponent.properties[propertyDefinition.name]}"/>
                <dt>${jcr:labelInNodeType(propertyDefinition,currentResource.locale,type)}:</dt>
                    <c:set target="${displayedFields}" value="${scriptPropName}" property="${scriptPropName}" />
            <dd jcr:id="${propertyDefinition.name}" class="edit${boundComponent.identifier}"
                  id="edit${boundComponent.identifier}${scriptPropName}"
                  jcr:url="<c:url value='${url.base}${functions:escapePath(boundComponent.path)}'/>">${prop.string}</dd>
            </c:if>
            <c:if test="${propertyDefinition.name eq 'jcr:description' and propertyDefinition.itemType eq contentType and not fn:contains(displayedFields,scriptPropName)}">
                <c:set var="prop" value="${boundComponent.properties[propertyDefinition.name]}"/>
                <dt>${jcr:labelInNodeType(propertyDefinition,currentResource.locale,type)}:</dt>
                <c:set target="${displayedFields}" value="${scriptPropName}" property="${scriptPropName}" />
                <dd jcr:id="${propertyDefinition.name}" class="edit${boundComponent.identifier}"
                    id="edit${boundComponent.identifier}${scriptPropName}"
                    jcr:url="<c:url value='${url.base}${functions:escapePath(boundComponent.path)}'/>">${prop.string}</dd>
            </c:if>
        </c:forEach>
        <c:forEach items="${type.propertyDefinitions}" var="propertyDefinition">
            <c:set var="readonly" value="${nodeLocked or propertyDefinition.protected or not jcr:hasPermission(boundComponent, 'jcr:modifyProperties_default')}"/>
            <c:set var="scriptPropName" value="${fn:replace(propertyDefinition.name,':','_')}"/>
            <c:if test="${!propertyDefinition.multiple and propertyDefinition.itemType eq contentType and not propertyDefinition.hidden and !(propertyDefinition.name eq 'jcr:title') and !(propertyDefinition.name eq '*') and not fn:contains(displayedFields,scriptPropName)}">
                <c:set var="prop" value="${boundComponent.properties[propertyDefinition.name]}"/>
                <dt>${jcr:labelInNodeType(propertyDefinition,currentResource.locale,type)}:</dt>
                <dd>
                <c:set target="${displayedFields}" value="${scriptPropName}" property="${scriptPropName}" />
                <c:if test="${readonly}">
                    <c:choose>
                        <c:when test="${(propertyDefinition.requiredType == jcrPropertyTypes.REFERENCE || propertyDefinition.requiredType == jcrPropertyTypes.WEAKREFERENCE)}">
                            File
                        </c:when>
                        <c:when test="${propertyDefinition.requiredType == jcrPropertyTypes.DATE}">
                            <span
                                <c:if test="${not empty prop}">
                                    class="momentToFormat" data-moment-display-type="format" data-moment-format="LLL" data-moment-locale="${currentResource.locale}"
                                    data-moment="<fmt:formatDate value="${prop.date.time}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"
                                </c:if>
                            ></span>
                        </c:when>
                        <c:otherwise>
                            <span>${prop.string}</span>
                        </c:otherwise>
                    </c:choose>
                </c:if>
                <c:if test="${not readonly}">
                    <c:choose>
                        <c:when test="${renderContext.liveMode}">
                            <c:url value='${url.baseLive}' var="baseURL"/>
                        </c:when>
                        <c:otherwise>
                            <c:url value='${url.basePreview}' var="baseURL"/>
                        </c:otherwise>
                    </c:choose>
                    <c:choose>
                        <c:when test="${propertyDefinition.selector eq selectorType.RICHTEXT}">
                            <div jcr:id="${propertyDefinition.name}" class="ckeditorEdit${boundComponent.identifier}"
                                 id="ckeditorEdit${boundComponent.identifier}${scriptPropName}${renderContext.mainResource.locale}"
                                 jcr:url="<c:url value='${url.base}${functions:escapePath(boundComponent.path)}'/>" jcr:ckeditorToolbar="contributeCKEditorToolbar">${prop.string}</div>
                        </c:when>
                        <c:otherwise>
                            <div jcr:id="${propertyDefinition.name}" class="edit${boundComponent.identifier}"
                                 id="edit${boundComponent.identifier}${scriptPropName}"
                                 jcr:url="<c:url value='${url.base}${functions:escapePath(boundComponent.path)}'/>">${prop.string}</div>
                        </c:otherwise>
                    </c:choose>
                </c:if>
                </dd>
            </c:if>
        </c:forEach>
    </dl>
</c:forEach>