<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<script>
    var collections = {};
    $(document).ready(function() {
        $("#removeFrom_${currentNode.identifier}").click(
                function () {

                    if (confirm(getMessageWithArgs(wsfi18n['docnt_collection.askForRemove'], ['${functions:escapeJavaScript(renderContext.mainResource.node.unescapedName)}', '${functions:escapeJavaScript(currentNode.displayableName)}']))) {
                        var datas = {
                            'uuids': ['${renderContext.mainResource.node.identifier}'],
                            'uuidsAddCollections':[],
                            'uuidsRemoveCollections':['${currentNode.identifier}'],
                            'action':'editCollection'
                        };
                        $.ajax({
                            type:'POST',
                            url:'<c:url value="${url.base}${functions:escapeJavaScript(functions:escapePath(renderContext.mainResource.node.path))}.manageCollection.do"/>',
                            dataType:'json',
                            data:datas,
                            success: function (data, textStatus, jqXHR) {
                                location.reload(true);
                            }
                        });
                    }
                }
        );
    });
</script>

<c:set var="template"
       value="${renderContext.mainResource.node.primaryNodeTypeName == 'jnt:file' ? 'workspace-library' : 'workspace-notes'}"/>
<c:url var="colUrl" value="${url.base}${functions:escapePath(jcr:getParentOfType(renderContext.mainResource.node,'docmix:docspaceObject').path)}.${template}.html">
    <c:param name="collection" value="${currentNode.identifier}"/>
</c:url>
<c:set var="referenceType"
       value="${renderContext.mainResource.node.primaryNodeTypeName == 'jnt:file' ? 'jnt:fileReference' : 'docnt:noteReference'}"/>
<span class="collectionwithdoc"></span><a title="${fn:escapeXml(currentNode.displayableName)}" id="${currentNode.identifier}-collecPath" href="${colUrl}">${functions:abbreviate(functions:default(fn:trim(currentNode.displayableName), currentNode.name),30,40,'...')} (${fn:length(jcr:getChildrenOfType(currentNode, referenceType))})</a>
<c:if test="${jcr:hasPermission(currentNode,'jcr:removeNode')}">
    <fmt:message key='docnt_collection.removeFrom' var="removeFromCollection"/>
    <a title="${fn:escapeXml(removeFromCollection)}" class="removefrom" href="#"
       id="removeFrom_${currentNode.identifier}">
        ${removeFromCollection}
    </a>
</c:if>
