<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<c:set var="isWsfaccess" value="true"/>

<c:choose>
    <c:when test="${currentNode.properties['settingToDisplay'].string eq 'userProfile'}">
        <jcr:node var="user" path="${renderContext.user.localPath}"/>
        <c:url var="urlToGet" value="${url.baseUserBoardFrameEdit}${functions:escapePath(user.path)}.me.html"/>
    </c:when>
    <c:when test="${currentNode.properties['settingToDisplay'].string eq 'usersManagement'}">
        <c:url var="urlToGet" value="${url.base}/settings.manageUsers.html"/>
    </c:when>
    <c:when test="${currentNode.properties['settingToDisplay'].string eq 'manageGroups'}">
        <c:url var="urlToGet" value='${url.base}${functions:escapePath(renderContext.site.path)}.manageGroups.html'/>
        <c:set var="isWsfaccess" value="false"/>
    </c:when>
    <c:when test="${currentNode.properties['settingToDisplay'].string eq 'mounts'}">
        <c:url var="urlToGet" value="/cms/adminframe/default/${currentResource.locale}/settings.manageMountPoints.html"/>
        <c:set var="isWsfaccess" value="false"/>
    </c:when>
</c:choose>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function() {
            <c:choose>
                <c:when test="${isWsfaccess}">
                    $('#digitalFactorySettingsDisplay').parent().css('margin-top', '40px');
                </c:when>
                <c:otherwise>
                    $('#digitalFactorySettingsDisplay').parent().css('margin-top', '-20px');
                </c:otherwise>
            </c:choose>


            $('#digitalFactorySettingsDisplay').parent().css('padding-left', '0px');
            $('#digitalFactorySettingsDisplay').parent().css('padding-right', '0px');
        });

        <c:if test="${currentNode.properties['settingToDisplay'].string eq 'mounts'}">
            function goToUrl(url) {
                document.getElementById("digitalFactorySettingsDisplay").contentWindow.location = (url)
            }
        </c:if>

        function autoResize(id){
            var newheight = 800;

            <c:if test="${isWsfaccess}">
                newheight = 300;
            </c:if>

            if(document.getElementById){
                newheight += document.getElementById(id).contentWindow.document.body.scrollHeight;
            }
            document.getElementById(id).height = (newheight) + "px";
        }
    </script>
</template:addResources>

<iframe id="digitalFactorySettingsDisplay" width="100%" frameborder="0" src="${urlToGet}"
        onLoad="autoResize('digitalFactorySettingsDisplay');" scrolling="no"></iframe>
