<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="social" uri="http://www.jahia.org/tags/socialLib" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function() {
            refreshMoment();
            refreshMomentEvery(60000);
        });
    </script>
</template:addResources>

<jcr:node var="adminSite" path="/sites/wsfaccess"/>

<c:set var="fromUser" value="${jcr:getParentOfType(currentNode,'jnt:user')}"/>
<c:choose>
    <c:when test="${fromUser.name eq renderContext.user.name}">
        <c:url var="userUrl"
               value='${url.baseLive}${functions:escapePath(fromUser.path)}.workspace-user.html?jsite=${adminSite.identifier}'/>
    </c:when>
    <c:otherwise>
        <c:url var="userUrl"
               value='${url.baseLive}${functions:escapePath(fromUser.path)}.workspace-public-user.html?jsite=${adminSite.identifier}'/>
    </c:otherwise>
</c:choose>

<div class="row-fluid">
    <div class="span1">
    <jcr:nodeProperty var="picture" node="${fromUser}" name="j:picture"/>
        <c:choose>
            <c:when test="${not empty picture}">
                <a href="${userUrl}">
                    <img class="img-polaroid img-circle"
                         src="${picture.node.thumbnailUrls['avatar_120']}"/>
                </a>
            </c:when>
            <c:otherwise>
                <a href="${userUrl}">
                    <img class="img-polaroid img-circle"
                         alt=" " src="<c:url value='/modules/social/images/userBig.png'/>" border="0"/>
                </a>
            </c:otherwise>
        </c:choose>
    </div>
    <div class="span11">
        <div class="row-fluid">
            <div class="span6">
                <p>
                    <a href="${userUrl}">${fn:escapeXml(not empty fromUser ? user:userFullName(fromUser) : fields["jcr:createdBy"])}</a>
                </p>
            </div>
            <jcr:nodeProperty node="${currentNode}" name="jcr:lastModified" var="lastModified"/>
            <div class="span6">
                <span class="momentToFormat pull-right" data-moment-display-type="fromNow" data-moment-locale="${currentResource.locale}"
                      data-moment="<fmt:formatDate value="${lastModified.time}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span>
            </div>
        </div>
        <div class="row-fluid">
            <div class="span12">
                <c:set var="targetPath" value="${currentNode.properties['j:targetNode'].string}"/>
                <jcr:node var="targetNode" path="${currentNode.properties['j:targetNode'].string}"/>
                <c:set var="activityType" value="${currentNode.properties['j:activityType'].string}"/>
                <c:set var="targetLink" value="${targetPath}"/>

                <c:choose>
                    <c:when test="${activityType eq 'docspace-massimport'}">
                        <fmt:message key="label.activityTypes.docspace-massimport.message">
                            <fmt:param value="${currentNode.properties['nbFilesImported'].long}"/>
                            <fmt:param value="${currentNode.properties['nbFilesSkipped'].long}"/>
                            <fmt:param value="${currentNode.properties['nbFilesRejected'].long}"/>
                        </fmt:message>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-newfile'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-document-details.html"/>">
                                    ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-newfile.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                        <div class="clearfix"></div>
                        <c:if test="${not empty targetNode}">
                            <div class="row-fluid">
                                <%@include file="thumbnailDisplay.jspf" %>
                                <div class="span10">
                                    <p><fmt:message key="label.activityTypes.docspace-newfile.message.type"/>${' '}${targetNode.fileContent.contentType}</p>
                                    <%@include file="extractedText.jspf" %>
                                </div>
                            </div>
                        </c:if>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-filecontentupdated'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-document-details.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-filecontentupdated.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                        <div class="clearfix"></div>
                        <c:if test="${not empty targetNode}">
                            <div class="row-fluid">
                                <%@include file="thumbnailDisplay.jspf" %>
                                <div class="span10">
                                    <p><fmt:message key="label.activityTypes.docspace-newfile.message.type"/>${' '}${targetNode.fileContent.contentType}</p>
                                    <%@include file="extractedText.jspf" %>
                                </div>
                            </div>
                        </c:if>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-documentdescriptionupdated'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-document-details.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-documentdescriptionupdated.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                        <div class="clearfix"></div>
                        <c:if test="${not empty targetNode}">
                            <div class="row-fluid">
                                <%@include file="thumbnailDisplay.jspf" %>
                                <div class="span10">
                                    ${fn:escapeXml(functions:abbreviate(currentNode.properties['newvalue'].string,30,40,'...'))}
                                </div>
                            </div>
                        </c:if>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-documenttitleupdated'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-document-details.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-documenttitleupdated.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                        <div class="clearfix"></div>
                        <c:if test="${not empty targetNode}">
                            <div class="row-fluid">
                                <%@include file="thumbnailDisplay.jspf" %>
                                <div class="span10">
                                    ${fn:escapeXml(functions:abbreviate(currentNode.properties['newvalue'].string,30,40,'...'))}
                                </div>
                            </div>
                        </c:if>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-moved'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="previousOriginLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.parent.path)}.workspace-library.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.parent.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                            <c:choose>
                                <c:when test="${jcr:isNodeType(targetNode, 'docmix:docspaceDocument')}">
                                    <c:set var="targetLink">
                                        <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-document-details.html"/>">
                                                ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                        </a>
                                    </c:set>
                                </c:when>
                                <c:when test="${jcr:isNodeType(targetNode, 'docmix:docspaceFolder')}">
                                    <c:set var="targetLink">
                                        <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-library.html"/>">
                                                ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                        </a>
                                    </c:set>
                                </c:when>
                            </c:choose>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-moved.message">
                                    <fmt:param value="${targetLink}"/>
                                    <fmt:param value="${previousOriginLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-copied'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="previousOriginLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.parent.path)}.workspace-library.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.parent.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                            <c:choose>
                                <c:when test="${jcr:isNodeType(targetNode, 'docmix:docspaceDocument')}">
                                    <c:set var="targetLink">
                                        <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-document-details.html"/>">
                                                ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                        </a>
                                    </c:set>
                                </c:when>
                                <c:when test="${jcr:isNodeType(targetNode, 'docmix:docspaceFolder')}">
                                    <c:set var="targetLink">
                                        <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-library.html"/>">
                                                ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                        </a>
                                    </c:set>
                                </c:when>
                            </c:choose>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-copied.message">
                                    <fmt:param value="${targetLink}"/>
                                    <fmt:param value="${previousOriginLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-tagged'}">
                        <c:if test="${not empty targetNode}">
                            <c:choose>
                                <c:when test="${jcr:isNodeType(targetNode, 'docmix:docspaceDocument')}">
                                    <c:set var="targetLink">
                                        <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-document-details.html"/>">
                                                ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                        </a>
                                    </c:set>
                                </c:when>
                                <c:when test="${jcr:isNodeType(targetNode, 'docnt:note')}">
                                    <c:set var="targetLink">
                                        <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-note-details.html"/>">
                                                ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                        </a>
                                    </c:set>
                                </c:when>
                            </c:choose>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <c:forEach items="${currentNode.properties['newvalues']}" var="value" varStatus="st">
                                    <c:if test="${st.first}">
                                        <c:set var="tags">
                                            <span class="label label-info">${value.string}</span>
                                        </c:set>
                                    </c:if>
                                    <c:if test="${not st.first}">
                                        <c:set var="tags">
                                            ${tags}
                                            <span class="label label-info">${value.string}</span>
                                        </c:set>
                                    </c:if>
                                </c:forEach>
                                <fmt:message key="label.activityTypes.docspace-tagged.message">
                                    <fmt:param value="${targetLink}"/>
                                    <fmt:param value="${tags}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-categorized'}">
                        <c:if test="${not empty targetNode}">
                            <c:choose>
                                <c:when test="${jcr:isNodeType(targetNode, 'docmix:docspaceDocument')}">
                                    <c:set var="targetLink">
                                        <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-document-details.html"/>">
                                                ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                        </a>
                                    </c:set>
                                </c:when>
                                <c:when test="${jcr:isNodeType(targetNode, 'docnt:note')}">
                                    <c:set var="targetLink">
                                        <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-note-details.html"/>">
                                                ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                        </a>
                                    </c:set>
                                </c:when>
                            </c:choose>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <c:forEach items="${currentNode.properties['newvalues']}" var="value" varStatus="st">
                                    <jcr:node var="cat" path="${value.string}"/>
                                    <c:if test="${st.first}">
                                        <c:set var="cats" value="${cat.displayableName}"/>
                                    </c:if>
                                    <c:if test="${not st.first}">
                                        <c:set var="cats" value="${cats},&nbsp;${cat.displayableName}"/>
                                    </c:if>
                                </c:forEach>
                                <fmt:message key="label.activityTypes.docspace-categorized.message">
                                    <fmt:param value="${targetLink}"/>
                                    <fmt:param value="${cats}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-noteconversion'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-note-details.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-noteconversion.message">
                                    <fmt:param value="${targetLink}"/>
                                    <fmt:param value="${currentNode.properties['conversionType'].string}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-newpoll'}">
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-newpoll.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                        <div class="row-fluid">
                            <div class="span12">
                                <c:if test="${not empty targetNode}">
                                    <template:module path="${targetNode.path}" view="docspace"/>
                                </c:if>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-closedpoll'}">
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-closedpoll.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                        <div class="row-fluid">
                            <div class="span12">
                                <template:module path="${targetNode.path}" view="docspace"/>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-newdiscussion'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.parent.path)}.html"/>">
                                    ${fn:escapeXml(targetNode.parent.displayableName)}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-newdiscussion.message">
                                    <fmt:param value="${fn:escapeXml(targetNode.displayableName)}"/>
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-newtopic'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.html"/>">
                                        ${fn:escapeXml(targetNode.displayableName)}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-newtopic.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-newblogcomment'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.parent.parent.path)}.html"/>">
                                        ${fn:escapeXml(targetNode.parent.parent.displayableName)}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-newblogcomment.message">
                                    <fmt:param value="${fn:escapeXml(targetNode.displayableName)}"/>
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-newmember'}">
                        <c:choose>
                            <c:when test="${fn:startsWith(currentNode.properties['memberKey'].string, 'u:')}">
                                <c:set var="user"
                                       value="${user:lookupUser(fn:substringAfter(currentNode.properties['memberKey'].string, 'u:'))}"/>
                                <c:choose>
                                    <c:when test="${ not empty user}">
                                        <jcr:node var="newUserNode" path="${user.localPath}"/>
                                        <c:url var="thisUserUrl"
                                               value='${url.baseLive}${functions:escapePath(newUserNode.path)}.workspace-public-user.html?jsite=${adminSite.identifier}'/>

                                        <c:set var="member"><a
                                                href="${thisUserUrl}">${user:displayName(user)}</a></c:set>
                                    </c:when>
                                    <c:otherwise>
                                        <c:set var="member" value="${fn:substringAfter(currentNode.properties['memberKey'].string, 'u:')}"/>
                                    </c:otherwise>
                                </c:choose>

                                <fmt:message var="roleNice" key="wsf.role.${currentNode.properties['role'].string}.short"/>
                                <fmt:message var="newMemberMessage" key="label.activityTypes.docspace-newmember.message">
                                    <fmt:param value="${member}"/>
                                    <fmt:param value="${roleNice}"/>
                                </fmt:message>
                            </c:when>
                            <c:when test="${fn:startsWith(currentNode.properties['memberKey'].string, 'g:')}">
                                <c:set var="group"
                                       value="${fn:substringAfter(currentNode.properties['memberKey'].string, 'g:')}"/>

                                <fmt:message var="roleNice" key="wsf.role.${currentNode.properties['role'].string}.short"/>
                                <fmt:message var="newMemberMessage" key="label.activityTypes.docspace-newgroup.message">
                                    <fmt:param value="${group}"/>
                                    <fmt:param value="${roleNice}"/>
                                </fmt:message>
                            </c:when>
                        </c:choose>
                        <div class="row-fluid">
                            <div class="span12">
                                ${newMemberMessage}
                            </div>
                            <div class="row-fluid">
                                <div class="span12"
                                    <c:if test="${not empty newUserNode}">
                                        <template:module path="${newUserNode.path}" view="mini"/>
                                    </c:if>
                                </div>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-newtask'}">
                        <c:if test="${not empty targetNode}">
                            <c:choose>
                                <c:when test="${jcr:isNodeType(targetNode.parent.parent, 'docmix:docspaceDocument')}">
                                    <c:set var="targetLink">
                                        <a href="<c:url value="${url.base}${functions:escapePath(targetNode.parent.parent.path)}.workspace-document-details.html"/>">
                                                ${fn:escapeXml(functions:abbreviate(targetNode.parent.parent.displayableName,30,40,'...'))}
                                        </a>
                                    </c:set>
                                </c:when>
                                <c:when test="${jcr:isNodeType(targetNode.parent.parent, 'docnt:note')}">
                                    <c:set var="targetLink">
                                        <a href="<c:url value="${url.base}${functions:escapePath(targetNode.parent.parent.path)}.workspace-note-details.html"/>">
                                                ${fn:escapeXml(functions:abbreviate(targetNode.parent.parent.displayableName,30,40,'...'))}
                                        </a>
                                    </c:set>
                                </c:when>
                                <c:otherwise>
                                    <c:set var="targetLink">
                                        <a href="<c:url value="${url.base}${functions:escapePath(targetNode.parent.parent.path)}.html"/>">
                                                ${fn:escapeXml(functions:abbreviate(targetNode.parent.parent.displayableName,30,40,'...'))}
                                        </a>
                                    </c:set>
                                </c:otherwise>
                            </c:choose>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-newtask.message">
                                    <fmt:param value="${fn:escapeXml(targetNode.displayableName)}"/>
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                            <c:if test="${not empty currentNode.properties['newAssignee'] and not empty user:lookupUser(currentNode.properties['newAssignee'].string)}">
                                <c:set var="assignee" value="${user:lookupUser(currentNode.properties['newAssignee'].string)}"/>
                            </c:if>
                            <div class="row-fluid">
                                <div class="span12">
                                    <fmt:message key="label.activityTypes.docspace-newtask.message.status"/>
                                        ${' '}${currentNode.properties['newStatus'].string}
                                    <c:if test="${not empty assignee}">
                                        <br />
                                        <c:url var="assigneeURL"
                                               value="${url.baseLive}${functions:escapePath(assignee.path)}.workspace-public-user.html?jsite=${adminSite.identifier}"/>
                                        ${' '}<fmt:message key="label.activityTypes.docspace-newtask.message.assignee"/>
                                        ${' '}<a href="${assigneeURL}">${user:fullName(assignee)}</a>
                                    </c:if>
                                </div>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-taskupdated'}">
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-taskupdated.message">
                                    <fmt:param value="${fn:escapeXml(targetNode.displayableName)}"/>
                                </fmt:message>
                            </div>
                            <c:if test="${not empty currentNode.properties['newAssignee'] and not empty user:lookupUser(currentNode.properties['newAssignee'].string)}">
                                <c:set var="assignee" value="${user:lookupUser(currentNode.properties['newAssignee'].string)}"/>
                            </c:if>
                            <div class="row-fluid">
                                <div class="span12">
                                    <fmt:message key="label.activityTypes.docspace-newtask.message.status"/>
                                        ${' '}${currentNode.properties['newStatus'].string}
                                    <c:if test="${not empty assignee}">
                                        <br />
                                        <c:url var="assigneeURL"
                                               value="${url.baseLive}${functions:escapePath(assignee.path)}.workspace-public-user.html?jsite=${adminSite.identifier}"/>
                                        ${' '}<fmt:message key="label.activityTypes.docspace-newtask.message.assignee"/>
                                        ${' '}<a href="${assigneeURL}">${user:fullName(assignee)}</a>
                                    </c:if>
                                </div>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-newlinkedresource'}">
                        <c:choose>
                            <c:when test="${jcr:isNodeType(currentNode.properties['target'].node, 'docmix:docspaceDocument')}">
                                <c:set var="targetLink">
                                    <a href="<c:url value="${url.base}${functions:escapePath(currentNode.properties['target'].node.path)}.workspace-document-details.html"/>">
                                            ${fn:escapeXml(functions:abbreviate(currentNode.properties['target'].node.displayableName,30,40,'...'))}
                                    </a>
                                </c:set>
                            </c:when>
                            <c:when test="${jcr:isNodeType(currentNode.properties['target'].node, 'docnt:note')}">
                                <c:set var="targetLink">
                                    <a href="<c:url value="${url.base}${functions:escapePath(currentNode.properties['target'].node.path)}.workspace-note-details.html"/>">
                                            ${fn:escapeXml(functions:abbreviate(currentNode.properties['target'].node.displayableName,30,40,'...'))}
                                    </a>
                                </c:set>
                            </c:when>
                        </c:choose>
                        <c:choose>
                            <c:when test="${jcr:isNodeType(currentNode.properties['source'].node, 'docmix:docspaceDocument')}">
                                <c:set var="sourceLink">
                                    <a href="<c:url value="${url.base}${functions:escapePath(currentNode.properties['source'].node.path)}.workspace-document-details.html"/>">
                                            ${fn:escapeXml(currentNode.properties['source'].node.displayableName)}
                                    </a>
                                </c:set>
                            </c:when>
                            <c:when test="${jcr:isNodeType(currentNode.properties['source'].node, 'docnt:note')}">
                                <c:set var="sourceLink">
                                    <a href="<c:url value="${url.base}${functions:escapePath(currentNode.properties['source'].node.path)}.workspace-note-details.html"/>">
                                            ${fn:escapeXml(currentNode.properties['source'].node.displayableName)}
                                    </a>
                                </c:set>
                            </c:when>
                        </c:choose>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-newlinkedresource.message">
                                    <fmt:param value="${targetLink}"/>
                                    <fmt:param value="${sourceLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-newcomment'}">
                        <c:set var="targetLink">
                            <a href="<c:url value="${url.base}${functions:escapePath(currentNode.properties['target'].node.path)}.workspace-document-details.html"/>">
                                    ${fn:escapeXml(functions:abbreviate(currentNode.properties['target'].node.displayableName,30,40,'...'))}
                            </a>
                        </c:set>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-newcomment.message">
                                    <fmt:param value="${currentNode.properties['commentTitle'].string}"/>
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-newnotecomment'}">
                        <c:set var="targetLink">
                            <a href="<c:url value="${url.base}${functions:escapePath(currentNode.properties['target'].node.path)}.workspace-note-details.html"/>">
                                    ${fn:escapeXml(functions:abbreviate(currentNode.properties['target'].node.displayableName,30,40,'...'))}
                            </a>
                        </c:set>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-newnotecomment.message">
                                    <fmt:param value="${currentNode.properties['commentTitle'].string}"/>
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-newwikipage'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-newwikipage.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-editwikipage'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-editwikipage.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-startreview'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-document-details.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-startreview.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-rejectreview'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-document-details.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-rejectreview.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-documentpublished'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-document-details.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-documentpublished.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-acceptreview'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-document-details.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-acceptreview.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-newblogentry'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-newblogentry.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-newfolder'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-newfolder.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-newnote'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.workspace-note-details.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-newnote.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-newapp'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-newapp.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                    <c:when test="${activityType eq 'docspace-newdocspace'}">
                        <c:if test="${not empty targetNode}">
                            <c:set var="targetLink">
                                <a href="<c:url value="${url.base}${functions:escapePath(targetNode.path)}.html"/>">
                                        ${fn:escapeXml(functions:abbreviate(targetNode.displayableName,30,40,'...'))}
                                </a>
                            </c:set>
                        </c:if>
                        <div class="row-fluid">
                            <div class="span12">
                                <fmt:message key="label.activityTypes.docspace-newdocspace.message">
                                    <fmt:param value="${targetLink}"/>
                                </fmt:message>
                            </div>
                        </div>
                    </c:when>
                </c:choose>
            </div>
        </div>
    </div>
</div>
<div class="clearfix"></div>