<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"%>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="javascript" resources="bootstrap-dropdown.js"/>

<c:choose>
    <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'docmix:docspace')}">
        <c:set var="docspaceNode" value="${renderContext.mainResource.node}"/>
    </c:when>
    <c:otherwise>
        <c:set var="docspaceNode" value="${jcr:getParentOfType(renderContext.mainResource.node, 'docmix:docspace')}"/>
    </c:otherwise>
</c:choose>

<c:choose>
    <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'jnt:page') or not empty jcr:getParentOfType(renderContext.mainResource.node, 'jnt:page')}">
        <c:set var="currentContainer" value="apps"/>
    </c:when>
    <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'docnt:notesContainer') or not empty jcr:getParentOfType(renderContext.mainResource.node, 'docnt:notesContainer')}">
        <c:set var="currentContainer" value="notes"/>
    </c:when>
    <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'docnt:pollsContainer') or not empty jcr:getParentOfType(renderContext.mainResource.node, 'docnt:pollsContainer')}">
        <c:set var="currentContainer" value="polls"/>
    </c:when>
    <c:when test="${not jcr:isNodeType(renderContext.mainResource.node, 'docmix:docspace') and (jcr:isNodeType(renderContext.mainResource.node, 'jnt:folder') or jcr:isNodeType(renderContext.mainResource.node, 'jnt:file'))}">
        <c:set var="currentContainer" value="library"/>
    </c:when>
    <c:otherwise>
        <c:set var="currentContainer" value="docspace"/>
    </c:otherwise>
</c:choose>

<jcr:node var="adminSite" path="/sites/wsfaccess"/>
<c:if test="${not empty currentNode.properties['ulclass'].string}">
    <ul class="${currentNode.properties['ulclass'].string}">
</c:if>

<c:if test="${currentNode.properties['wisehome'].boolean}">
    <jcr:sql var="wsfactoryResults" sql="SELECT * FROM [jnt:virtualsite] WHERE ['j:templatesSet']='workspace-factory' ORDER BY ['jcr:title'] ASC"/>
    <c:if test="${fn:length(wsfactoryResults.nodes) gt 0}">
        <c:set var="sitePathToCompare" value="${renderContext.site.path}/"/>
        <c:choose>
            <c:when test="${fn:length(wsfactoryResults.nodes) eq 1}">
                <c:forEach items="${wsfactoryResults.nodes}" var="workspaceFactorySite" varStatus="status">
                    <c:if test="${status.first}">
                        <li <%--<c:if test="${fn:startsWith(workspaceFactorySite.home.path, sitePathToCompare) and sitePathToCompare ne '/sites/wsfaccess/'}">class="active"</c:if>--%>>
                            <a href="<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(workspaceFactorySite.path)}/home.html'/>">
                                <i class="fa fa-fw fa-home"></i>
                                ${workspaceFactorySite.displayableName}
                            </a>
                        </li>
                    </c:if>
                </c:forEach>
            </c:when>
            <c:otherwise>
                <li id="workspaceFactoriesDropdownMenu" class="dropdown<%--<c:if test="${fn:startsWith(renderContext.mainResource.node.path, sitePathToCompare) and sitePathToCompare ne '/sites/wsfaccess/'}"> active</c:if>--%>">
                    <a class="dropdown-toggle active" data-toggle="dropdown" href="#">
                        <i class="fa fa-fw fa-home"></i>
                        <c:set value="false" var="inWorkspaceFactory"/>
                        <c:forEach items="${wsfactoryResults.nodes}" var="workspaceFactorySite">
                            <c:if test="${fn:startsWith(workspaceFactorySite.home.path, sitePathToCompare)}">
                                ${workspaceFactorySite.displayableName}
                                <c:set value="true" var="inWorkspaceFactory"/>
                            </c:if>
                        </c:forEach>
                        <c:if test="${not inWorkspaceFactory}">
                            <fmt:message key="docnt_docspaceNavigation.workspaceFactories"/>
                        </c:if>
                        <b class="caret"></b>
                    </a>
                    <ul class="dropdown-menu">
                        <li class="dropdown-header">
                            <fmt:message key="docnt_docspaceNavigation.workspaceFactories"/>
                        </li>
                        <li class="divider"></li>
                        <c:forEach items="${wsfactoryResults.nodes}" var="workspaceFactorySite">
                            <li <c:if test="${fn:startsWith(workspaceFactorySite.home.path, sitePathToCompare)}">class="active"</c:if>>
                                <a href="<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(workspaceFactorySite.path)}/home.html'/>">
                                    <i class="fa fa-fw fa-home"></i>
                                    ${workspaceFactorySite.displayableName}
                                </a>
                            </li>
                        </c:forEach>
                    </ul>
                </li>
            </c:otherwise>
        </c:choose>
    </c:if>
</c:if>

<c:if test="${not empty docspaceNode and currentNode.properties['home'].boolean }">
    <li <c:if test="${renderContext.mainResource.template eq 'default' and currentContainer eq 'docspace'}">class="active"</c:if>>
        <a href="<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(docspaceNode.path)}.html'/>">
            <i class="fa fa-fw fa-dashboard"></i>
            <fmt:message key="docnt_docspaceNavigation.dashboard"/>
        </a>
    </li>
</c:if>

<c:if test="${not empty docspaceNode and currentNode.properties['library'].boolean}">
    <li <c:if test="${currentContainer eq 'library' || renderContext.mainResource.template eq 'workspace-library' || renderContext.mainResource.template eq 'workspace-document-details'}">class="active"</c:if>>
        <a href="<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(docspaceNode.path)}.workspace-library.html'/>">
            <i class="fa fa-fw fa-folder"></i>
            <fmt:message key="docnt_docspaceNavigation.library"/>
        </a>
    </li>
</c:if>
<c:if test="${not empty docspaceNode and currentNode.properties['notes'].boolean}">
    <li <c:if test="${currentContainer eq 'notes'}">class="active"</c:if>>
        <a href="<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(docspaceNode.path)}/notes.workspace-notes.html'/>">
            <i class="fa fa-fw fa-pencil"></i>
            <fmt:message key="wsf.label.notes"/>
        </a>
    </li>
</c:if>
<c:if test="${not empty docspaceNode and currentNode.properties['polls'].boolean}">
    <li <c:if test="${currentContainer eq 'polls'}">class="active"</c:if>>
        <a href="<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(docspaceNode.path)}/polls.workspace-polls.html'/>">
            <i class="fa fa-fw fa-bars"></i>
            <fmt:message key="wsf.label.polls"/>
        </a>
    </li>
</c:if>
<c:if test="${not empty docspaceNode and currentNode.properties['calendar'].boolean}">
    <li <c:if test="${renderContext.mainResource.template eq 'workspace-calendar'}">class="active"</c:if>>
        <a href="<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(docspaceNode.path)}.workspace-calendar.html'/>">
            <i class="fa fa-fw fa-calendar"></i>
            <fmt:message key="docnt_docspaceNavigation.calendar"/>
        </a>
    </li>
</c:if>
<c:if test="${currentNode.properties['directory'].boolean}">
    <c:if test="${jcr:hasPermission(adminSite, 'jcr:read_default')}">
        <c:set var="directoryPagePath" value="${adminSite.path}/directory"/>
    <li <c:if test="${renderContext.mainResource.node.path eq directoryPagePath}">class="active"</c:if>>
        <a href="<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(adminSite.path)}/directory.html'/>">
            <i class="fa fa-fw fa-users"></i>
            <fmt:message key="docnt_docspaceNavigation.users"/>
        </a>
    </li>
    </c:if>
</c:if>
<c:if test="${currentNode.properties['profile'].boolean}">
    <li <c:if test="${renderContext.mainResource.template eq 'workspace-user'}">class="active"</c:if>>
        <a href="<c:url value='${url.baseLive}${functions:escapePath(renderContext.user.localPath)}.workspace-user.html?jsite=${adminSite.identifier}'/>">
            <i class="fa fa-fw fa-user"></i>
            ${renderContext.user.username}
        </a>
    </li>
</c:if>
<c:if test="${not empty docspaceNode and currentNode.properties['apps'].boolean}">
    <c:forEach items="${docspaceNode.nodes}" var="node">
        <template:addCacheDependency node="${node}"/>
        <c:if test="${jcr:isNodeType(node, 'jnt:page') and !jcr:isNodeType(node, 'jmix:navMenu')}">
            <li <c:if test="${fn:startsWith(renderContext.mainResource.node.path,node.path)}">class="active"</c:if>>
                <a href="<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(node.path)}.html'/>">
                    <i class="fa fa-fw fa-<c:if test="${node.name eq 'forum'}">comment</c:if><c:if test="${node.name eq 'wiki'}">university</c:if><c:if test="${node.name eq 'blog'}">bullhorn</c:if>"
                        ></i>
                    ${node.displayableName}
                </a>
            </li>
        </c:if>
    </c:forEach>
</c:if>
<c:if test="${not empty docspaceNode and currentNode.properties['members'].boolean}">
    <li <c:if test="${renderContext.mainResource.template eq 'workspace-members'}">class="active"</c:if>>
        <a href="<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(docspaceNode.path)}.workspace-members.html'/>">
            <i class="fa fa-fw fa-users"></i>
            <fmt:message key="wsf.label.members"/>
        </a>
    </li>
</c:if>
<c:if test="${not empty docspaceNode and currentNode.properties['settings'].boolean}">
    <c:if test="${jcr:hasPermission(docspaceNode, 'docspace-settings-main') or jcr:hasPermission(docspaceNode, 'docspace-settings-massImport') or jcr:hasPermission(docspaceNode, 'docspace-settings-emailGateway')}">
        <li class="hidden-tablet<c:if test="${renderContext.mainResource.template eq 'workspace-settings'}"> active</c:if>">
            <a href="<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(docspaceNode.path)}.workspace-settings.html'/>">
                <i class="fa fa-fw fa-cog"></i>
                <fmt:message key="docnt_docspaceNavigation.settings"/>
            </a>
        </li>
    </c:if>
</c:if>

<template:addCacheDependency node="${renderContext.mainResource.node}"/>
<c:if test="${not empty currentNode.properties['ulclass'].string}">
    </ul>
</c:if>