<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="workflow" uri="http://www.jahia.org/tags/workflow" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="utils" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="ui" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>

<c:set var="docspaceNode" value="${renderContext.mainResource.node}"/>

<template:addCacheDependency  path="/gateway/startPoints/jahia-spaces-inbox"/>
<fmt:message key="docnt_docspaceSettings.gatewayAlias.issue" var="i18nAliasIssue"/>
<template:addResources type="inlinejavascript">
    <script type="text/javascript">
        $(document).ready(function () {
            $('#gatewayForm').submit(function (event) {
                event.preventDefault();

                $(this).append('<input type="hidden" name="form-token" value="' +
                        document.forms['tokenGatewayForm'].elements['form-token'].value + '"/>');

                $.post("<c:url value='${url.basePreview}${functions:escapePath(docspaceNode.path)}.configureGateway.do'/>", $(this).serialize(),
                    function (data) {
                        window.location.reload();
                    }, "json");
                return false;
            });

            $('#mailInboxTypeGmail,#mailInboxTypeOther').change(function () {
                $('#mailIndboxAdvanced').toggle('fast');
                return true;
            });
            <jcr:node var="startPoint" path="/gateway/startPoints/jahia-spaces-inbox"/>
            <c:if test="${not empty startPoint}">
            $.get("<c:url value='${url.basePreview}/gateway/startPoints/jahia-spaces-inbox.json'/>",
                function(data) {
                    var s = "([a-z0-9]+)://([a-z._-]+):?([0-9]*)\\?username=([a-zA-Z.@0-9]*)&amp;password=(.*)&amp;consumer\\.delay=([0-9]+)&amp;delete=(true|false)";
                    var re = new RegExp(s);
                    var m = re.exec(data.uri);
                    if (m != null) {
                        $("#mailProtocol").val(m[1]);
                        $("#mailHost").val(m[2]);
                        $("#mailPort").val(m[3]);
                        $("#mailDelay").val(m[6]/1000);
                        if(m[7] == "false") {
                            $("#mailDelete").click();
                        }
                        $("#mailUsername").val(m[4]);
                    }
                }, "json");
            </c:if>
        });
    </script>
</template:addResources>

<div class="modal-header">
    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
    <h3><fmt:message key="docnt_docspaceSettings.mailGateway"/></h3>
</div>

<template:tokenizedForm>
    <form id="tokenGatewayForm" method="post"
          action="<c:url value='${url.basePreview}${functions:escapePath(docspaceNode.path)}.configureGateway.do'/>">
    </form>
</template:tokenizedForm>

<form class="form-horizontal no-margin-bottom" id="gatewayForm" action="#" method="post">
    <div class="modal-body">
        <input type="hidden" name="jcrRedirectTo"
               value="<c:url value='${url.basePreview}${functions:escapePath(renderContext.mainResource.node.path)}'/>"/>
        <input type="hidden" name="jcrNewNodeOutputFormat" value="${renderContext.mainResource.template}.html"/>

        <p><fmt:message key="docnt_docspaceSettings.mailGateway.mailInbox.provideConfig"/></p>
        <div class="control-group">
            <div class="controls">
                <label for="mailInboxTypeGmail" class="radio">
                    <input type="radio" id="mailInboxTypeGmail" name="inboxType" value="gmail" checked="checked"/>
                    <fmt:message key="docnt_docspaceSettings.mailGateway.mailInbox.gmail"/>
                </label>

                <label for="mailInboxTypeOther" class="radio">
                    <input type="radio" id="mailInboxTypeOther" name="inboxType" value="other"/>
                    <fmt:message key="docnt_docspaceSettings.mailGateway.mailInbox.other"/>
                </label>

                <span id="help_typeOfMailBox" class="help-inline">
                    <fmt:message key="docnt_docspaceSettings.mailGateway.mailInbox.help"/>
                </span>
            </div>
        </div>

        <div id="mailIndboxAdvanced" class="hide">
            <div class="control-group">
                <label class="control-label" for="mailProtocol">
                    <fmt:message key="docnt_docspaceSettings.mailGateway.mailInbox.protocol"/>
                </label>
                <div class="controls">
                    <select id="mailProtocol" name="protocol">
                        <option value="imap" selected="selected">IMAP</option>
                        <option value="imaps">IMAPS (IMAP+SSL)</option>
                        <option value="pop3">POP3</option>
                        <option value="pop3s">POP3S (POP3+SSL)</option>
                    </select>
                    <span id="help_selectMailProtocol" class="help-inline hide">
                        <fmt:message key="docnt_docspaceSettings.mailGateway.mailInbox.protocol.help"/>
                    </span>
                </div>
            </div>

            <div class="control-group">
                <label class="control-label" for="mailHost">
                    <fmt:message key="docnt_docspaceSettings.mailGateway.mailInbox.host"/>
                </label>
                <div class="controls">
                    <input type="text" name="host" id="mailHost" value=""/>
                    <span id="help_selectMailHost" class="help-inline hide">
                        <fmt:message key="docnt_docspaceSettings.mailGateway.mailInbox.host.help"/>
                    </span>
                </div>
            </div>

            <div class="control-group">
                <label class="control-label" for="mailPort">
                    <fmt:message key="docnt_docspaceSettings.mailGateway.mailInbox.port"/>
                </label>
                <div class="controls">
                    <input type="text"  name="port" id="mailPort" value=""/>
                    <span id="help_selectMailPort" class="help-inline hide">
                        <fmt:message key="docnt_docspaceSettings.mailGateway.mailInbox.port.help"/>
                    </span>
                </div>
            </div>

            <div class="control-group">
                <label class="control-label" for="mailDelay">
                    <fmt:message key="docnt_docspaceSettings.mailGateway.mailInbox.delay"/>
                </label>
                <div class="controls">
                    <input type="text" name="delay" id="mailDelay" value="60"/>
                    <span id="help_selectMailDelay" class="help-inline hide">
                        <fmt:message key="docnt_docspaceSettings.mailGateway.mailInbox.delay.help"/>
                    </span>
                </div>
            </div>

            <div class="control-group">
                <div class="controls">
                    <label class="checkbox" for="mailDelete">
                        <input type="checkbox" name="delete" id="mailDelete" checked="checked"/>
                        <fmt:message key="docnt_docspaceSettings.mailGateway.mailInbox.delete"/>
                    </label>
                    <span id="help_selectMailDelete" class="help-inline hide">
                        <fmt:message key="docnt_docspaceSettings.mailGateway.mailInbox.delete.help"/>
                    </span>
                </div>
            </div>
        </div>

        <div class="control-group">
            <label class="control-label" for="mailUsername">
                <fmt:message key="wsf.label.username"/>
            </label>
            <div class="controls">
                <input type="text" name="username" id="mailUsername" value=""/>
                <span id="help_selectMailUsername" class="help-inline hide">
                    <fmt:message key="docnt_docspaceSettings.mailGateway.mailInbox.username.help"/>
                </span>
            </div>
        </div>

        <div class="control-group">
            <label class="control-label" for="mailPassword">
                <fmt:message key="wsf.label.password"/>
            </label>
            <div class="controls">
                <input type="password" name="password" id="mailPassword" value=""/>
                <span id="help_selectMailPassword" class="help-inline hide">
                    <fmt:message key="docnt_docspaceSettings.inboxManagement.mailInbox.password.help"/>
                </span>
            </div>
        </div>
    </div>

    <div class="modal-footer">
        <button type="button" class="btn" data-dismiss="modal" aria-hidden="true">
            <fmt:message key="wsf.label.cancel"/>
        </button>
        <button type="submit" class="btn btn-primary">
            <fmt:message key='wsf.label.submit'/>
        </button>
    </div>
</form>
