<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="s" uri="http://www.jahia.org/tags/search" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="f" uri="http://www.jahia.org/jstl/customFunctions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="javascript" resources="jquery.min.js"/>

<c:if test="${empty param['bindedComponent']}">
    <c:choose>
        <c:when test="${renderContext.ajaxRequest}">
            <c:set var="bindedComponent" value="${renderContext.ajaxResource.node}"/>
        </c:when>
        <c:otherwise>
            <c:set var="bindedComponent"
                   value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>
        </c:otherwise>
    </c:choose>

</c:if>
<%--Collect all available tags--%>
<c:set var="tags" value=""/>
<query:definition var="listQuery" statement="select * from [jmix:tagged] as n where isdescendantnode('${functions:sqlencode(bindedComponent.path)}')"/>
<jcr:jqom var="result" qomBeanName="listQuery"/>
<c:forEach items="${result.nodes}" var="node" varStatus="outerLoop">
    <c:if test="${jcr:isNodeType(node, 'jmix:tagged')}">
        <c:set var="tagList" value="${node.properties['j:tagList']}"/>
        <c:forEach items="${tagList}" var="tag" varStatus="innerLoop">
            <c:choose>
                <%--This does not work as expected and will have to be investigated--%>
                <c:when test="${outerLoop.first and innerLoop.first}">
                    <c:set var="tags" value="${tag.string}" />
                </c:when>
                <c:when test="${outerLoop.last and innerLoop.last}">
                    <c:set var="tags" value="${tags}, ${tag.string}" />
                </c:when>
                <c:otherwise>
                    <c:set var="tags" value="${tags}, ${tag.string}" />
                </c:otherwise>
            </c:choose>
        </c:forEach>
    </c:if>
</c:forEach>

<c:set var="tags" value="${fn:split(tags, ',')}"/>
<%--Remove duplicates and empties--%>
<c:set var="tgs" value="${f:removeDuplicates(tags)}"/>

<c:if test="${fn:length(tgs) > 0}">
    <hr/>
    <div class="row-fluid">
       <h5><fmt:message key="docnt_libraryTagFilter.heading" /></h5>
        <div class="span12">
            <c:forEach items="${tgs}" var="tag">
                <c:if test="${not empty tag}">
                    <span class="searchableTag label label-info" id="${fn:escapeXml(tag)}_${currentNode.identifier}">
                            ${fn:escapeXml(fn:trim(tag))}
                    </span>
                </c:if>
            </c:forEach>
        </div>
    </div>

    <script type="text/javascript">
        $(document).ready(function() {
            $(".searchableTag")
                .css({"cursor" : "pointer"})
                .on("click", function() {
                    if ($(this).hasClass("label-info")) {
                        $(this).removeClass("label-info");
                        $(this).addClass("label-success searchableTagActive");
                    }
                    else {
                        $(this).removeClass("label-success searchableTagActive");
                        $(this).addClass("label-info");
                    }
                    var params = "";
                    $(".searchableTagActive").each(function(i) {
                        if (i == 0)
                            params += "?tags=" + encodeURIComponent($(this).html().trim());
                        else
                            params += "," + encodeURIComponent($(this).html().trim());
                    });

                    $.ajax({
                        url: '${url.context}${url.base}${functions:escapePath(bindedComponent.path)}.hidden.datatable.html.ajax' + params,
                        type: "GET",
                        success: function(result) {
                            var data = JSON.parse(result).data;
                            <c:choose>
                                <c:when test="${jcr:isNodeType(bindedComponent, 'docnt:notesContainer')}">
                                    notesViewDatatable.clear().rows.add(data);
                                    notesViewDatatable.draw();
                                </c:when>
                                <c:otherwise>
                                    libraryViewDatatable.clear().rows.add(data);
                                    libraryViewDatatable.draw();
                                </c:otherwise>
                            </c:choose>
                            //Add listeners (Could be set to body in docspaceActions!!!)
                            $('.fileCheckbox').change(function () {
                                var checkedLength = $("input:checkbox[class=fileCheckbox]:checked").length;
                                var length = $(".fileCheckbox").length;
                                if(checkedLength == length){
                                    $('.allFileCheckbox').prop("checked", true);
                                }else {
                                    $('.allFileCheckbox').prop("checked", false);
                                }
                                fileCheckBoxChecked();
                            });

                            $('.allFileCheckbox').click(function() {
                                var state = this.checked;
                                var fileCheckboxes = $('.fileCheckbox');
                                $.each(fileCheckboxes, function(idx, val,f) {
                                    this.checked = state;
                                    if(idx == fileCheckboxes.length - 1)
                                        fileCheckBoxChecked();
                                });
                            });
                        }
                    });
            });
        });
    </script>
</c:if>