<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootbox.min.js"/>

<template:addResources>
    <script type="text/javascript">
        function removeLink(url) {
            bootbox.confirm(wsfi18n['docnt_LinkedResource.confirmUnlink'], function(result) {
                if (result) {
                    $.ajax({
                        type: 'DELETE',
                        url: url,
                        dataType: 'json',
                        success: function () {
                            location.reload(true);
                        }
                    });
                }
            });
        }
    </script>
</template:addResources>

<c:set var="boundComponent"
    value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>
<template:include view="hidden.header"/>

<c:forEach items="${moduleMap.currentList}" var="subchild" begin="${moduleMap.begin}" end="${moduleMap.end}" varStatus="status">
    <c:if test="${status.first}">
        <ul class="unstyled">
    </c:if>
    <c:choose>
        <c:when test="${boundComponent.identifier eq subchild.properties.source.string}">
            <c:set var="linkedNodeId" value="${subchild.properties.target.string}"/>
        </c:when>
        <c:otherwise>
            <c:set var="linkedNodeId" value="${subchild.properties.source.string}"/>
        </c:otherwise>
    </c:choose>
    <c:if test="${not empty linkedNodeId}">
        <jcr:node var="linkedNode" uuid="${linkedNodeId}" />
    </c:if>
    <c:if test="${not empty linkedNode}">
        <li>
            <div class="row-fluid">
            <c:choose>
                <c:when test="${jcr:isNodeType(linkedNode, 'jnt:file')}">
                    <template:module node="${linkedNode}" view="faiconspan" templateType="html"/>
                    <a href="<c:url value='${url.base}${functions:escapePath(linkedNode.path)}.workspace-document-details.html'/>"
                       title="${linkedNode.name}">${functions:abbreviate(functions:default(fn:trim(linkedNode.displayableName), linkedNode.name),30,40,'...')}</a>
                </c:when>
                <c:when test="${jcr:isNodeType(linkedNode, 'docnt:note')}">
                    <span class="fa fa-file-text-o"></span>
                    <a href="<c:url value='${url.base}${functions:escapePath(linkedNode.path)}.workspace-note-details.html'/>"
                       title="${linkedNode.name}">${functions:abbreviate(functions:default(fn:trim(linkedNode.displayableName), linkedNode.name),30,40,'...')}</a>
                </c:when>
                <c:when test="${jcr:isNodeType(linkedNode, 'jnt:topic')}">
                    <span class="fa fa-comment-o"></span>
                    <a href="<c:url value='${url.base}${functions:escapePath(linkedNode.path)}.html'/>"
                       title="${linkedNode.name}">${functions:abbreviate(functions:default(fn:trim(linkedNode.displayableName), linkedNode.name),30,40,'...')}</a>
                </c:when>
                <c:when test="${jcr:isNodeType(linkedNode, 'jnt:wikiPage')}">
                    <span class="fa fa-university"></span>
                    <a href="<c:url value='${url.base}${functions:escapePath(linkedNode.path)}.html'/>"
                       title="${linkedNode.name}">${functions:abbreviate(functions:default(fn:trim(linkedNode.displayableName), linkedNode.name),30,40,'...')}</a>
                </c:when>
                <c:when test="${jcr:isNodeType(linkedNode, 'jnt:poll')}">
                    <template:module path="${linkedNode.path}" view="docspace"/>
                </c:when>
            </c:choose>
            </div>
            <c:if test="${jcr:hasPermission(subchild,'jcr:write_default')}">
            <c:url var="unlinkUrl" value="${url.base}${functions:escapePath(subchild.path)}"/>
                <div class="row-fluid">
                    <a href="#" title="<fmt:message key="docnt_LinkedResource.unlink"/>" onclick="removeLink('${unlinkUrl}')"><i
                            class="fa fa-minus-circle pull-right"></i></a>
                </div>
            <br/>
			</c:if>
        </li>
    </c:if>
    <c:if test="${status.last}"></ul></c:if>
</c:forEach>

<template:include view="hidden.footer"/>
