<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="ui" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<jsp:useBean id="date" class="java.util.Date" scope="page"/>
<%--Go back in time 183 days--%>
<jsp:setProperty name="date" property="time" value="${date.time - 15768000000}" />
<fmt:formatDate pattern="yyyy-MM-dd'T'HH:mm:ss.SSSZZ" value="${date}" var="d"/>
<%--Proper iso8601 format - because the above does not include ":" in the string--%>
<c:set var="properDate" value="${fn:substring(d, 0, 26)}:${fn:substring(d, 26, fn:length(d))}" />

<c:choose>
    <c:when test="${currentNode.properties['type'].string eq 'created'}">
        <query:definition var="listQuery" limit="100"
                          statement="select * from [docmix:docspaceDocument] where ([jcr:createdBy] = '${functions:sqlencode(renderContext.user.name)}' and [jcr:created] >= cast('${properDate}' as date)) order by [jcr:lastModified] desc"/>
        <c:set target="${moduleMap}" property="editable" value="false"/>
        <c:set target="${moduleMap}" property="listQuery" value="${listQuery}"/>    </c:when>
    <c:when test="${currentNode.properties['type'].string eq 'modified'}">
        <query:definition var="listQuery" limit="100"
                          statement="select * from [docmix:docspaceDocument] where ([jcr:lastModifiedBy] = '${functions:sqlencode(renderContext.user.name)}' and [jcr:lastModified] >= cast('${properDate}' as date)) order by [jcr:lastModified] desc"/>
        <c:set target="${moduleMap}" property="editable" value="false"/>
        <c:set target="${moduleMap}" property="listQuery" value="${listQuery}"/>    </c:when>
    <c:when test="${currentNode.properties['type'].string eq 'locked'}">
        <query:definition var="listQuery" limit="100"
                          statement="select * from [docmix:docspaceDocument] where ([j:lockTypes] = '${functions:sqlencode(renderContext.user.name)}:docspace' and [jcr:lastModified] >= cast('${properDate}' as date)) order by [jcr:lastModified] desc"/>
        <c:set target="${moduleMap}" property="editable" value="false"/>
        <c:set target="${moduleMap}" property="listQuery" value="${listQuery}"/>
    </c:when>
</c:choose>
<c:set target="${moduleMap}" property="subNodesView" value="docspace-link"/>

