<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<template:addResources type="css" resources="jquery-ui.smoothness.css,jquery-ui.smoothness-jahia.css"/>
<template:addResources type="javascript" resources="jquery.min.js,jquery-ui.min.js"/>
<template:addResources type="javascript" resources="ajaxreplace.js"/>
<template:addResources type="javascript" resources="ckeditor/ckeditor.js"/>
<template:addResources type="javascript" resources="ckeditor/adapters/jquery.js"/>
<c:set var="formid" value="noteForm${currentNode.identifier}"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function () {
            $(".newContentCkeditorContribute${currentNode.identifier}docnt_note").each(function () {
                $(this).ckeditor(function () {
                }, {
                    toolbar_Note : [
                        ['Source'],
                        ['Bold','Italic','Underline','Strike'],
                        ['NumberedList','BulletedList','-','Blockquote'],
                        ['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'],
                        ['Link','Unlink'],
                        ['Table'],
                        ['Format'],
                        ['TextColor','BGColor']
                    ],
                    toolbar : 'Note', filebrowserBrowseUrl: null, filebrowserFlashBrowseUrl: null, filebrowserImageBrowseUrl: null, filebrowserLinkBrowseUrl: null
                });
                $(this).data('ckeditorInstance').checkWCAGCompliance = (typeof wcagCompliant) === 'function' ? wcagCompliant : null;
            });


            $("#${formid}").validate({
                rules: {
                    'jcr:title': 'required'
                },
                'messages':{
                    'jcr:title': wsfi18n['wsf.label.noTitle']
                },
                errorClass: 'text-error',
                submitHandler: function(form) {
                    $.post($(form).attr('action'), $(form).serialize(), function(result) {
                        showLoading(wsfi18n['wsf.title.workInProgress']);
                        location.replace("<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}'/>/" + result.j_nodename + ".workspace-note-details.html");
                    }, "json");
                }
            });

            $("#cancel${currentNode.name}").click(function(){
                location.replace("<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}.workspace-notes.html'/>");
            });

        });
    </script>
</template:addResources>

<template:tokenizedForm>
    <form method="post" class="form-horizontal"
          action="<c:url value='${url.base}${functions:escapePath(currentNode.path)}/*'/>"
          id="${formid}">
        <input type="hidden" name="jcrNodeType" value="docnt:note">
        <input type="hidden" name="jcrMethodToCall" value="post"/>

        <div class="control-group">
            <label class="control-label" for="title"><fmt:message key="wsf.label.title"/></label>

            <div class="controls">
                <input type="text" name="jcr:title" id="title" class="field"
                       value="${currentNode.properties['jcr:title'].string}" />
            </div>
        </div>

        <div class="control-group">
            <label class="control-label" for="editContent_${currentNode.identifier}"><fmt:message key="docnt_note.body"/></label>

            <div class="controls">
            <textarea name="body" id="editContent_${currentNode.identifier}"
                      class="newContentCkeditorContribute${currentNode.identifier}docnt_note" cols="45" rows="3">${currentNode.properties['body'].string}</textarea>
            </div>
        </div>

        <div class="control-group">
            <div class="controls">
                <button type="submit" class="btn btn-primary">
                    <fmt:message key="wsf.label.ok"/>
                </button>
                <button type="button" class="btn" id="cancel${currentNode.name}">
                    <fmt:message key="wsf.label.cancel"/>
                </button>
            </div>
        </div>
    </form>
</template:tokenizedForm>