<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="workflow" uri="http://www.jahia.org/tags/workflow" %>
<%@ taglib prefix="s" uri="http://www.jahia.org/tags/search" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="files.css"/>
<template:addResources type="css" resources="vendor/datatables/dataTables.responsive.css"/>
<template:addResources type="css" resources="vendor/datatables/dataTables.bootstrap.css"/>
<%--<template:addResources type="css" resources="vendor/datatables/dataTables-themescroller.css"/>--%>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="vendor/datatables/dataTables.js"/>
<template:addResources type="javascript" resources="vendor/datatables/dataTables.responsive.js"/>
<template:addResources type="javascript" resources="vendor/datatables/dataTables.bootstrap.js"/>
<template:addResources type="javascript" resources="vendor/datatables/dataTables.scroller.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>

<template:include view="hidden.header"/>

<template:addResources type="inlinejavascript">
    <script type="text/javascript">
        $(document).ready(function () {

            refreshMoment();
            refreshMomentEvery(60000);

            $(".checkAll").click(function () {
                $(".fileCheckbox").each(function (index) {
                    if ($(".checkAll").attr("checked") == "checked") {
                        $(this).attr("checked", "checked");
                    } else {
                        $(this).removeAttr("checked");
                    }
                });
                fileCheckBoxChecked();
            });

            notesViewDatatable = $('#noteListTable').DataTable({
                dom             : "frtiS",
                "scrollY"       : "400px",
                "scrollCollapse": true,
                "paging"        : true,
                responsive      : {details: false},
                order           : [[3, 'desc']],
                "language"      : {
                    "emptyTable": wsfi18n['docnt_notesContainer.noNotesAvailable']
                },
                columnDefs      : [
                    {
                        targets   : 0,
                        searchable: false,
                        orderable : false,
                        render    : function (data, type, full, meta) {
                            return '<input class="' + data.css + '" type="checkbox" name="' + data.identifier + '" path="' + data.path + '" alt="' + data.fullName + '"/>';
                        }
                    },
                    {
                        targets   : 1,
                        searchable: true,
                        orderable : true,
                        render    : function (data, type, full, meta) {
                            var urlBase   = "<c:url value='${url.base}'/>";
                            var rendering = "";
                            if (data.locked == "true") {
                                rendering = '<span class="icon-lock' + (data.archived ? "-archive" : "") + '"></span>&nbsp;'
                            }
                            return rendering + '<a href="' + urlBase + data.path + '.workspace-note-details.html" title="' + data.fullName + '">' + data.fullName + '</a>';
                        }
                    },
                    {
                        targets   : 2,
                        searchable: true,
                        orderable : true,
                        type      : "date",
                        render    : function (data, type, full, meta) {
                            if (type == "display") {
                                return '<span class="momentToFormat" data-moment-display-type="format" data-moment-format="LL" data-moment-locale="${renderContext.mainResourceLocale}" data-moment="' + data + '">' + moment(data).fromNow() + '</span>'
                            }
                            return data;
                        }
                    },
                    {
                        targets   : 3,
                        searchable: true,
                        orderable : true,
                        type      : "date",
                        render    : function (data, type, full, meta) {
                            if (type == "display") {
                                return '<span class="momentToFormat" data-moment-display-type="fromNow" data-moment-locale="${renderContext.mainResourceLocale}" data-moment="' + data + '">' + moment(data).fromNow() + '</span>'
                            }
                            return data;
                        }
                    }
                ],
                drawCallback    : function () {
                    parseFileCheckboxes();
                    if (this[0].rows.length > 100) {
                        $(".checkAll").prop("checked", false);
                        $(".fileCheckbox").prop("checked", false);
                        $(".checkAll").hide();
                    }
                    else {
                        $(".checkAll").prop("checked", false);
                        $(".fileCheckbox").prop("checked", false);
                        $(".checkAll").show();
                    }
                    fileCheckBoxChecked();
                },
                initComplete    : function (settings, json) {
                    refreshMoment();
                },
                data            :<template:include templateType="json" view="datatable"></template:include>.data
        });
        })
        ;
    </script>
</template:addResources>
<br/>
<c:if test="${not empty param.collection}">
    <h3>
        <jcr:node var="collectionNode" uuid="${param.collection}"/>
            ${collectionNode.displayableName}
        <fmt:message key="wsf.label.in"/>
            ${renderContext.mainResource.node.parent.properties['jcr:title'].string}
    </h3>
</c:if>

<div id="documentList${currentNode.identifier}" class="row-fluid">
    <table class="table table-hover" summary="Note List Table"
           id="noteListTable">
        <thead>
        <tr>
            <th class="span1 min-tablet-l" id="Select" scope="col">
                <input type="checkbox" class="allFileCheckbox checkAll"/>
            </th>
            <th class="span3 all" id="Title" scope="col">
                <fmt:message key="wsf.label.title"/>
            </th>
            <th class="span2 min-tablet-l" id="Creation" scope="col">
                <fmt:message key="wsf.label.created"/>
            </th>
            <th class="span2 all" id="LastModif" scope="col">
                <fmt:message key="wsf.label.lastModification"/>
            </th>
            <th class="span1 min-tablet-l" id="Author" scope="col">
                <fmt:message key="wsf.label.author"/>
            </th>
        </tr>
        </thead>
        <tbody></tbody>
    </table>
    <template:include view="hidden.footer">
        <template:param name="searchUrl" value="${url.current}"/>
    </template:include>
</div>