<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="workflow" uri="http://www.jahia.org/tags/workflow" %>
<%@ taglib prefix="s" uri="http://www.jahia.org/tags/search" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="files.css"/>
<template:addResources type="css" resources="poll.css"/>
<template:addResources type="css" resources="vendor/datatables/dataTables.bootstrap.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="poll.js"/>
<template:addResources type="javascript" resources="vendor/datatables/dataTables.js"/>
<template:addResources type="javascript" resources="vendor/datatables/dataTables.bootstrap.js"/>
<template:addResources type="javascript" resources="vendor/datatables/dataTables.scroller.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>


<template:include view="hidden.header"/>
<script type="text/javascript">
    var SimpleAccordion = {
        previousElement     : [],
        processClick        : true,
        init                : function () {
            var self = this;
            $(".simpleAccordion").on("click", function () {
                if (self.processClick)
                    self.addSelectionAndClose($(this).attr("id"));
            });
        },
        addSelectionAndClose: function (id) {
            if (this.previousElement.length > 0 && this.previousElement[0] == id) {
                this.previousElement.pop();
                return false;
            }

            var prev = this.previousElement.pop();

            if (prev) {
                this.processClick = false;
                document.getElementById(prev).click();
                this.processClick = true;
            }

            this.previousElement.push(id);

            return true;
        }
    };

    $(document).ready(function () {

        //Simulate accordion
        SimpleAccordion.init();

        $('#pollListTable${currentNode.identifier}').DataTable({
            "columnDefs"    : [
                {'sortable': false, searchable: false, 'targets': 0}
            ],
            order           : [[4, 'desc']],
            "scrollY"       : "400px",
            dom             : "frtiS",
            "paging"        : true,
            "scrollCollapse": false,
            "language"      : {
                "emptyTable": wsfi18n['docnt_pollsContainer.noPollsAvailable']
            },
            drawCallback    : function () {
                parseFileCheckboxes();
                if (this[0].rows.length > 100) {
                    $(".checkAll").prop("checked", false);
                    $(".fileCheckbox").prop("checked", false);
                    $(".checkAll").hide();
                }
                else {
                    $(".checkAll").prop("checked", false);
                    $(".fileCheckbox").prop("checked", false);
                    $(".checkAll").show();
                }
                fileCheckBoxChecked();
            },
            initComplete    : function (settings, json) {
                refreshMoment();
            }
        });
    });
</script>

<div id="documentList${currentNode.identifier}">
    <table width="100%" class="table table-hover" summary="Polls List Table"
           id="pollListTable${currentNode.identifier}">
        <caption class="hide">
        </caption>
        <thead>
        <tr>
            <th class="span1">
                <input class="allFileCheckbox checkAll" type="checkbox" id="allPollsSelector_${currentNode.identifier}">
            </th>
            <%--<th class="span1">--%>
            <%--<fmt:message key="wsf.label.type"/>--%>
            <%--</th>--%>
            <th class="span4">
                <fmt:message key="docnt_pollsContainer.question"/>
            </th>
            <th class="span1">
                <fmt:message key="docnt_pollsContainer.votes"/>
            </th>
            <th class="span2">
                <fmt:message key="wsf.label.created"/>
            </th>
            <th class="span2">
                <fmt:message key="docnt_pollsContainer.end"/>
            </th>
        </tr>
        </thead>
        <tbody>
        <c:choose>
            <c:when test="${moduleMap.resultsHits != null}">
                <s:resultIterator hits="${moduleMap.resultsHits}" begin="${moduleMap.begin}" end="${moduleMap.end}">
                    <c:set var="subchild" value="${hit.rawHit}"/>
                    <%@ include file="pollItem.jspf" %>
                </s:resultIterator>
            </c:when>
            <c:otherwise>
                <c:forEach items="${moduleMap.currentList}" var="subchild" begin="${moduleMap.begin}"
                           end="${moduleMap.end}">
                    <%@ include file="pollItem.jspf" %>
                </c:forEach>
            </c:otherwise>
        </c:choose>
        </tbody>
    </table>
    <template:include view="hidden.footer">
        <template:param name="searchUrl" value="${url.current}"/>
    </template:include>
</div>


