<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="s" uri="http://www.jahia.org/tags/search" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<c:choose>
    <c:when test="${!empty param.collection}">
        <c:choose>
            <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'docmix:docspace')}">
                <c:set var="docspaceNode" value="${renderContext.mainResource.node}"/>
            </c:when>
            <c:otherwise>
                <c:set var="docspaceNode"
                       value="${jcr:getParentOfType(renderContext.mainResource.node, 'docmix:docspace')}"/>
            </c:otherwise>
        </c:choose>
        <jcr:node var="collection" uuid="${param.collection}"/>
        <jsp:useBean id="collectionList" class="java.util.ArrayList" type="java.util.List"/>
        <c:forEach items="${jcr:getChildrenOfType(collection, 'docnt:noteReference')}" var="ref">
            <c:if test="${ fn:contains(ref.properties['j:node'].node.path,docspaceNode.path)}">
                <jcr:node uuid="${ref.properties['j:node'].string}" var="node"/>
                <% collectionList.add(pageContext.findAttribute("node")); %>
            </c:if>
        </c:forEach>
        <c:set target="${moduleMap}" property="currentList" value="${collectionList}"/>
        <c:set target="${moduleMap}" property="end" value="${fn:length(moduleMap.currentList)}"/>
        <c:set target="${moduleMap}" property="listTotalSize" value="${moduleMap.end}"/>
    </c:when>
    <c:when test="${jcr:isNodeType(currentNode,'docmix:docspaceObject') and not empty param['src_terms[0].term']}">
        <c:set var="hitsName" value="hits_${currentNode.identifier}"/>
        <c:set var="hitsCountName" value="hitsCount_${currentNode.identifier}"/>
        <c:choose>
            <c:when test='${searchMap[hitsName] eq null}'>
                <s:results var="resultsHits">
                    <c:set target="${moduleMap}" property="listTotalSize" value="${count}"/>
                    <c:set target="${moduleMap}" property="resultsHits" value="${resultsHits}"/>
                    <c:set target="${moduleMap}" property="displaySearchParams" value="true"/>
                    <c:if test='${searchMap == null}'>
                        <jsp:useBean id="searchMap" class="java.util.HashMap" scope="request"/>
                    </c:if>
                    <c:set target="${searchMap}" property="${hitsName}" value="${resultsHits}"/>
                    <c:set target="${searchMap}" property="${hitsCountName}" value="${count}"/>                   
                </s:results>
            </c:when>
            <c:otherwise>
                <c:set target="${moduleMap}" property="listTotalSize" value="${searchMap[hitsCountName]}" />
                <c:set target="${moduleMap}" property="resultsHits" value="${searchMap[hitsName]}" />
                <c:set target="${moduleMap}" property="displaySearchParams" value="true" />
            </c:otherwise>
        </c:choose>                    
    </c:when>
    <c:when test="${not empty param[facetParamVarName]}">
        <c:set var="descendantNode" value="${fn:substringAfter(currentNode.realNode.path,'/sites/')}"/>
        <c:set var="descendantNode" value="${fn:substringAfter(descendantNode,'/')}"/>
        <query:definition var="listQuery"
                          statement="select * from [docnt:note] where isdescendantnode('/sites/${functions:sqlencode(renderContext.site.name)}/${functions:sqlencode(descendantNode)}')"/>
        <c:set target="${moduleMap}" property="listQuery" value="${listQuery}"/>
    </c:when>

    <c:otherwise>
        <query:definition var="listQuery">
            <query:selector nodeTypeName="jnt:poll"/>
            <c:set var="descendantNode" value="${fn:substringAfter(currentNode.realNode.path,'/sites/')}"/>
            <c:set var="descendantNode" value="${fn:substringAfter(descendantNode,'/')}"/>
            <query:descendantNode path="/sites/${functions:sqlencode(renderContext.site.name)}/${functions:sqlencode(descendantNode)}"/>
            <query:sortBy propertyName="jcr:created" order="desc"/>
        </query:definition>
    </c:otherwise>
</c:choose>
<c:set target="${moduleMap}" property="listQuery" value="${listQuery}"/>
