<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="workflow" uri="http://www.jahia.org/tags/workflow" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="utils" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="ui" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<template:addResources type="css" resources="loading.css"/>
<template:addResources type="javascript" resources="loading.js"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function() {
            $("#submitChanges-${currentNode.identifier}").on("click", function(e) {
                e.preventDefault();
                var form = $("#serverNameChangeForm-${currentNode.identifier}");
                var formAction = form.attr("action");
                showLoading(wsfi18n['wsf.title.workInProgress']);
                $.ajax({
                    url: formAction,
                    type: "post",
                    data: form.serialize(),
                    dataType: "json",
                    success: function() {
                        window.location.reload();
                    },
                    error: function() {
                        console.log("Failed to update server name!");
                        hideLoading();
                    }
                });
            })
        });
    </script>
</template:addResources>

<c:set var="docspaceNode" value="${renderContext.mainResource.node}"/>
<c:set var="wsfaccess" value="${jcr:getParentOfType(docspaceNode, 'jmix:accessControlled')}" />

<div class="modal-header">
    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
    <h3><fmt:message key="docnt_serverNameUpdate.title.updateServerName"/></h3>
</div>

<div class="modal-body">
    <form class="form-horizontal" id="serverNameChangeForm-${currentNode.identifier}"
          action="<c:url value='${url.basePreview}${functions:escapePath(docspaceNode.path)}.changeServerName.do'/>"
          method="POST">
        <div class="control-group">
            <label class="control-label"><fmt:message key="docnt_serverNameUpdate.prompt.enterNewName"/></label>

            <div class="controls">
                <div class="input-append">
                    <input name="newServerName" type="text" value="${wsfaccess.properties['j:serverName'].string}"/>
                </div>
            </div>
        </div>
    </form>
</div>
<div class="modal-footer">
    <button type="button" class="btn" data-dismiss="modal" aria-hidden="true">
        <fmt:message key="wsf.label.cancel"/>
    </button>
    <button type="button" class="btn btn-primary" id="submitChanges-${currentNode.identifier}">
        <fmt:message key="wsf.label.submit"/>
    </button>
</div>