$.ajaxSetup({traditional: true, cache: false});
var richTextEditors = {};
var contributionI18n = {
    'ok': 'OK',
    'cancel': 'Cancel',
    'invalidconstraint': 'There are some validation errors! Correct the input and save again',
    'edit': 'Click to edit',
    'uploaded': 'file uploaded click on preview to see the new file',
    'error': 'an error occurred, please check the file you try to upload',
    'wcag.close': 'Close',
    'wcag.context': 'Context',
    'wcag.description': 'Description',
    'wcag.error': 'Error',
    'wcag.example': 'Example',
    'wcag.ignore': 'Ignore error(s)',
    'wcag.information': 'Information',
    'wcag.ok': 'WCAG Compliance: OK',
    'wcag.warning': 'Warning'
};

var lockedPath = {};

$(window).unload(function () {
    $.each(lockedPath, function (key, value) {
        if (value = 'locked') {
            $.ajax({
                type: 'POST',
                async: false,
                url: key + '.unlock.do',
                data: {type: 'contribute'}
            });
        }
    });
});

function errorOnSave(thisField) {
    return function (jqXHR, textStatus, errorThrown) {
        alert(contributionI18n['invalidconstraint']);
        thisField.editing = true;
        thisField.reset();
    }
}

function initEditFields(id, escapeTextValue, callback) {
    $(".edit" + id).editable(function (value, settings) {
        var self = this;
        var data;
        var initData = $(this).attr('init:data');
        if (initData != null) {
            data = $.parseJSON(initData);
        }
        if (data == null) {
            data = {};
        }
        data['jcrMethodToCall'] = 'put';
        var submitId = $(this).attr('jcr:id');
        data[submitId] = value;
        var thisField = this;
        $.ajax({
            type: 'POST',
            url: $(this).attr('jcr:url'),
            data: data,
            dataType: "json",
            error: errorOnSave(thisField),
            traditional: true
        }).done(function () {
            if (callback != null) {
                callback(submitId);
            }
            if ($(self).attr("jcr:id") == "jcr:title") {
                showLoading(wsfi18n['wsf.title.workInProgress']);
                window.location.reload();
            }
        });

        return escapeTextValue ? $('<div/>').text(value).html() : value;
    }, {
        type: 'text',
        onblur: 'ignore',
        submit: '<button type="submit" class="btn btn-primary">' + contributionI18n['ok'] + '</button>',
        cancel: '<button type="cancel" class="btn btn-danger">' + contributionI18n['cancel'] + '</button>',
        tooltip: contributionI18n['edit'],
        placeholder: contributionI18n['edit']
    });

    $(".ckeditorEdit" + id).editable(function (value, settings) {
        var data;
        var initData = $(this).attr('init:data');
        if (initData != null) {
            data = $.parseJSON(initData);
        }
        if (data == null) {
            data = {};
        }
        data['jcrMethodToCall'] = 'put';
        var submitId = $(this).attr('jcr:id');
        data[submitId] = value;
        var thisField = this;
        $.ajax({
            type: 'POST',
            url: $(this).attr('jcr:url'),
            data: data,
            dataType: "json",
            error: errorOnSave(thisField),
            traditional: true
        }).done(function () {
            if (callback != null) {
                callback(submitId);
            }
        });

        return (value);
    }, {
        type: 'ckeditor',
        onblur: 'ignore',
        submit: '<button type="submit" class="btn btn-primary">' + contributionI18n['ok'] + '</button>',
        cancel: '<button type="cancel" class="btn btn-danger">' + contributionI18n['cancel'] + '</button>',
        tooltip: contributionI18n['edit'],
        placeholder: contributionI18n['edit'],
        ckeditorToolbar: $(".ckeditorEdit" + id).attr('jcr:ckeditorToolbar'),
        onreset: function (settings, original) {
            $('#wcag-' + $(original).attr('id') + '_ckeditor').remove();
            return true;
        },
        onsubmit: function (settings, original) {
            return wcagCompliant($(original).attr('id') + '_ckeditor', original);
        }
    });
}

function wcagCompliant(id, richTextElement, userTriggered) {
    var ctx = typeof contextJsParameters != 'undefined' ? contextJsParameters.contextPath : '';
    if (!userTriggered) {
        var wcag = typeof contextJsParameters != 'undefined' ? contextJsParameters.wcag : false;
        if (!wcag) {
            return true;
        }
    }
    var wcagOk = false;
    if (CKEDITOR.instances[id] != null) {
        $.ajax({
            async: false,
            type: 'POST',
            url: ctx + '/cms/wcag/validate',
            data: {'text': CKEDITOR.instances[id].getData()},
            error: function (xhr, textStatus, errorThrown) {
                wcagOk = true;
            },
            success: function (data, textStatus) {
                var ignore = $('#wcag-ignore-' + id);
                if ((userTriggered || ignore.length == 0 || ignore.attr('checked') == false) && (data.errors.length + data.warnings.length + data.infos.length > 0)) {
                    if (ignore.length > 0) {
                        $('#wcag-' + id).remove();
                    }
                    var myDiv = $('<div class="wcag-warnings" id="wcag-' + id + '">' +
                    '<div class="wcag-warnings-ignore"><input type="checkbox" id="wcag-ignore-' + id + '" value="true" name="ignore"/>&nbsp;<label for="wcag-ignore-' + id + '">' + (userTriggered ? contributionI18n['wcag.close'] : contributionI18n['wcag.ignore']) + '</label></div>' +
                    '<table class="table" width="100%" border="1" cellpadding="0" cellspacing="3">' +
                    '<thead><tr><th width="5%">#</th><th width="5%"> </th><th width="75%">' +
                    contributionI18n['wcag.description'] + '</th>' +
                        /*
                         '<th width="10%">' + contributionI18n['wcag.context'] + '</th>' +
                         */
                    '<th width="10%">' + contributionI18n['wcag.example'] + '</th></tr></thead>' +
                    '<tbody id="wcag-violations-' + id + '">' +
                    '</tbody>' +
                    '</table>' +
                    '</div>');
                    $(richTextElement).before(myDiv);
                    if (userTriggered) {
                        $('#wcag-ignore-' + id).click(function () {
                            $('#wcag-' + id).remove();
                        })
                    }
                    var placeholder = $('#wcag-violations-' + id);
                    var count = 0;
                    $.each($.merge([], $.merge($.merge([], data.errors), data.warnings), data.infos), function (index, violation) {
                        var violationType = violation.type.toLowerCase();
                        var row = '<tr><td align="center">' + (++count) + '</td>';
                        row = row + '<td align="center"><img src="' + ctx + '/modules/default/images/icons/' +
                        violationType + '.png" height="16" width="16" alt="' + contributionI18n['wcag.' + violationType] + '"' +
                        ' title="' + contributionI18n['wcag.' + violationType] + '"/></td>';
                        row = row + '<td>' + violation.message + '</td>';
                        /*
                         row = row + '<td align="center">' +
                         '<a href="#wcag-context-' + id + '-' + count + '" class="wcag-context">' +
                         '<img src="' + ctx + '/modules/default/images/icons/about.png" height="16" width="16" alt="' + contributionI18n['wcag.context'] + '"' +
                         ' title="' + contributionI18n['wcag.context'] + '"/></a>' +
                         '<div style="display:none"><div id="wcag-context-' + id + '-' + count + '">' + 'ctx' + '</div></div>' +
                         '</td>';
                         */

                        row = row + '<td align="center">' + violation.example + '</td></tr>';
                        placeholder.append($(row));
                    });
                    $('a.wcag-context').fancybox({
                        'titleShow': false,
                        'autoDimensions': false,
                        'width': 500,
                        'height': 300
                    });
                    wcagOk = false;
                } else {
                    wcagOk = true;
                    $('#wcag-' + id).remove();
                    if (userTriggered && (data.errors.length + data.warnings.length + data.infos.length == 0)) {
                        alert(contributionI18n['wcag.ok']);
                    }
                }
            },
            dataType: 'json'
        });
    } else {
        wcagOk = true;
    }
    return wcagOk;
}

function checkWCAGCompliace(richTexts) {
    var wcagOk = true;
    $.each(richTexts, function (index, richTextElement) {
        if (!wcagCompliant($(richTextElement).attr('id'), richTextElement)) {
            wcagOk = false;
            return false;
        }
        return true;
    });

    return wcagOk;
}
