<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootbox.min.js"/>
<template:addResources type="javascript" resources="ckeditor/ckeditor.js"/>
<template:addResources type="javascript" resources="ckeditor/adapters/jquery.js"/>

<jcr:nodeProperty node="${renderContext.mainResource.node}" name="jcr:title" var="title"/>
<jcr:nodeProperty node="${renderContext.mainResource.node}" name="text" var="text"/>
<jcr:nodeProperty node="${renderContext.mainResource.node}" name="jcr:createdBy" var="createdBy"/>
<jcr:nodeProperty node="${renderContext.mainResource.node}" name="jcr:created" var="created"/>

<script type="text/javascript">
    var initValue;

    $(document).ready(function(){
        refreshMoment();

        $('#editBlogContent_${currentNode.identifier}').ckeditor(function () {
        }, {
            toolbar_Blog : [
                ['Source'],
                ['Bold','Italic','Underline','Strike'],
                ['NumberedList','BulletedList','-','Blockquote'],
                ['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'],
                ['Link','Unlink','Image'],
                ['Table'],
                ['Format'],
                ['TextColor','BGColor']
            ],
            toolbar : 'Blog'
        });
        $('#editBlogContent_${currentNode.identifier}').data('ckeditorInstance').checkWCAGCompliance = (typeof wcagCompliant) === 'function' ? wcagCompliant : null;

        initValue = CKEDITOR.instances['editBlogContent_${currentNode.identifier}'].getData();
    });

    function confirmCancelEdit() {
        if (CKEDITOR.instances['editBlogContent_${currentNode.identifier}'].getData() !== initValue || $('#editBlogEntryTitle').val() !== '${functions:escapeJavaScript(title.string)}') {
            bootbox.confirm(wsfi18n['jnt_blogEntryFormCreate.docspace.cancelConfirm'], function(result) {
                if (result) {
                    window.location = '<c:url value="/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(renderContext.mainResource.node.path)}.html"/>';
                }
            });
        } else {
            window.location = '<c:url value="/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(renderContext.mainResource.node.path)}.html"/>';
        }
    }

    function validateEditBlog() {
        if ($('#editBlogEntryTitle').val() == '') {
            bootbox.alert(wsfi18n['jnt_blogEntryFormCreate.docspace.pleaseProvideTitle']);
            return false;
        }
    }
</script>

<template:tokenizedForm>
    <form id="formPost" method="post" action="<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}/'/>" name="blogPost">
        <input type="hidden" name="jcrAutoCheckin" value="true">
        <input type="hidden" name="jcrRedirectTo" value="<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}'/>"/>
        <input type="hidden" name="jcrMethodToCall" value="put">
        <input type="hidden" name="jcrNewNodeOutputFormat" value="html"/>
        <input type="hidden" name="jcrNodeType" value="jnt:blogPost">
        <fieldset>
            <legend><fmt:message key="wsf.label.by"/>&nbsp;${createdBy.string}
                &nbsp;-&nbsp;<span class="momentToFormat" data-moment-display-type="format" data-moment-format="LL"
                                   data-moment-locale="${currentResource.locale}"
                                   data-moment="<fmt:formatDate value="${created.time}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span>
            </legend>

            <div class="control-group">
                <label class="control-label" for="editBlogEntryTitle">
                    <fmt:message key="wsf.label.title"/>
                </label>
                <div class="controls">
                    <input id="editBlogEntryTitle" class="input-block-level" type="text" value="<c:out value='${title.string}'/>" name="jcr:title"/>
                </div>
            </div>

            <div class="control-group">
                <label class="control-label" for="editBlogContent_${currentNode.identifier}">
                    <fmt:message key="jnt_blogEntryFormCreate.docspace.post"/>
                </label>
                <div class="controls">
                    <textarea name="text" rows="10" cols="70" id="editBlogContent_${currentNode.identifier}">${fn:escapeXml(text.string)}</textarea>
                </div>
            </div>
        </fieldset>

        <div class="control-group">
            <div class="controls">
                <button type="submit" class="btn btn-primary" onclick="validateEditBlog()">
                    <fmt:message key="wsf.label.save"/>
                </button>
                <button type="button" class="btn btn-danger" onclick="confirmCancelEdit()">
                    <fmt:message key="wsf.label.cancel"/>
                </button>
            </div>
        </div>
    </form>
</template:tokenizedForm>