<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="blog.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootbox.min.js"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function(){
            refreshMoment();
        });
    </script>
</template:addResources>
	
<jcr:nodeProperty node="${currentNode}" name="jcr:title" var="title"/>
<jcr:nodeProperty node="${currentNode}" name="text" var="text"/>
<jcr:nodeProperty node="${currentNode}" name="jcr:createdBy" var="createdBy"/>
<jcr:nodeProperty node="${currentNode}" name="jcr:created" var="created"/>
	
<c:set var="currentUser" value="${user:lookupUser(createdBy.string)}"/>

<c:if test="${jcr:isNodeType(currentNode, 'jnt:blogPost')}">
    <c:set var="blogHome" value="${url.base}${currentResource.node.parent.path}.html"/>
</c:if>
<c:if test="${!jcr:isNodeType(currentNode, 'jnt:blogPost')}">
    <c:set var="blogHome" value="${url.current}"/>
</c:if>

<c:set var="canDelete" value="${jcr:hasPermission(currentNode,'deleteBlogEntry')}"/>
<c:set var="canEdit" value="${jcr:hasPermission(currentNode,'editBlogEntry')}"/>

<c:if test="${canDelete}">
    <template:addResources>
        <script type="text/javascript">
            function confirmDeleteBlogPost() {
                bootbox.confirm(wsfi18n['jnt_blogPost.docspace.deleteBlogPost'], function(result) {
                    if (result) {
                        $('#jahia-blog-article-delete_${currentNode.identifier}').submit();
                    }
                });
            }
        </script>
    </template:addResources>
    <template:tokenizedForm>
    <form action="<c:url value='${url.base}${functions:escapePath(currentNode.path)}'/>" method="post"
          id="jahia-blog-article-delete_${currentNode.identifier}">
        <input type="hidden" name="jcrRedirectTo" value="<c:url value='${url.base}${functions:escapePath(jcr:getParentOfType(renderContext.mainResource.node, "jnt:page").path)}'/>"/>
        <input type="hidden" name="jcrNewNodeOutputFormat" value="html"/>
        <input type="hidden" name="jcrMethodToCall" value="delete"/>
    </form>
    </template:tokenizedForm>
</c:if>

<div>
    <c:if test="${canEdit or canDelete}">
        <span class="posteditdelete">
            <c:if test="${canDelete}">
                <button class="btn btn-danger btn-mini" title="<fmt:message key="wsf.label.delete"/>"
                        type="button" onclick="confirmDeleteBlogPost()">
                    <i class="fa fa-trash"></i>
                </button>
            </c:if><c:if test="${canEdit}">
                <a class="btn btn-primary btn-mini" title="<fmt:message key="wsf.label.edit"/>"
                   href="<c:url value='${url.base}${functions:escapePath(currentResource.node.path)}.blog-edit.html'/>">
                    <i class="fa fa-pencil"></i>
                </a>
            </c:if>
        </span>
    </c:if>
    <fmt:formatDate value="${created.time}" type="date" pattern="dd" var="userCreatedDay"/>
    <fmt:formatDate value="${created.time}" type="date" pattern="MMM" var="userCreatedMonth"/>
    <div class="post-date"><span>${userCreatedMonth}</span>${userCreatedDay}</div>
    <h2 class="post-title"><c:out value="${title.string}"/></h2>

    <span>
        <fmt:message key="wsf.label.by"/>&nbsp;
        ${user:fullName(currentUser)}
        &nbsp;-&nbsp;<span class="momentToFormat" data-moment-display-type="format" data-moment-format="LL"
                           data-moment-locale="${currentResource.locale}"
                           data-moment="<fmt:formatDate value="${created.time}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></span>
    </span>
    <ul class="pull-right">
        <jcr:nodeProperty node="${currentNode}" name="j:tagList" var="assignedTags"/>
        <c:forEach items="${assignedTags}" var="tag" varStatus="status">
            <li class="label label-info">${fn:escapeXml(tag.string)}</li>
        </c:forEach>
    </ul>
    <br />
    <br />
    <div>
        ${text.string}
    </div>
    <jcr:sql var="numberOfPostsQuery"
             sql="select [jcr:uuid] from [jnt:post] as p  where isdescendantnode(p,['${functions:sqlencode(currentNode.path)}'])"/>
    <c:set var="numberOfPosts" value="${numberOfPostsQuery.rows.size}"/>
    <span>
        <c:if test="${numberOfPosts == 0}">
            <a href="<c:url value='${url.base}${functions:escapePath(currentNode.path)}.html#comments'/>">
                <i class="fa fa-comment fa-fw"></i>
                0${' '}<fmt:message key="wsf.title.comments"/>
            </a>
        </c:if>
        <c:if test="${numberOfPosts > 0}">
            <a href="<c:url value='${url.base}${functions:escapePath(currentNode.path)}.html#comments'/>">
                <i class="fa fa-comment fa-fw"></i>
                ${numberOfPosts}${' '}<fmt:message key="wsf.title.comments"/>
            </a>
        </c:if>
    </span>
 <div class="clearfix"></div>
</div>
<template:addCacheDependency path="${currentNode.path}/comments"/>
