<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="s" uri="http://www.jahia.org/tags/search" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="bootstrap" uri="http://www.jahia.org/tags/bootstrapLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="workspace.css"/>
<template:addResources type="javascript" resources="jquery.js"/>
<template:addResources type="javascript" resources="bootstrap-collapse.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootstrap-dropdown.js"/>

<jcr:nodeProperty node="${currentNode}" name="jcr:title" var="title"/>
<jcr:nodeProperty node="${currentNode}" name="j:styleName" var="styleName"/>
<jcr:nodeProperty node="${currentNode}" name="option" var="option"/>
<jcr:nodeProperty node="${currentNode}" name="responsive" var="responsive"/>
<jcr:nodeProperty node="${currentNode}" name="inverse" var="inverse"/>
<c:set var="navbarClasses" value="navbar" />
<c:if test="${not empty option and not empty option.string}">
    <c:set var="navbarClasses" value="${navbarClasses} ${option.string}" />
</c:if>
<c:if test="${not empty inverse and inverse.boolean}">
    <c:set var="navbarClasses" value="${navbarClasses} navbar-inverse" />
</c:if>
<c:if test="${not empty styleName}">
    <c:set var="navbarClasses" value="${navbarClasses} ${styleName.string}" />
</c:if>

<c:choose>
    <c:when test="${renderContext.editModeConfigName eq 'studiomode' and inWrapper eq false}">
        <c:if test="${not empty inverse and inverse.boolean}">
            <c:set var="navbarClasses" value="${navbarClasses} navbar-inverse" />
        </c:if>
        <div class="<c:if test="${not empty inverse and inverse.boolean}">navbar-inverse</c:if>">
            <div class="navbar-inner">
                <c:forEach items="${jcr:getChildrenOfType(currentNode, 'jmix:bootstrapNavBarItem')}" var="child" varStatus="status">
                    <template:module node="${child}" />
                </c:forEach>
            </div>
        </div>
        <c:if test="${renderContext.editMode}">
            <template:module path="*"/>
        </c:if>
    </c:when>
    <c:otherwise>
        <div class="${navbarClasses} workspace-secondnavbar">
            <div class="navbar-inner">
                <c:if test="${not empty responsive and responsive.boolean}">
                    <div class="container${currentNode.properties.fluid.boolean ? '-fluid' : ''}">
                        <c:if test="${renderContext.mainResource.node.url ne renderContext.site.home.url}">
                            <a class="btn btn-navbar" data-toggle="collapse" data-target="#docspaceNav${currentNode.identifier}">
                                <i class="fa fa-bars"></i>
                            </a>
                        </c:if>
                    </c:if>

                    <jcr:sql var="workspacesResults" sql="SELECT * FROM [docmix:docspace] AS f WHERE isdescendantnode(f,['${functions:sqlencode(renderContext.site.path)}']) ORDER BY f.[jcr:title] ASC"/>
                    <c:choose>
                        <c:when test="${fn:length(workspacesResults.nodes) eq 0}">
                            <a class="brand" href="${renderContext.site.home.url}">
                                <i class="fa fa-fw fa-home"></i>
                                ${renderContext.site.displayableName}
                            </a>
                        </c:when>
                        <c:otherwise>
                            <ul class="nav">
                                <li class="dropdown">
                                    <a class="dropdown-toggle brand" data-toggle="dropdown" href="#">
                                        <i class="fa fa-fw fa-home"></i>
                                        <c:set value="false" var="inWorkspace"/>
                                        <c:forEach items="${workspacesResults.nodes}" var="workspaceSite">
                                            <c:if test="${workspaceSite.name eq jcr:getMeAndParentsOfType(renderContext.mainResource.node, 'docmix:docspace')[0].name}">
                                                ${workspaceSite.displayableName}
                                                <c:set value="true" var="inWorkspace"/>
                                            </c:if>
                                        </c:forEach>
                                        <c:if test="${not inWorkspace}">
                                            ${renderContext.site.displayableName}
                                        </c:if>
                                        <b class="caret"></b>
                                    </a>
                                    <ul class="dropdown-menu">
                                        <li <c:if test="${renderContext.mainResource.node.url eq renderContext.site.home.url}">class="active"</c:if>>
                                            <a href="${renderContext.site.home.url}">
                                                <i class="fa fa-fw fa-home"></i>
                                                ${renderContext.site.displayableName}
                                            </a>
                                        </li>
                                        <li class="divider"></li>
                                        <c:forEach items="${workspacesResults.nodes}" var="workspaceSite">
                                            <li <c:if test="${workspaceSite.name eq jcr:getMeAndParentsOfType(renderContext.mainResource.node, 'docmix:docspace')[0].name}">class="active"</c:if>>
                                                <a href="<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(workspaceSite.path)}.workspace-library.html'/>">
                                                    <i class="fa fa-fw fa-suitcase"></i>
                                                    ${workspaceSite.displayableName}
                                                </a>
                                            </li>
                                        </c:forEach>
                                    </ul>
                                </li>
                            </ul>
                        </c:otherwise>
                    </c:choose>

                    <c:if test="${not empty responsive and responsive.boolean}">
                        <div id="docspaceNav${currentNode.identifier}" class="nav-collapse collapse">
                    </c:if>
                    <c:forEach items="${jcr:getChildrenOfType(currentNode, 'jmix:bootstrapNavBarItem')}" var="child" varStatus="status">
                        <template:module node="${child}" />
                    </c:forEach>
                    <c:if test="${not empty responsive and responsive.boolean}">
                        </div>
                    </div>
                </c:if>
            </div>
        </div>
    </c:otherwise>
</c:choose>
