<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="ui" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="workflow" uri="http://www.jahia.org/tags/workflow" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<jsp:useBean id="datas" class="java.util.LinkedHashMap"/>

<template:addResources type="css" resources="vendor/bootstrap-calendar/calendar.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="underscore-min.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="bootstrap-tooltip.js"/>
<template:addResources type="javascript" resources="bootstrap-popover.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="vendor/bootstrap-calendar/calendar.js"/>
<template:addResources type="javascript" resources="vendor/bootstrap-calendar/language/${currentResource.locale}.js"/>


<c:choose>
    <c:when test="${jcr:isNodeType(renderContext.mainResource.node, 'docmix:docspace')}">
        <c:set var="docspaceNode" value="${renderContext.mainResource.node}"/>
    </c:when>
    <c:otherwise>
        <c:set var="docspaceNode" value="${jcr:getParentOfType(renderContext.mainResource.node, 'docmix:docspace')}"/>
    </c:otherwise>
</c:choose>

<c:if test="${!empty docspaceNode}">
    <script type="text/javascript">
        _.templateSettings = {
            interpolate: /\<\@\=(.+?)\@\>/gim,
            evaluate: /\<\@(.+?)\@\>/gim,
            escape: /\<\@\-(.+?)\@\>/gim
        };

        var labelButton = {
            day: wsfi18n['wsf.label.today'],
            week: wsfi18n['jnt_calendar.docspace.thisWeek'],
            month: wsfi18n['jnt_calendar.docspace.thisMonth'],
            year: wsfi18n['jnt_calendar.docspace.thisYear']
        };

        var calendar;

        $(document).ready(function () {
            <c:url var="tasksfeeder" value="/cms/wsfactory/${renderContext.workspace}/${renderContext.mainResourceLocale}${functions:escapePath(fn:substringBefore(currentResource.path, '.default.html'))}.tasksfeeder.json">
                <c:param name="docspaceNode" value="${docspaceNode.path}"/>
            </c:url>

            calendar = $("#calendar_${currentNode.identifier}").calendar({
                tmpl_path: '<c:url value="${url.currentModule}/javascript/vendor/bootstrap-calendar/templates/"/>',
                events_source: '${tasksfeeder}',
                language: '${currentResource.locale}',
                jahialabel: {
                    task: wsfi18n['jnt_task.docspace'],
                    priority: wsfi18n['jnt_task.docspace.priority'],
                    assignee: wsfi18n['jnt_task.docspace.assignee'],
                    statelabel: wsfi18n['jnt_task.docspace.state'],
                    state: {
                        active: wsfi18n['jnt_task.docspace.state.active'],
                        finished: wsfi18n['jnt_task.docspace.state.finished'],
                        started: wsfi18n['jnt_task.docspace.state.started'],
                        suspended: wsfi18n['jnt_task.docspace.state.suspended'],
                        accept: wsfi18n['jnt_task.docspace.state.accept'],
                        reject: wsfi18n['jnt_task.docspace.state.reject'],
                        acceptAndPublish: wsfi18n['jnt_task.docspace.state.acceptAndPublish'],
                        acceptAndArchive: wsfi18n['jnt_task.docspace.state.acceptAndArchive'],
                        acceptPublishAndArchive: wsfi18n['jnt_task.docspace.state.acceptPublishAndArchive'],
                        unpublish: wsfi18n['jnt_task.docspace.state.unpublish']
                    }
                },
                onAfterViewLoad: function(view) {
                    $('#currentDateCalendar_${currentNode.identifier}').html(this.getTitle());
                    $('.calendarButton').removeClass('btn-primary');
                    $('#calBtn-' + view + '_${currentNode.identifier}').addClass('btn-primary');
                    $('#todayButton_${currentNode.identifier}').html(labelButton[view]);
                    $('#todayButton_${currentNode.identifier}').prop('title', labelButton[view]);
                },
                onAfterEventsLoad: function(events) {
                    _.each(events, function(v) {
                        v.start = moment(v.end).startOf('day').valueOf().toString();
                        v.end = moment(v.end).valueOf().toString();
                        if (v.endDate !== undefined) {
                            v.endDate = moment(v.endDate).locale('${currentResource.locale}').format('lll');
                        }
                    });
                }
            });
        });

        function calendarNav(navTo) {
            calendar.navigate(navTo);
        }

        function calendarDisplay(view) {
            calendar.view(view);
            $('.calendarButton').removeClass('btn-primary');
            $('#calBtn-' + view + '_${currentNode.identifier}').addClass('btn-primary');
        }
    </script>
    <div class="row-fluid">
        <div class="span12 text-center">
            <h3>
                <a href="#" onclick="calendarNav('prev');return false;"
                   title="<fmt:message key="bootstrapPager.previous"/>"
                   class="fa fa-fw fa-chevron-circle-left no-decoration">
                </a>
                <span id="currentDateCalendar_${currentNode.identifier}"></span>
                <a href="#" onclick="calendarNav('next');return false;"
                   title="<fmt:message key="bootstrapPager.next"/>"
                   class="fa fa-fw fa-chevron-circle-right no-decoration">
                </a>
            </h3>
        </div>
    </div>
    <div class="row-fluid">
        <div class="span1"></div>
        <div class="span5">
            <div class="btn-group pull-left">
                <fmt:message key="jnt_calendar.docspace.thisMonth" var="thisMonth"/>
                <button id="todayButton_${currentNode.identifier}" class="btn btn-small" onclick="calendarNav('today')"
                        title="${fn:escapeXml(thisMonth)}">
                    ${thisMonth}
                </button>
            </div>
        </div>
        <div class="span5">
            <div class="btn-group pull-right">
                <fmt:message key="jnt_calendar.docspace.year" var="labelYear"/>
                <button id="calBtn-year_${currentNode.identifier}" class="btn btn-small calendarButton"
                        onclick="calendarDisplay('year')" title="${fn:escapeXml(labelYear)}">
                    ${labelYear}
                </button>
                <fmt:message key="jnt_calendar.docspace.month" var="labelMonth"/>
                <button id="calBtn-month_${currentNode.identifier}" class="btn btn-primary btn-small calendarButton"
                        onclick="calendarDisplay('month')" title="${fn:escapeXml(labelMonth)}">
                    ${labelMonth}
                </button>
                <fmt:message key="jnt_calendar.docspace.week" var="labelWeek"/>
                <button id="calBtn-week_${currentNode.identifier}" class="btn btn-small calendarButton"
                        onclick="calendarDisplay('week')" title="${fn:escapeXml(labelWeek)}">
                    ${labelWeek}
                </button>
                <fmt:message key="jnt_calendar.docspace.day" var="labelDay"/>
                <button id="calBtn-day_${currentNode.identifier}" class="btn btn-small calendarButton"
                        onclick="calendarDisplay('day')" title="${fn:escapeXml(labelDay)}">
                    ${labelDay}
                </button>
            </div>
        </div>
    </div>
    <br />
    <div class="row-fluid">
        <div class="span1"></div>
        <div class="span10">
            <div class="calendar margin-top-20" id="calendar_${currentNode.identifier}"></div>
        </div>
    </div>
    <br />
    <br />
    <br />
    <br />
</c:if>
