<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="acl" type="java.lang.String"--%>

<template:addResources type="css" resources="pagecategorizing.css"/>
<template:addResources type="css" resources="workspace.css"/>

<c:set var="boundComponent"
       value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>
<c:if test="${not empty boundComponent}">
    <c:set var="nodeLocked" value="${jcr:isLockedAndCannotBeEdited(boundComponent)}"/>
    <div class="categorythispage">
    <jcr:nodeProperty node="${boundComponent}" name="j:defaultCategory" var="assignedCategories"/>
    <c:set var="separator" value="${functions:default(currentResource.moduleParams.separator, ' ,')}"/>
    <c:if test="${not nodeLocked}">
        <c:url var="postUrl" value="${url.base}${functions:escapePath(boundComponent.path)}"/>
        <script type="text/javascript">
            var uuidCategories = "${boundComponent.identifier}";
            var uuids = [];
            <c:forEach items="${assignedCategories}" var="category" varStatus="status">
                <c:if test="${not empty category.node}">
                    uuids.push("${category.node.identifier}");
                </c:if>
            </c:forEach>

            function deleteCategory(uuid) {
                $.ajaxSetup({traditional: true, cache:false});
                var newUuids = [];
                for (i = 0; i < uuids.length; i++) {
                    if (uuids[i] != uuid) {
                        newUuids.push(uuids[i])
                    }
                }
                uuids = newUuids;
                if (uuids.length == 0) {
                    $.post("${postUrl}", {"jcrMethodToCall":"put","jcrRemoveMixin":"jmix:categorized"}, function(result) {
                        $("#addedCategory_" + uuid).hide();
                    }, "json");
                } else {
                    $.post("${postUrl}", {"j:defaultCategory":uuids,"jcrMethodToCall":"put","jcr:mixinTypes":"jmix:categorized"}, function(result) {
                        $("#addedCategory_" + uuid).hide();
                    }, "json");
                }
                return false;
            }

            $(document).ready(function() {
                $("body").on("mouseover", ".categoryView_${boundComponent.identifier}", function() {
                    $(this).css("background", "#dddddd");
                }).on("mouseout", ".categoryView_${boundComponent.identifier}", function() {
                    $(this).css("background", "#ffffff");
                });
            });

        </script>
    </c:if>
    <div class="row-fluid" id="categoryHolder">
                <c:if test="${not empty assignedCategories}">
                    <c:forEach items="${assignedCategories}" var="category" varStatus="status">
                        <div id="addedCategory_${category.node.identifier}" class="row-fluid categoryView_${boundComponent.identifier} padding-2">
                                <span class="categorizeditem">${fn:escapeXml(category.node.displayableName)}</span>
                        <c:if test="${not nodeLocked}">
                            <a class="fa fa-remove pull-right removeCategoryFromFile" id="removeCategory_${currentNode.identifier}-${status.index}" onclick="deleteCategory('${category.node.identifier}')" href="#"></a>
                        </c:if>
                        </div>
                    </c:forEach>
                </c:if>
        </div>
    </div>
</c:if>