<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="dm" uri="http://www.jahia.org/tags/document-management" %>
<%@taglib prefix="docspace" uri="http://www.jahia.org/tags/docspace" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="workspace.css"/>
<c:set var="mimetype" value="${docspace:getMimeType(currentNode.name)}"/>
<c:set var="useImage" value="${fn:startsWith(mimetype,'image/')}"/>
<c:set var="useVideo" value="${fn:startsWith(mimetype, 'video/')}"/>
<c:if test="${not useImage and not useVideo}">
    <c:set var="useText" value="${fn:startsWith(mimetype,'text/') or mimetype eq 'application/xml'}"/>
</c:if>

<c:choose>
    <c:when test="${!useImage and !useText and !useVideo}">
        <c:set var="pdfUrl" value="${dm:isPdf(currentNode) ? currentNode.url : dm:getPdfViewUrl(currentNode, true)}"/>
        <jcr:node var="convertedPDF" path="${currentNode.path}/convertedFile"/>
        <c:if test="${empty pdfUrl and not empty convertedPDF}">
            <c:set var="pdfUrl" value="${currentNode.url}?t=convertedFile"/>
        </c:if>
        <c:if test="${not empty pdfUrl}">
        <template:addResources type="javascript" resources="vendor/flexpaper/jquery.extensions.min.js,vendor/flexpaper/flexpaper.js,vendor/flexpaper/flexpaper_handlers.js,vendor/bootstrap-slider/bootstrap-slider.js"/>
        <template:addResources type="css" resources="vendor/flexpaper/flexpaper_flat.css,vendor/bootstrap-slider/slider.css"/>
        <div class="flexpaper_viewer" id="documentViewer"></div>
        <template:addResources type="inlinejavascript">
            <script type="text/javascript">
                $(document).ready(function() {
                    jQuery.get((!window.isTouchScreen)?'${url.context}/modules/workspace-factory/javascript/vendor/flexpaper/UI_flexpaper_desktop_flat.html':'${url.context}/modules/workspace-factory/javascript/vendor/flexpaper/UI_flexpaper_mobile_flat.html',
                            function(toolbarData) {
                    $('#documentViewer').FlexPaperViewer(
                            { config : {
                                PDFFile : '${functions:escapeJavaScript(pdfUrl)}',

                                Scale : 0.6,
                                ZoomTransition : 'easeOut',
                                ZoomTime : 0.5,
                                ZoomInterval : 0.2,
                                FitPageOnLoad : false,
                                FitWidthOnLoad : true,
                                FullScreenAsMaxWindow : true,
                                ProgressiveLoading : true,
                                MinZoomSize : 0.2,
                                MaxZoomSize : 5,
                                SearchMatchAll : false,

                                Toolbar         : toolbarData,
                                InitViewMode : 'Portrait',
                                RenderingOrder : 'html5',
                                StartAtPage : '',

                                ViewModeToolsVisible : true,
                                ZoomToolsVisible : true,
                                NavToolsVisible : true,
                                CursorToolsVisible : true,
                                SearchToolsVisible : true,
                                WMode : 'window',
                                localeDirectory:'${url.context}/modules/workspace-factory/javascript/vendor/flexpaper/locale/',
                                localeChain: '${renderContext.UILocale}',
                                key: "\u0040\u0038\u0065\u0063\u0034\u0039\u0034\u0035\u0031\u0062\u0062\u0037\u0034\u0030\u0033\u0034\u0065\u0031\u0034\u0030\u0024\u0036\u0061\u0064\u0030\u0062\u0066\u0066\u0061\u0038\u0062\u0038\u0032\u0038\u0061\u0066\u0032\u0061\u0061\u0034"
                            }
                            }
                    );
                            });
                });
            </script>
        </template:addResources>
        </c:if>
    </c:when>
    <c:when test="${useImage}">
        <template:addResources type="javascript" resources="jquery.min.js"/>
        <c:set var="currentNodeUrl" value="${fn:replace(currentNode.url, \"'\", \"%27\")}"/>
        <template:addResources type="inlinejavascript">
        <script type="text/javascript">
		    function docViewerUpdate(label) {
                var url = '${currentNodeUrl}';
                $("#image").attr("src",url+"?l="+label);
		    }

            var resize = function() {
            	var fullWidth = $("#fullWidthDiv").width();
            	var img = $("#image");
            	if (img.attr('width') == 'undefined' || img.attr('width') > fullWidth) {
                	img.width(fullWidth);
            	}
            	img.show();
            };
            $(window).load(resize);
            $(window).resize(resize);
        </script>
        </template:addResources>
        <div id="fullWidthDiv">&nbsp;</div>

        <template:addResources type="css" resources="files.css"/>
        <c:set var="imgWidth" value="${currentNode.properties['j:width'].string}"/><c:if test="${not empty imgWidth}"><c:set var="imgWidth"> width="${imgWidth}"</c:set></c:if>
        <img id="image" src="<c:url value='${currentNode.url}' context='/' />" class="hide" ${not empty imgWidth ? imgWidth : ''}/>
    </c:when>
    <c:when test="${useText}">
        <pre>${fn:escapeXml(currentNode.fileContent.text)}</pre>
    </c:when>
    <c:when test="${useVideo}">
        <c:if test="${mimetype eq 'video/x-matroska'}">
            <c:set var="mimetype" value="video/webm"/>
        </c:if>
        <template:addResources type="css" resources="vendor/videojs/video-js.min.css"/>
        <template:addResources type="javascript" resources="vendor/videojs/video.js"/>
        <template:addResources type="javascript" resources="vendor/videojs/lang/${currentResource.locale}.js"/>
        <video width="100%" id="wsfVideoPlayer" controls height="400"
               class="video-js vjs-default-skin vjs-big-play-centered" data-setup='{"example_option":true}'>
            <source src="${currentNode.url}" type="${mimetype}">
        </video>
    </c:when>
    <c:otherwise>
        <template:addResources type="css" resources="files.css"/>
        <template:include templateType="html" view="faiconspan"/>&nbsp;<a href="<c:url value='${currentNode.url}' context='/'/>">${fn:escapeXml(currentNode.name)}</a>
    </c:otherwise>
</c:choose>
<br />
<br />