<%@ page import="org.jahia.modules.docspace.filters.DocumentListViewFilter" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="workflow" uri="http://www.jahia.org/tags/workflow" %>
<%@ taglib prefix="s" uri="http://www.jahia.org/tags/search" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="files.css"/>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootstrap-carousel.js"/>
<template:include view="hidden.header"/>
<c:set var="nbItemsList" value="25,50,100,250"/>
<%@include file="../../includes/bootstrapPagerInit.jspf"%>
<div class="row-fluid" id="listViewTableContainer">
<%@include file="switchView.jspf" %>
<c:set var="galleryIsNotEmpty" value="${functions:length(moduleMap.currentList) > 0 or functions:length(moduleMap.resultsHits) > 0}"/>
<c:choose>
<c:when test="${galleryIsNotEmpty}">
    <%@include file="../../includes/bootstrapPagerMobile.jspf"%>
        <div id="imageCarousel" class="carousel slide">
            <!-- Carousel items -->
            <div class="carousel-inner">
                <c:set var="imageListLength" value="0"/>
                <c:choose>
                    <c:when test="${moduleMap.resultsHits != null}">
                        <s:resultIterator hits="${moduleMap.resultsHits}" begin="${moduleMap.begin}"
                                          end="${moduleMap.end}" varStatus="status">
                            <c:set var="subchild" value="${hit.rawHit}"/>
                            <c:set var="imageListLength" value="${imageListLength + 1}"/>
                            <div class="<c:if test="${status.first}">active</c:if> item text-center">
                                <div id="imageHolder_${subchild.identifier}">
                                    <%@ include file="galleryItem.jspf" %>
                                </div>
                                <div class="carousel-caption">
                                    <h4>${subchild.name}</h4>
                                </div>
                                <script type="text/javascript">
                                    GalleryUtil.images.push('${subchild.identifier}');
                                    GalleryUtil.imageHeights['${subchild.identifier}'] = '${subchild.properties["j:height"].string}';
                                </script>
                            </div>
                        </s:resultIterator>
                    </c:when>
                    <c:otherwise>
                        <c:forEach items="${moduleMap.currentList}" var="subchild" begin="${moduleMap.begin}"
                                   end="${moduleMap.end}" varStatus="status">
                            <c:set var="imageListLength" value="${imageListLength + 1}"/>
                            <div class="<c:if test="${status.first}">active</c:if> item text-center">
                                <div id="imageHolder_${subchild.identifier}">
                                    <%@ include file="galleryItem.jspf" %>
                                </div>
                                <div class="carousel-caption">
                                    <h4>${subchild.name}</h4>
                                </div>
                                <script type="text/javascript">;
                                    GalleryUtil.images.push('${subchild.identifier}');
                                    GalleryUtil.imageHeights['${subchild.identifier}'] = '${subchild.properties["j:height"].string}';
                                </script>
                            </div>
                        </c:forEach>
                    </c:otherwise>
                </c:choose>
            </div>
            <ol class="carousel-indicators">
                <c:forEach begin="1" end="${imageListLength}" var="item" varStatus="status">
                    <li data-target="#imageCarousel" data-slide-to="${status.index - 1}"
                        class="<c:if test="${status.first}">active</c:if> carouselIndicator"></li>
                </c:forEach>
            </ol>
            <!-- Carousel nav -->
            <a class="carousel-control left" href="#imageCarousel" data-slide="prev">&lsaquo;</a>
            <a class="carousel-control right" href="#imageCarousel" data-slide="next">&rsaquo;</a>
            <div class="pull-right caption-hide fa fa-minus docspace-folder-gallery"></div>
        </div>

</c:when>
    <c:otherwise>
        <p><fmt:message key="jnt_folder.docspace.emptyOrNoImagesFolder"/></p>
    </c:otherwise>
</c:choose>
<div class="clearfix"></div>
<c:if test="${moduleMap.editable and renderContext.editMode}">
    <template:module path="*"/>
</c:if>
<template:include view="hidden.footer">
    <template:param name="searchUrl" value="${url.current}"/>
</template:include>
<c:if test="${galleryIsNotEmpty}">
<template:addResources>
    <script type="text/javascript">
        var GalleryUtil = {
            images : [],
            imageHeights : {},
            carousel : {},
            init : function() {
                //Set up carousel
                this.carousel = $('#imageCarousel');
                this.carousel.carousel({
                    interval: 5000
                });
                //Set up caption hiding
                this.setCaptionListener();
                //Set up carousel's properties
                $(".carouselIndicator").css("cursor",  "pointer");
                var self = this;
                $(".carouselIndicator").on("click", function() {
                    self.carousel.carousel($(this).attr("data-slide-to").float);
                });
                $(".item").css("background-color", "grey");
                this.setGallerySize();
            },
            setGallerySize : function() {
                var newHeight = window.innerWidth * 0.44;

                for(var i = 0; i < this.images.length; i++) {
                    if (this.imageHeights[this.images[i]] < newHeight) {
                        $("#imageHolder_" + this.images[i]).css({"line-height" : newHeight + "px",
                                                                 "height": newHeight + "px",
                                                                 "max-height": newHeight + "px",
                                                                 "width" : "auto",
                                                                 "margin": "auto"});
                        $("#image_"+ this.images[i]).css({"height": this.imageHeights[this.images[i]] + "px",
                                                                 "max-height": this.imageHeights[this.images[i]] + "px",
                                                                 "width" : "auto",
                                                                 "margin": "auto",
                                                                 "vertical-align": "middle"});
                    }
                    else {
                        $("#imageHolder_" + this.images[i]).css({"line-height" : newHeight + "px",
                                                                 "height": newHeight + "px",
                                                                 "max-height": newHeight + "px",
                                                                 "width" : "auto",
                                                                 "margin": "auto"});
                        $("#image_"+ this.images[i]).css({"height": newHeight + "px",
                                                                 "max-height": newHeight + "px",
                                                                 "width" : "auto",
                                                                 "margin": "auto",
                                                                 "vertical-align": "middle"});
                    }
                }
            },//setGallerySize
            setCaptionListener : function() {
                $("body").on("click", ".caption-hide", function() {
                    $(".carousel-caption").toggleClass("hide");
                    if ($(this).hasClass("fa-minus")) {
                        $(this).removeClass("fa-minus");
                        $(this).addClass("fa-plus");
                    }
                    else {
                        $(this).removeClass("fa-plus");
                        $(this).addClass("fa-minus");
                    }
                });
            }
        }//GalleryUtil
        $(document).ready(function() {
            GalleryUtil.init();

            $(".checkAll").click(
                    function () {
                        $(".fileCheckbox").each(function (index) {
                            if ($(".checkAll").attr("checked") == "checked") {
                                $(this).attr("checked","checked");
                            } else {
                                $(this).removeAttr("checked");
                            }
                        });
                        fileCheckBoxChecked();
            });

            //Resize gallery window
            window.onresize = function() {
                GalleryUtil.setGallerySize();
            }
        });
    </script>
</template:addResources>
</c:if>
    <%--When filtered by tags gallery images need to be put into array and size of carousel recalculated--%>
    <c:if test="${renderContext.ajaxRequest}">
        <c:choose>
            <c:when test="${moduleMap.resultsHits != null}">
                <s:resultIterator hits="${moduleMap.resultsHits}" begin="${moduleMap.begin}"
                                  end="${moduleMap.end}" varStatus="status">
                    <c:set var="subchild" value="${hit.rawHit}"/>
                    <c:set var="imageListLength" value="${imageListLength + 1}"/>
                    <script type="text/javascript">
                        GalleryUtil.images.push('${subchild.identifier}');
                        GalleryUtil.imageHeights['${subchild.identifier}'] = '${subchild.properties["j:height"].string}';
                    </script>
                </s:resultIterator>
            </c:when>
            <c:otherwise>
                <c:forEach items="${moduleMap.currentList}" var="subchild" begin="${moduleMap.begin}"
                           end="${moduleMap.end}" varStatus="status">
                    <c:set var="imageListLength" value="${imageListLength + 1}"/>
                    <script type="text/javascript">;
                        GalleryUtil.images.push('${subchild.identifier}');
                        GalleryUtil.imageHeights['${subchild.identifier}'] = '${subchild.properties["j:height"].string}';
                    </script>
                </c:forEach>
            </c:otherwise>
        </c:choose>
        <script type="text/javascript">
            GalleryUtil.init();
        </script>
    </c:if>
</div>