<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="facet" uri="http://www.jahia.org/tags/facetLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="loading.css"/>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-collapse.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootbox.min.js"/>
<template:addResources type="javascript" resources="jquery.form.js"/>
<template:addResources type="javascript" resources="loading.js"/>
<template:addResources type="javascript" resources="underscore-min.js"/>

<template:include view="hidden.header"/>

<c:set var="currentLocale">${currentResource.locale}</c:set>
<fmt:message key="wsf.label.hide" var="labelHide"/>
<fmt:message key="wsf.label.show" var="labelShow"/>

<script type="text/javascript">
    function bbEditSiteDiv(nodeName, nodePath, nodeTitle, nodeServerName, nodeDescription) {
        bootbox.dialog({
            title: wsfi18n['jnt_listSites.docspace.siteProperties'],
            message:    '<form class="form-horizontal">' +
                            '<fieldset>' +
                                '<div class="control-group">' +
                                    '<label class="control-label" for="siteTitle' + nodeName + '">' +
                                        wsfi18n['wsf.label.title'] +' (*)' +
                                    '</label>' +
                                    '<div class="controls">' +
                                        '<input type="text" name="siteTitle' + nodeName + '" id="siteTitle' + nodeName + '" value="' + _.escape(nodeTitle) + '"/>' +
                                    '</div>' +
                                '</div>' +

                                '<div class="control-group">' +
                                    '<label class="control-label" for="siteDescr' + nodeName + '">' +
                                        wsfi18n['wsf.label.description'] +
                                    '</label>' +
                                    '<div class="controls">' +
                                        '<textarea type="text" name="siteDescr' + nodeName + '" id="siteDescr' + nodeName + '">' +
                                            nodeDescription +
                                        '</textarea>' +
                                    '</div>' +
                                '</div>' +
                            '</fieldset>' +
                        '</form>',
            buttons: {
                danger: {
                    label: wsfi18n['wsf.label.cancel'],
                    className: 'btn-default',
                    callback: function() {}
                },
                success: {
                    label: wsfi18n['jnt_listSites.docspace.submitChanges'],
                    className: 'btn-primary',
                    callback: function() {
                        showLoading(wsfi18n['wsf.title.workInProgress']);
                        $.ajax({
                            type: 'POST',
                            url: '${url.context}${url.base}' + nodePath + '.adminEditSite.do',
                            data: {
                                siteTitle: $('#siteTitle' + nodeName).val(),
                                siteServerName: nodeServerName,
                                siteDescr: $('#siteDescr' + nodeName).val()
                            },
                            success: function(response) {
                                if (response.warn != undefined) {
                                    hideLoading();
                                    bootbox.alert(response.warn);
                                } else {
                                    window.location.reload();
                                }
                            },
                            error: function(response) {
                                hideLoading();
                                bootbox.alert(response.warn);
                            }
                        });
                    }
                }
            }
        });
    }

    function bbManageUsersAndGroups(url) {
        $('#modalBodyUsersAndGroups').load(url);
        $('#modalUsersAndGroups').modal();
    }

    function bbDeleteSelection() {
        if ($(".sitecheckbox:checked").length == 0) {
            bootbox.alert(wsfi18n['jnt_listSites.docspace.noSiteSelected']);
        } else {
            $(".addedInput").remove();

            $(".sitecheckbox:checked").each(function () {
                $('<input class="addedInput" type="hidden" name="sitebox" value="'+$(this).attr("name")+'">').appendTo("#deleteSiteForm")
            });

            bootbox.dialog({
                title: wsfi18n['wsf.label.confirmAction'],
                message: wsfi18n['jnt_listSites.docspace.confirmDeleteSelection'],
                buttons: {
                    danger: {
                        label: wsfi18n['wsf.label.cancel'],
                        className: 'btn-default',
                        callback: function() {}
                    },
                    success: {
                        label: wsfi18n['wsf.label.ok'],
                        className: 'btn-danger',
                        callback: function() {
                            showLoading(wsfi18n['wsf.title.workInProgress']);
                            $('#deleteSiteForm').ajaxSubmit(function() {
                                window.location.reload();
                            })
                        }
                    }
                }
            });
        }
    }

    function bbExportSite(url, live) {
        if ($(".sitecheckbox:checked").length == 0) {
            bootbox.alert(wsfi18n['jnt_listSites.docspace.noSiteSelected']);
        } else {
            $(".addedInput").remove();

            $(".sitecheckbox:checked").each(function () {
                $('<input class="addedInput" type="hidden" name="sitebox" value="'+$(this).attr("name")+'">').appendTo("#deleteSiteForm")
            });

            if ($(".sitecheckbox:checked").length == 1) {
                name = $(".sitecheckbox:checked").attr("name");
                url = url.replace("/cms/export/default/sites","/cms/export/default/"+name);
            }
            $(".sitecheckbox:checked").each(function (index) {
                $('<input class="addedInput" type="hidden" name="sitebox" value="'+$(this).attr("name")+'">').appendTo("#exportForm")
            });
            $('#exportForm input[name=live]').val(live);
            $('#exportForm').attr("action",url);
            $('#exportForm').submit();
        }
    }

    function switchWorkspaceFactoryDisplay(identifier) {
        $('#iconChevron_' + identifier).toggleClass('fa-chevron-up fa-chevron-down', 200);
        if ($('#linkCollapse_' + identifier).attr('title') == wsfi18n['wsf.label.hide']) {
            $('#linkCollapse_' + identifier).attr('title', wsfi18n['wsf.label.show']);
        } else {
            $('#linkCollapse_' + identifier).attr('title', wsfi18n['wsf.label.hide']);
        }
        $('.workspaceIconChevron').each(function () {
            if (!$(this).is($('#iconChevron_' + identifier)) && $(this).hasClass('fa-chevron-up'))
                $(this).toggleClass('fa-chevron-up fa-chevron-down', 200);
        });
        $('.workspaceLink').each(function () {
            if (!$(this).is($('#linkCollapse_' + identifier)) && $(this).attr('title') == wsfi18n['wsf.label.hide'])
                $(this).attr('title', wsfi18n['wsf.label.show']);
        });
        $('.workspaceList').each(function () {
            if (!$(this).is($('#collapse_' + identifier)) && $(this).hasClass('in'))
                $(this).collapse('hide');
        });
    }
</script>

<table class="table table-condensed table-hover">
    <thead>
        <th id="Title" class="muted span9">
            <fmt:message key="wsf.label.title"/>
        </th>
        <th id="Actions" class="muted span3">
            <fmt:message key="wsf.label.actions"/>
        </th>
    </thead>
    <tbody>
        <c:forEach items="${moduleMap.currentList}" var="workspaceFactory" varStatus="workspaceFactoryStatus"
                   begin="${moduleMap.begin}" end="${moduleMap.end}">
            <c:choose>
                <c:when test="${currentNode.properties.typeOfContent.string eq 'contents'}">
                    <c:set var="page" value="/contents"/>
                </c:when>
                <c:when test="${currentNode.properties.typeOfContent.string eq 'files'}">
                    <c:set var="page" value="/files"/>
                </c:when>
                <c:otherwise>
                    <c:set var="page" value="/${workspaceFactory.home.name}"/>
                </c:otherwise>
            </c:choose>
            <c:set var="baseLive" value="${url.baseLive}"/>
            <c:set var="basePreview" value="${url.basePreview}"/>
            <c:set var="baseContribute" value="${url.baseContribute}"/>
            <c:set var="baseEdit" value="${url.baseEdit}"/>
            <c:if test="${not functions:contains(workspaceFactory.languages, currentLocale)}">
                <c:set var="localeLength" value="${fn:length(currentLocale)}"/>
                <c:set var="baseLive"
                       value="${fn:substring(url.baseLive,-1,fn:length(url.baseLive)-localeLength)}${currentResource.locale}"/>
                <c:set var="basePreview"
                       value="${fn:substring(url.basePreview,-1,fn:length(url.basePreview)-localeLength)}${currentResource.locale}"/>
                <c:set var="baseContribute"
                       value="${fn:substring(url.baseContribute,-1,fn:length(url.baseContribute)-localeLength)}${currentResource.locale}"/>
                <c:set var="baseEdit"
                       value="${fn:substring(url.baseEdit,-1,fn:length(url.baseEdit)-localeLength)}${currentResource.locale}"/>
            </c:if>
            <c:set var="baseContribute" value="${fn:replace(baseContribute,'/contribute/' ,'/wsfactory/' )}"/>
            <c:set var="remotelyPublished" value="${jcr:isNodeType(workspaceFactory,'jmix:remotelyPublished')}"/>
            <tr>
                <td>
                    <c:choose>
                        <c:when test="${currentNode.properties.contribute.boolean  && jcr:hasPermission(workspaceFactory, 'contributeModeAccess') && !renderContext.settings.distantPublicationServerMode && not remotelyPublished}">
                            <ul class="unstyled">
                                <li>
                                    <a data-toggle="collapse" onclick="switchWorkspaceFactoryDisplay('${currentNode.identifier}_${workspaceFactory.identifier}')"
                                       href="#collapse_${currentNode.identifier}_${workspaceFactory.identifier}"
                                       title="<c:choose><c:when test="${workspaceFactoryStatus.first}">${fn:escapeXml(labelHide)}</c:when><c:otherwise>${fn:escapeXml(labelShow)}</c:otherwise></c:choose>"
                                       id="linkCollapse_${currentNode.identifier}_${workspaceFactory.identifier}" class="workspaceLink no-decoration">
                                        <i id="iconChevron_${currentNode.identifier}_${workspaceFactory.identifier}"
                                           class="fa fa-fw workspaceIconChevron<c:choose><c:when test="${workspaceFactoryStatus.first}"> fa-chevron-up</c:when><c:otherwise> fa-chevron-down</c:otherwise></c:choose>"></i>
                                        ${workspaceFactory.displayableName}
                                    </a>
                                    <jcr:sql var="workspaces"
                                             sql="select * from [docmix:docspace] where isdescendantnode('${functions:sqlencode(workspaceFactory.path)}') order by [jcr:title] asc"/>
                                    <c:forEach items="${workspaces.nodes}" var="workspace" varStatus="workspaceStatus">
                                        <c:if test="${workspaceStatus.first}">
                                            <ul id="collapse_${currentNode.identifier}_${workspaceFactory.identifier}" class="unstyled collapse<c:if test="${workspaceFactoryStatus.first}"> in</c:if> workspaceList">
                                        </c:if>
                                        <li>
                                            &nbsp;
                                            &nbsp;
                                            &nbsp;
                                            &nbsp;
                                            <i class="fa fa-suitcase"></i>
                                            <a href="<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(workspace.path)}.workspace-library.html'/>">
                                                    ${fn:escapeXml(workspace.displayableName)}
                                            </a>
                                            <jcr:node var="acl" path="${workspace.path}/j:acl/GRANT_u_${renderContext.user.username}"/>
                                            <c:if test="${not empty acl}">
                                                <c:forEach items="${acl.properties['j:roles']}" var="role" varStatus="roleStatus">
                                                    <fmt:message key='wsf.role.${role.string}' var="labelDocspaceRole"/>
                                                    ${roleStatus.first ? '(' : ', '}<span class="muted" title="${fn:escapeXml(labelDocspaceRole)}"><fmt:message key="wsf.role.${role.string}.short"/></span>${roleStatus.last ? ')' : ''}
                                                </c:forEach>
                                            </c:if>
                                        </li>
                                        <c:if test="${workspaceStatus.last}">
                                            </ul>
                                        </c:if>
                                    </c:forEach>
                                </li>
                            </ul>
                        </c:when>
                        <c:otherwise>${workspaceFactory.displayableName}</c:otherwise>
                    </c:choose>
                </td>
                <td>
                    <c:choose>
                        <c:when test="${not empty workspaceFactory and (jcr:hasPermission(workspaceFactory,'editModeAccess') || jcr:hasPermission(workspaceFactory,'contributeModeAccess'))}">
                            <c:set var="siteId" value="${workspaceFactory.properties['j:siteId'].long}"/>
                            <c:if test="${currentNode.properties.administrationlink.boolean && jcr:hasPermission(workspaceFactory,'adminVirtualSites')}">
                                <fmt:message key='wsf.label.administration' var="labelAdministration"/>
                                <a href="<c:url value='/administration/?do=change&changesite=${siteId}#sites'/>"
                                   title="${fn:escapeXml(labelAdministration)}" class="no-decoration">
                                    <img src="<c:url value='${url.currentModule}/css/img/admin.png'/>" width="16" height="16" alt=" "
                                         role="presentation"/>
                                </a>
                            </c:if>
                            <c:if test="${currentNode.properties.edit.boolean && jcr:hasPermission(workspaceFactory,'editModeAccess') && !renderContext.settings.distantPublicationServerMode && not remotelyPublished}">
                                <fmt:message key='wsf.label.editMode' var="labelEditMode"/>
                                <a href="<c:url value='${baseEdit}${functions:escapePath(workspaceFactory.path)}${page}.html'/>"
                                   title="${fn:escapeXml(labelEditMode)}" class="no-decoration">
                                    <img src="<c:url value='${url.currentModule}/css/img/editMode.png'/>" width="16" height="16" alt=" "
                                         role="presentation"/>
                                </a>
                            </c:if>
                            <c:if test="${currentNode.properties.contribute.boolean  && jcr:hasPermission(workspaceFactory,'contributeModeAccess') && !renderContext.settings.distantPublicationServerMode && not remotelyPublished}">
                                <c:url value='${url.currentModule}/css/img/contribute.png' var="icon"/>
                                <c:if test="${currentNode.properties.typeOfContent.string eq 'contents'}">
                                    <c:url value='${url.currentModule}/css/img/content-manager-1616.png' var="icon"/>
                                </c:if>
                                <fmt:message key='wsf.label.contribute' var="labelContribute"/>
                                <a href="<c:url value='${baseContribute}${functions:escapePath(workspaceFactory.path)}${page}.html'/>"
                                   title="${fn:escapeXml(labelContribute)}" class="no-decoration">
                                    <img src="${icon}" width="16" height="16" alt=" " role="presentation"/>
                                </a>
                            </c:if>
                            <c:if test="${currentNode.properties.preview.boolean && jcr:hasPermission(workspaceFactory,'jcr:read_default') && !renderContext.settings.distantPublicationServerMode && not remotelyPublished}">
                                <fmt:message key='wsf.label.preview' var="labelPreview"/>
                                <a href="<c:url value='${basePreview}${functions:escapePath(workspaceFactory.path)}${page}.html'/>"
                                   title="${fn:escapeXml(labelPreview)}" class="no-decoration">
                                    <img src="<c:url value='${url.currentModule}/css/img/preview.png'/>" width="16" height="16" alt=" "
                                         role="presentation"/>
                                </a>
                            </c:if>
                            <c:if test="${currentNode.properties.live.boolean && (workspaceFactory.home.properties['j:published'].boolean or remotelyPublished)}">
                                <fmt:message key='wsf.label.live' var="labelLive"/>
                                <a href="<c:url value='${baseLive}${functions:escapePath(workspaceFactory.path)}${page}.html'/>"
                                   title="${fn:escapeXml(labelLive)}" class="no-decoration">
                                    <img src="<c:url value='${url.currentModule}/css/img/live.png'/>" width="16" height="16" alt=" "
                                         role="presentation"/>
                                </a>
                            </c:if>
                            <c:if test="${currentNode.properties.editproperties.boolean && jcr:hasPermission(workspaceFactory,'adminVirtualSites')}">
                                <fmt:message key='jnt_listSites.docspace.changeProperties' var="labelManageSiteChangeProperties"/>
                                <a href="#"
                                   title="${fn:escapeXml(labelManageSiteChangeProperties)}"
                                   onclick="bbEditSiteDiv('${functions:escapeJavaScript(workspaceFactory.name)}',
                                           '${functions:escapeJavaScript(functions:escapePath(workspaceFactory.path))}',
                                           '${fn:escapeXml(functions:escapeJavaScript(workspaceFactory.properties['j:title'].string))}',
                                           '${workspaceFactory.properties['j:serverName'].string}',
                                           '${fn:escapeXml(functions:escapeJavaScript(workspaceFactory.properties['j:description'].string))}');return false;"
                                   class="no-decoration">
                                    <img src="<c:url value='${url.currentModule}/css/img/changeProperties.png'/>" width="16" height="16" alt=" "
                                         role="presentation"/>
                                </a>
                            </c:if>
                            <c:if test="${currentNode.properties.details.boolean && jcr:hasPermission(workspaceFactory,'adminVirtualSites')}">
                                <a href="#" onclick="bbManageUsersAndGroups('<c:url value="/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(workspaceFactory.path)}${page}.${currentNode.properties.detailsTemplate.string}.html"/>');return false;"
                                   title="${currentNode.properties.detailsLabel.string}" class="no-decoration">
                                    <img src="<c:url value='${url.currentModule}/css/img/administrator.png'/>" width="16" height="16" alt=" "
                                         role="presentation"/>
                                </a>
                            </c:if>
                            <c:if test="${currentNode.properties.details.boolean && jcr:hasPermission(workspaceFactory,'siteAdminGroups')}">
                                <fmt:message key='jnt_listSites.docspace.goToGroupAdministration' var="labelGoToManageGroupAdmin"/>
                                <a href="<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(workspaceFactory.path)}/manage-groups.html'/>" id="groupButton${workspaceFactory.name}"
                                   title="${fn:escapeXml(labelGoToManageGroupAdmin)}" class="no-decoration">
                                    <img src="<c:url value='${url.currentModule}/css/img/group_edit.png'/>" width="16" height="16" alt=" "
                                         role="presentation"/>
                                </a>
                            </c:if>
                        </c:when>
                        <c:otherwise>
                            <c:set var="editModeAccess"
                                   value="${jcr:findAllowedNodesForPermission('editModeAccess', workspaceFactory, 'jnt:page')}"/>
                            <c:set var="contributeModeAccess"
                                   value="${jcr:findAllowedNodesForPermission('contributeModeAccess', workspaceFactory, 'jnt:page')}"/>
                            <c:set var="previewModeAccess"
                                   value="${jcr:findAllowedNodesForPermission('jcr:read_default', workspaceFactory, 'jnt:page')}"/>
                            <c:if test="${workspaceFactory.home.properties['j:published'].boolean or not empty editModeAccess or not empty contributeModeAccess or not empty previewModeAccess}">
                                <c:set var="baseLive" value="${url.baseLive}"/>
                                <c:set var="basePreview" value="${url.basePreview}"/>
                                <c:set var="baseContribute" value="${url.baseContribute}"/>
                                <c:set var="baseEdit" value="${url.baseEdit}"/>
                                <c:if test="${not functions:contains(workspaceFactory.languages, currentLocale)}">
                                    <c:set var="localeLength" value="${fn:length(currentLocale)}"/>
                                    <c:set var="baseLive"
                                           value="${fn:substring(url.baseLive,-1,fn:length(url.baseLive)-localeLength)}${currentResource.locale}"/>
                                    <c:set var="basePreview"
                                           value="${fn:substring(url.basePreview,-1,fn:length(url.basePreview)-localeLength)}${currentResource.locale}"/>
                                    <c:set var="baseContribute"
                                           value="${fn:substring(url.baseContribute,-1,fn:length(url.baseContribute)-localeLength)}${currentResource.locale}"/>
                                    <c:set var="baseEdit"
                                           value="${fn:substring(url.baseEdit,-1,fn:length(url.baseEdit)-localeLength)}${currentResource.locale}"/>
                                </c:if>
                                <c:set var="baseContribute" value="${fn:replace(baseContribute,'/contribute/' ,'/wsfactory/' )}"/>
                                <c:if test="${not empty editModeAccess && currentNode.properties.contribute.boolean && !renderContext.settings.distantPublicationServerMode}">
                                    <fmt:message key='wsf.label.editMode' var="labelEditMode"/>
                                    <a href="<c:url value='${baseEdit}${functions:escapePath(editModeAccess[0].path)}.html'/>"
                                       title="${fn:escapeXml(labelEditMode)}" class="no-decoration">
                                        <img src="<c:url value='${url.currentModule}/css/img/editMode.png'/>" width="16" height="16" alt=" "
                                             role="presentation"/>
                                    </a>
                                </c:if>

                                <c:if test="${not empty contributeModeAccess && currentNode.properties.contribute.boolean && !renderContext.settings.distantPublicationServerMode}">
                                    <fmt:message key='wsf.label.contribute' var="labelContribute"/>
                                    <a href="<c:url value='${baseContribute}${functions:escapePath(contributeModeAccess[0].path)}.html'/>"
                                       title="${fn:escapeXml(labelContribute)}" class="no-decoration">
                                        <img src="<c:url value='${url.currentModule}/css/img/contribute.png'/>" width="16" height="16" alt=" "
                                             role="presentation"/>
                                    </a>
                                </c:if>

                                <c:if test="${not empty previewModeAccess && currentNode.properties.preview.boolean && !renderContext.settings.distantPublicationServerMode}">
                                    <fmt:message key='wsf.label.preview' var="labelPreview"/>
                                    <a href="<c:url value='${basePreview}${functions:escapePath(previewModeAccess[0].path)}.html'/>"
                                       title="${fn:escapeXml(labelPreview)}" class="no-decoration">
                                        <img src="<c:url value='${url.currentModule}/css/img/preview.png'/>" width="16" height="16" alt=" "
                                             role="presentation"/>
                                    </a>
                                </c:if>
                                <c:if test="${currentNode.properties.live.boolean && workspaceFactory.home.properties['j:published'].boolean}">
                                    <fmt:message key='wsf.label.live' var="labelLive"/>
                                    <a href="<c:url value='${baseLive}${functions:escapePath(workspaceFactory.path)}${page}.html'/>"
                                       title="${fn:escapeXml(labelLive)}" class="no-decoration">
                                        <img src="<c:url value='${url.currentModule}/css/img/live.png'/>" width="16" height="16" alt=" "
                                             role="presentation"/>
                                    </a>
                                </c:if>
                            </c:if>
                        </c:otherwise>
                    </c:choose>
                </td>
            </tr>
        </c:forEach>
    </tbody>
</table>

<%@ include file="modalAndForm.jspf" %>

<template:include view="hidden.footer"/>
