<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="facet" uri="http://www.jahia.org/tags/facetLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="loading.css"/>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootbox.min.js"/>
<template:addResources type="javascript" resources="jquery.form.js"/>
<template:addResources type="javascript" resources="loading.js"/>
<template:addResources type="javascript" resources="underscore-min.js"/>

<template:include view="hidden.header"/>

<c:set var="currentLocale">${currentResource.locale}</c:set>
<jsp:useBean id="nowDate" class="java.util.Date" />
<fmt:formatDate value="${nowDate}" pattern="yyyy-MM-dd-HH-mm" var="now"/>

<script type="text/javascript">
    $(document).ready(function() {
        $("#checkAll").on('change', function () {
            if ($("#checkAll").prop('checked') === true) {
                $(".sitecheckbox").prop("checked", true);
            } else {
                $(".sitecheckbox").prop("checked", false);
            }
        });
    });

    function bbEditSiteDiv(nodeName, nodePath, nodeServerName, nodeTitle, nodeDescription) {
        bootbox.dialog({
            title: wsfi18n['jnt_listSites.docspace.siteProperties'],
            message:    '<form class="form-horizontal">' +
                            '<fieldset>' +
                                '<div class="control-group">' +
                                    '<label class="control-label" for="siteTitle' + nodeName + '">' +
                                        wsfi18n['wsf.label.title'] + ' (*)' +
                                    '</label>' +
                                    '<div class="controls">' +
                                        '<input type="text" name="siteTitle' + nodeName + '" id="siteTitle' + nodeName + '" value="' + _.escape(nodeTitle) + '"/>' +
                                    '</div>' +
                                '</div>' +

                                '<div class="control-group">' +
                                    '<label class="control-label" for="siteDescr' + nodeName + '">' +
                                        wsfi18n['wsf.label.description'] +
                                    '</label>' +
                                    '<div class="controls">' +
                                        '<textarea type="text" name="siteDescr' + nodeName + '" id="siteDescr' + nodeName + '">' +
                                            nodeDescription +
                                        '</textarea>' +
                                    '</div>' +
                                '</div>' +
                            '</fieldset>' +
                        '</form>',
            buttons: {
                danger: {
                    label: wsfi18n['wsf.label.cancel'],
                    className: 'btn-default',
                    callback: function() {}
                },
                success: {
                    label: wsfi18n['jnt_listSites.docspace.submitChanges'],
                    className: 'btn-primary',
                    callback: function() {
                        showLoading(wsfi18n['wsf.title.workInProgress']);
                        $.ajax({
                            type: 'POST',
                            url: '${url.context}${url.base}' + nodePath + '.adminEditSite.do',
                            dataType: 'json',
                            data: {
                                siteTitle: $('#siteTitle' + nodeName).val(),
                                siteServerName: nodeServerName,
                                siteDescr: $('#siteDescr' + nodeName).val()
                            },
                            success: function(response) {
                                if (response.warn != undefined) {
                                    hideLoading();
                                    bootbox.alert(response.warn);
                                } else {
                                    window.location.reload();
                                }
                            },
                            error: function(response) {
                                hideLoading();
                                bootbox.alert(response.warn);
                            }
                        });
                    }
                }
            }
        });
    }

    function bbManageUsersAndGroups(url) {
        $('#modalBodyUsersAndGroups').load(url);
        $('#modalUsersAndGroups').modal();
    }

    function bbDeleteSelection() {
        if ($(".sitecheckbox:checked").length == 0) {
            bootbox.alert(wsfi18n['jnt_listSites.docspace.noSiteSelected']);
        } else {
            $(".addedInput").remove();

            $(".sitecheckbox:checked").each(function () {
                $('<input class="addedInput" type="hidden" name="sitebox" value="'+$(this).attr("name")+'">').appendTo("#deleteSiteForm")
            });

            bootbox.dialog({
                title: wsfi18n['wsf.label.confirmAction'],
                message: wsfi18n['jnt_listSites.docspace.confirmDeleteSelection'],
                buttons: {
                    danger: {
                        label: wsfi18n['wsf.label.cancel'],
                        className: 'btn-default',
                        callback: function() {}
                    },
                    success: {
                        label: wsfi18n['wsf.label.ok'],
                        className: 'btn-danger',
                        callback: function() {
                            showLoading(wsfi18n['wsf.title.workInProgress']);
                            $('#deleteSiteForm').ajaxSubmit(function() {
                                window.location.reload();
                            })
                        }
                    }
                }
            });
        }
    }

    function bbExportSite(url, live) {
        if ($(".sitecheckbox:checked").length == 0) {
            bootbox.alert(wsfi18n['jnt_listSites.docspace.noSiteSelected']);
        } else {
            $(".addedInput").remove();

            if ($(".sitecheckbox:checked").length == 1) {
                url = url.replace("/cms/export/default/sites","/cms/export/default/" + $(".sitecheckbox:checked").attr("name"));
            }
            $(".sitecheckbox:checked").each(function () {
                $('<input class="addedInput" type="hidden" name="sitebox" value="'+$(this).attr("name")+'">').appendTo("#exportForm")
            });
            $('#exportForm input[name=live]').val(live);
            $('#exportForm').attr("action", url);
            $('#exportForm').submit();
        }
    }
</script>

<jcr:node var="root" path="/"/>

<div class="page-header">
    <c:if test="${jcr:hasPermission(root,'adminVirtualSites')}">
        <template:area path="createNewFactoryButton" view="areaButton"/>
    </c:if>
    <c:if test="${moduleMap.end > 0 and moduleMap.end > moduleMap.begin and jcr:hasPermission(root,'adminVirtualSites')}">
        <c:if test="${currentNode.properties.delete.boolean}">
            <button class="btn btn-danger" onclick="bbDeleteSelection()">
                <fmt:message key="wsf.label.delete"/>
            </button>
        </c:if>
        <c:if test="${currentNode.properties.export.boolean}">
            <button type="button" class="btn" onclick="bbExportSite('<c:url value="/cms/export/default/sites_staging_export_${now}.zip"/>', false)">
                <fmt:message key="jnt_listSites.docspace.exportStaging"/>
            </button>
            <button type="button" class="btn" onclick="bbExportSite('<c:url value="/cms/export/default/sites_export_${now}.zip"/>', true)">
                <fmt:message key="jnt_listSites.docspace.exportLive"/>
            </button>
        </c:if>
    </c:if>
</div>


<table width="100%" class="table table-hover" summary="Site List Table" id="siteListTable">
    <thead>
        <tr>
            <c:if test="${(currentNode.properties.export.boolean or currentNode.properties.delete.boolean)}">
                <th id="Select" class="muted">
                    <input type="checkbox" id="checkAll"/>
                </th>
            </c:if>
            <th id="Title" class="muted">
                <fmt:message key="wsf.label.title"/>
            </th>
            <th class="hidden-phone muted" id="Key">
                <fmt:message key="serverSettings.docspace.siteKey"/>
            </th>
            <%--<th class="hidden-phone muted" id="ServerName">--%>
                <%--<fmt:message key="serverSettings.docspace.serverName"/>--%>
            <%--</th>--%>
            <th id="Actions" class="muted">
                <fmt:message key="wsf.label.actions"/>
            </th>
        </tr>
    </thead>

    <tbody>
        <c:forEach items="${moduleMap.currentList}" var="node" begin="${moduleMap.begin}" end="${moduleMap.end}">
            <c:choose>
                <c:when test="${currentNode.properties.typeOfContent.string eq 'contents'}">
                    <c:set var="page" value="/contents"/>
                </c:when>
                <c:when test="${currentNode.properties.typeOfContent.string eq 'files'}">
                    <c:set var="page" value="/files"/>
                </c:when>
                <c:otherwise>
                    <c:set var="page" value="/${node.home.name}"/>
                </c:otherwise>
            </c:choose>
            <c:set var="baseLive" value="${url.baseLive}"/>
            <c:set var="basePreview" value="${url.basePreview}"/>
            <c:set var="baseContribute" value="${url.baseContribute}"/>
            <c:set var="baseEdit" value="${url.baseEdit}"/>
            <c:if test="${not functions:contains(node.languages, currentLocale)}">
                <c:set var="localeLength" value="${fn:length(currentLocale)}"/>
                <c:set var="baseLive"
                       value="${fn:substring(url.baseLive,-1,fn:length(url.baseLive)-localeLength)}${currentResource.locale}"/>
                <c:set var="basePreview"
                       value="${fn:substring(url.basePreview,-1,fn:length(url.basePreview)-localeLength)}${currentResource.locale}"/>
                <c:set var="baseContribute"
                       value="${fn:substring(url.baseContribute,-1,fn:length(url.baseContribute)-localeLength)}${currentResource.locale}"/>
                <c:set var="baseEdit"
                       value="${fn:substring(url.baseEdit,-1,fn:length(url.baseEdit)-localeLength)}${currentResource.locale}"/>
            </c:if>
            <c:set var="baseContribute" value="${fn:replace(baseContribute,'/contribute/' ,'/wsfactory/' )}"/>
            <c:set var="remotelyPublished" value="${jcr:isNodeType(node,'jmix:remotelyPublished')}"/>
            <tr class="odd">
                <c:if test="${(currentNode.properties.export.boolean or currentNode.properties.delete.boolean)}">
                    <td headers="Select">
                        <c:if test="${jcr:hasPermission(node,'adminVirtualSites')}">
                            <input class="sitecheckbox" type="checkbox" name="${node.name}" />
                        </c:if>
                    </td>
                </c:if>
                <td headers="Title">
                    <c:choose>
                        <c:when test="${currentNode.properties.contribute.boolean  && jcr:hasPermission(node,'contributeModeAccess') && !renderContext.settings.distantPublicationServerMode && not remotelyPublished}">
                            <a href="<c:url value='${baseContribute}${functions:escapePath(node.path)}${page}.html'/>">
                                ${node.displayableName}
                            </a>
                        </c:when>
                        <c:otherwise>${node.displayableName}</c:otherwise>
                    </c:choose>
                </td>
                <td class="hidden-phone" headers="Key">${node.name}</td>
                <%--<td class="hidden-phone" headers="ServerName">${node.properties['j:serverName'].string}</td>--%>
                <c:choose>
                    <c:when test="${not empty node and (jcr:hasPermission(node,'editModeAccess') || jcr:hasPermission(node,'contributeModeAccess'))}">
                        <td headers="Actions">
                            <c:set var="siteId" value="${node.properties['j:siteId'].long}"/>
                            <c:if test="${currentNode.properties.administrationlink.boolean && jcr:hasPermission(node,'adminVirtualSites')}">
                                <a href="<c:url value='/administration/?do=change&changesite=${siteId}#sites'/>"
                                   title="<fmt:message key='wsf.label.administration'/>" class="no-decoration">
                                    <img src="<c:url value='${url.currentModule}/css/img/admin.png'/>" width="16" height="16" alt=" "
                                        role="presentation"/>
                                </a>
                            </c:if>
                            <c:if test="${currentNode.properties.edit.boolean && jcr:hasPermission(node,'editModeAccess') && !renderContext.settings.distantPublicationServerMode && not remotelyPublished}">
                                <a href="<c:url value='${baseEdit}${functions:escapePath(node.path)}${page}.html'/>"
                                   title="<fmt:message key='wsf.label.editMode'/>" class="no-decoration">
                                    <img src="<c:url value='${url.currentModule}/css/img/editMode.png'/>" width="16" height="16" alt=" "
                                        role="presentation"/>
                                </a>
                            </c:if>
                            <c:if test="${currentNode.properties.contribute.boolean  && jcr:hasPermission(node,'contributeModeAccess') && !renderContext.settings.distantPublicationServerMode && not remotelyPublished}">
                                <c:url value='${url.currentModule}/css/img/contribute.png' var="icon"/>
                                <c:if test="${currentNode.properties.typeOfContent.string eq 'contents'}">
                                    <c:url value='${url.currentModule}/css/img/content-manager-1616.png' var="icon"/>
                                </c:if>
                                <a href="<c:url value='${baseContribute}${functions:escapePath(node.path)}${page}.html'/>"
                                   title="<fmt:message key='wsf.label.contribute'/>" class="no-decoration">
                                    <img src="${icon}" width="16" height="16" alt=" " role="presentation"/>
                                </a>
                            </c:if>
                            <c:if test="${currentNode.properties.preview.boolean && jcr:hasPermission(node,'jcr:read_default') && !renderContext.settings.distantPublicationServerMode && not remotelyPublished}">
                                <a href="<c:url value='${basePreview}${functions:escapePath(node.path)}${page}.html'/>"
                                   title="<fmt:message key='wsf.label.preview'/>" class="no-decoration">
                                    <img src="<c:url value='${url.currentModule}/css/img/preview.png'/>" width="16" height="16" alt=" "
                                        role="presentation"/>
                                </a>
                            </c:if>
                            <c:if test="${currentNode.properties.live.boolean && (node.home.properties['j:published'].boolean or remotelyPublished)}">
                                <a href="<c:url value='${baseLive}${functions:escapePath(node.path)}${page}.html'/>"
                                   title="<fmt:message key='wsf.label.live'/>" class="no-decoration">
                                    <img src="<c:url value='${url.currentModule}/css/img/live.png'/>" width="16" height="16" alt=" "
                                        role="presentation"/>
                                </a>
                            </c:if>
                            <c:if test="${currentNode.properties.editproperties.boolean && jcr:hasPermission(node,'adminVirtualSites')}">
                                <a href="#"
                                   title="<fmt:message key='jnt_listSites.docspace.changeProperties'/>"
                                   onclick="bbEditSiteDiv('${functions:escapeJavaScript(node.name)}',
                                           '${functions:escapeJavaScript(functions:escapePath(node.path))}',
                                           '${node.properties['j:serverName'].string}',
                                           '${fn:escapeXml(functions:escapeJavaScript(node.properties['j:title'].string))}',
                                           '${fn:escapeXml(functions:escapeJavaScript(node.properties['j:description'].string))}');return false;"
                                   class="no-decoration">
                                    <img src="<c:url value='${url.currentModule}/css/img/changeProperties.png'/>" width="16" height="16" alt=" "
                                        role="presentation"/>
                                </a>
                            </c:if>
                            <c:if test="${currentNode.properties.details.boolean && jcr:hasPermission(node,'adminVirtualSites')}">
                                <a href="#" onclick="bbManageUsersAndGroups('<c:url value="${basePreview}${functions:escapePath(node.path)}${page}.${currentNode.properties.detailsTemplate.string}.html"/>');return false;"
                                   title="${currentNode.properties.detailsLabel.string}" class="no-decoration">
                                    <img src="<c:url value='${url.currentModule}/css/img/administrator.png'/>" width="16" height="16" alt=" "
                                        role="presentation"/>
                                </a>
                            </c:if>
                            <c:if test="${jcr:hasPermission(node,'siteAdminGroups')}">
                                <a href="<c:url value='/cms/wsfactory/default/${currentResource.locale}${functions:escapePath(node.path)}/manage-groups.html'/>" id="groupButton${node.name}"
                                   title="<fmt:message key='jnt_listSites.docspace.goToGroupAdministration'/>" class="no-decoration">
                                    <img src="<c:url value='${url.currentModule}/css/img/group_edit.png'/>" width="16" height="16" alt=" "
                                        role="presentation"/>
                                </a>
                            </c:if>
                        </td>
                    </c:when>
                    <c:otherwise>
                        <c:set var="editModeAccess"
                               value="${jcr:findAllowedNodesForPermission('editModeAccess', node, 'jnt:page')}"/>
                        <c:set var="contributeModeAccess"
                               value="${jcr:findAllowedNodesForPermission('contributeModeAccess', node, 'jnt:page')}"/>
                        <c:set var="previewModeAccess"
                               value="${jcr:findAllowedNodesForPermission('jcr:read_default', node, 'jnt:page')}"/>
                        <c:if test="${node.home.properties['j:published'].boolean or not empty editModeAccess or not empty contributeModeAccess or not empty previewModeAccess}">
                            <td headers="Actions">
                                <c:set var="baseLive" value="${url.baseLive}"/>
                                <c:set var="basePreview" value="${url.basePreview}"/>
                                <c:set var="baseContribute" value="${url.baseContribute}"/>
                                <c:set var="baseEdit" value="${url.baseEdit}"/>
                                <c:if test="${not functions:contains(node.languages, currentLocale)}">
                                    <c:set var="localeLength" value="${fn:length(currentLocale)}"/>
                                    <c:set var="baseLive"
                                           value="${fn:substring(url.baseLive,-1,fn:length(url.baseLive)-localeLength)}${currentResource.locale}"/>
                                    <c:set var="basePreview"
                                           value="${fn:substring(url.basePreview,-1,fn:length(url.basePreview)-localeLength)}${currentResource.locale}"/>
                                    <c:set var="baseContribute"
                                           value="${fn:substring(url.baseContribute,-1,fn:length(url.baseContribute)-localeLength)}${currentResource.locale}"/>
                                    <c:set var="baseEdit"
                                           value="${fn:substring(url.baseEdit,-1,fn:length(url.baseEdit)-localeLength)}${currentResource.locale}"/>
                                </c:if>
                                <c:set var="baseContribute" value="${fn:replace(baseContribute,'/contribute/' ,'/wsfactory/' )}"/>
                                <c:if test="${not empty editModeAccess && currentNode.properties.contribute.boolean && !renderContext.settings.distantPublicationServerMode}">
                                    <a href="<c:url value='${baseEdit}${functions:escapePath(editModeAccess[0].path)}.html'/>"
                                       title="<fmt:message key='wsf.label.editMode'/>">
                                        <img src="<c:url value='${url.currentModule}/css/img/editMode.png'/>" width="16" height="16" alt=" "
                                            role="presentation"/>
                                    </a>
                                </c:if>

                                <c:if test="${not empty contributeModeAccess && currentNode.properties.contribute.boolean && !renderContext.settings.distantPublicationServerMode}">
                                    <a href="<c:url value='${baseContribute}${functions:escapePath(contributeModeAccess[0].path)}.html'/>"
                                       title="<fmt:message key='wsf.label.contribute'/>" class="no-decoration">
                                        <img src="<c:url value='${url.currentModule}/css/img/contribute.png'/>" width="16" height="16" alt=" "
                                            role="presentation"/>
                                    </a>
                                </c:if>

                                <c:if test="${not empty previewModeAccess && currentNode.properties.preview.boolean && !renderContext.settings.distantPublicationServerMode}">
                                    <a href="<c:url value='${basePreview}${functions:escapePath(previewModeAccess[0].path)}.html'/>"
                                       title="<fmt:message key='wsf.label.preview'/>" class="no-decoration">
                                        <img src="<c:url value='${url.currentModule}/css/img/preview.png'/>" width="16" height="16" alt=" "
                                            role="presentation"/>
                                    </a>
                                </c:if>
                                <c:if test="${currentNode.properties.live.boolean && node.home.properties['j:published'].boolean}">
                                    <a href="<c:url value='${baseLive}${functions:escapePath(node.path)}${page}.html'/>"
                                       title="<fmt:message key='wsf.label.live'/>" class="no-decoration">
                                        <img src="<c:url value='${url.currentModule}/css/img/live.png'/>" width="16" height="16" alt=" "
                                            role="presentation"/>
                                    </a>
                                </c:if>
                            </td>
                        </c:if>
                    </c:otherwise>
                </c:choose>
            </tr>
        </c:forEach>
    </tbody>
</table>

<%@ include file="modalAndForm.jspf" %>

<template:include view="hidden.footer"/>
