<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>

<template:addResources type="css" resources="vendor/typeahead/typeahead.css"/>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js"/>
<template:addResources type="javascript" resources="jquery.jeditable.js,jquery.jeditable.custom.js"/>
<template:addResources type="javascript" resources="vendor/typeahead/typeahead.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootbox.min.js"/>

<c:set var="boundComponent" value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>

<jcr:nodeProperty node="${currentNode}" name="rolesList" var="rolesList"/>
<jcr:nodeProperty node="${currentNode}" name="defaultRole" var="defaultRoleProp"/>
<c:set var="providedDefaultRole" value="${not empty defaultRoleProp ? defaultRoleProp.string : ''}"/>
<c:set var="rolesJs" value=""/>
<c:forEach items="${rolesList}" var="role" varStatus="status">
    <c:set var="roleName" value="${role.string}"/>
    <c:set var="roles" value="${roles} ${roleName}"/>
    <fmt:message key="wsf.role.${roleName}.short" var="roleLabel"/>
    <c:set var="rolesJs" value="${rolesJs}${not empty rolesJs ? ',' : ''}'${roleName}':'${roleLabel}'"/>
    <c:if test="${status.index==0}"><c:set var="firstRole" value="${roleName}"/></c:if>
    <c:if test="${providedDefaultRole==roleName}"><c:set var="defaultRole" value="${roleName}"/></c:if>
    <c:if test="${status.last}"><c:set var="rolesCount" value="${status.count}"/></c:if>
</c:forEach>
<c:set var="defaultRole" value="${not empty defaultRole ? defaultRole : firstRole}"/>
<c:set var="canManageMembers" value="${jcr:hasPermission(boundComponent, not empty currentResource.moduleParams.membersManagementSourceNode ? 'jcr:modifyAccessControl_default' : 'docspace-member-manage')}"/>

<c:if test="${not param.hideForm && canManageMembers}">
    <div>
        <form onsubmit="return false;">
            <div class="scrollable-dropdown-menu">
                <input id="searchUsersTerm_${currentNode.identifier}" class="typeahead" type="text" placeholder="<fmt:message key='jnt_membersManagement.docspace.addUsersOrGroups'/>">
            </div>
        </form>
        <br class="clearfix"/>
    </div>
</c:if>

<c:set var="memberDisplayLimit" value="${currentNode.properties.size.long}"/>

<c:if test="${canManageMembers}">
    <c:url var="postUrl" value="${url.base}${functions:escapePath(boundComponent.path)}.addMemberToAcl.do"/>
    <template:addResources>
        <script type="text/javascript">
            $(document).ready(function() {
                var callback = function() {};
                <c:url value='${not empty currentResource.moduleParams.membersManagementSourceNode ? url.findUsersAndGroupsInAcl : url.findUsersAndGroups}' var="findUsersGroupsUrl">
                    <c:if test="${currentNode.properties.useRolesListForConstrainingUserSearch.boolean}">
                        <c:set var="roles" value=""/>
                        <c:forEach items="${rolesList}" var="roleNode">
                            <c:set var="roleName" value="${roleNode.string}"/>
                            <c:set var="roles" value="${roles} ${roleName}"/>
                        </c:forEach>
                    </c:if>
                </c:url>

                // typeahead
                var usersTH = new Bloodhound({
                    datumTokenizer: Bloodhound.tokenizers.whitespace(),
                    queryTokenizer: Bloodhound.tokenizers.whitespace,
                    remote: {
                        url: '${url.server}${findUsersGroupsUrl}' + '?q=___QUERY',
                        wildcard: '___QUERY',
                        ajax : {
                            type: "GET",
                            dataType: 'json',
                            data: {
                                <c:if test="${not empty currentResource.moduleParams.membersManagementSourceNode}">
                                sourceNode: '${currentResource.moduleParams.membersManagementSourceNode}',
                                roles: '${roles}',
                                </c:if>
                                <c:if test="${empty currentResource.moduleParams.membersManagementSourceNode}">
                                siteKey: '${renderContext.site.siteKey}',
                                </c:if>
                                limit: 10,
                                emptyResultForBadQuery: true
                            }
                        }
                    },
                    limit: 10
                });

                // Initialize the Bloodhound suggestion engine
                usersTH.initialize();

                // Instantiate the Typeahead UI
                $('#searchUsersTerm_${currentNode.identifier}').typeahead(null, {
                    displayKey: 'displayName',
                    source: usersTH.ttAdapter(),
                    highlight: true,
                    autocomplete: true,
                    templates: {
                        suggestion: function(node) {
                            return '<img class="img-polaroid img-circle margin-right-10" id="img_user_' + node['key']
                                    + '" src="${url.context}/modules/default/images/'
                                    + (node['type'] == 'g' ? 'group-icon' : 'usersmall')
                                    + '.png" height="32" width="32"/>' + node['displayName'];
                        }
                    }
                });

                // Event to get selected or autocompleted value
                $('#searchUsersTerm_${currentNode.identifier}').bind('typeahead:selected', function(obj, datum) {
                    if (datum.type === 'u') {
                        addUserOrGroup(datum.key);
                    } else if (datum.type === 'g') {
                        addUserOrGroup('g:' + datum.groupname);
                    }
                    $('#searchUsersTerm_${currentNode.identifier}').typeahead('val', '');
                });
                $('#searchUsersTerm_${currentNode.identifier}').bind('typeahead:autocompleted', function(obj, datum) {
                    if (datum.type === 'u') {
                        addUserOrGroup(datum.key);
                    } else if (datum.type === 'g') {
                        addUserOrGroup('g:' + datum.groupname);
                    }
                    $('#searchUsersTerm_${currentNode.identifier}').typeahead('val', '');
                });

                function addUserOrGroup(key) {
                    $.post('${functions:escapeJavaScript(postUrl)}', { "memberKey": key, "role": "${defaultRole}" }, function(result) {
                        <c:choose>
                            <c:when test="${memberDisplayLimit > 0}">
                                $('#usersList_${currentNode.identifier}').load('<c:url value="${url.current}.ajax?mainResource=${functions:escapeJavaScript(functions:escapePath(boundComponent.path))}.html&includeJavascripts=true&hideForm=true"/>', callback);
                            </c:when>
                            <c:otherwise>
                                location.reload();
                            </c:otherwise>
                        </c:choose>
                    }, "json");
                }

                <c:if test="${memberDisplayLimit > 0}">
                callback = function() {
                    <c:if test="${rolesCount > 1}">
                    $(".editRoles_${currentNode.identifier}").each(function() {
                        var data = {${rolesJs}};
                        data['selected'] = $(this).attr('data-role');
                        $(this).editable(function (value, settings) {
                                    $.post("${functions:escapeJavaScript(postUrl)}", {"memberKey":$(this).attr('key'), "role":value, "overwrite":true}, function(result) {
                                        $("#usersList_${currentNode.identifier}").load("<c:url value='${url.current}.ajax?mainResource=${functions:escapeJavaScript(functions:escapePath(boundComponent.path))}.html&includeJavascripts=true&hideForm=true'/>",callback);
                                    }, "json");
                                }, {
                                    type: 'custom-select',
                                    cssclass: 'input-append',
                                    inputClass: 'input-medium',
                                    data: data,
                                    submit: '<button class="btn btn-primary" type="submit" >Ok</button>'
                                }
                        );
                    });
                    </c:if>
                };
                callback();
                </c:if>

                $('.removeUserRole_${currentNode.identifier}').click(function() {
                    var userID = $(this).attr('key');
                    bootbox.confirm(wsfi18n['jnt_membersManagement.docspace.removeMembersConfirm'], function(result) {
                        if (result) {
                            $.post("${functions:escapeJavaScript(postUrl)}", {"memberKey": userID, "role": ""}, function () {
                                $("#usersList_${currentNode.identifier}").load("<c:url value='${url.current}.ajax?mainResource=${functions:escapeJavaScript(functions:escapePath(boundComponent.path))}.html&includeJavascripts=true&hideForm=true'/>");
                            }, "json");
                        }
                    });
                })
            });
        </script>
    </template:addResources>
</c:if>

<%-- Added users display --%>
<div id="usersList_${currentNode.identifier}" class="row-fluid">
    <div class="span10">
        <c:if test="${memberDisplayLimit > 0}">
            <c:set var="aclEntries" value="${functions:getRolesForNode(boundComponent, false, false, roles, memberDisplayLimit, 'latestFirst')}"/>
            <jcr:node var="adminSite" path="/sites/wsfaccess"/>

            <ul class="thumbnails">
                <c:forEach items="${aclEntries}" var="entry"  begin="0" end="${memberDisplayLimit-1}">
                    <li class="span12 li-no-margin-left">
                        <c:set var="principal" value="${entry['principal']}"/>
                        <c:set var="isGroup" value="${entry['principalType'] eq 'group'}"/>
                        <c:set var="fullName" value="${fn:escapeXml(user:fullName(principal))}"/>

                        <div class="row-fluid thumbnail">
                            <c:if test="${isGroup}">
                                <c:url var="thumbnailUrl" value="${url.currentModule}/css/img/usergroupbig.png"/>
                            </c:if>
                            <c:if test="${!isGroup}">
                                <jcr:nodeProperty var="picture" node="${principal}" name="j:picture"/>
                                <c:url var="profileLink" value="${url.baseLive}${functions:escapePath(principal.path)}.workspace-${currentNode.session.user.username eq principal.name ? '' : 'public-'}user.html">
                                    <c:param name="jsite" value="${adminSite.identifier}"/>
                                </c:url>

                                <c:if test="${empty picture}">
                                    <c:url var="thumbnailUrl" value="${url.currentModule}/css/img/userbig.png"/>
                                </c:if>
                                <c:if test="${not empty picture}">
                                    <c:set var="thumbnailUrl" value="${picture.node.thumbnailUrls['avatar_120']}"/>
                                </c:if>
                            </c:if>

                            <div class="span4 text-center">
                                <c:if test="${not empty profileLink}">
                                <a href="${profileLink}">
                                    </c:if>
                                    <img src="${thumbnailUrl}"
                                         alt="${fullName}"
                                         border="0" width="70"
                                         height="70"
                                         class="img-polaroid img-circle"/>
                                    <c:if test="${not empty profileLink}">
                                </a>
                                </c:if>
                                <c:if test="${canManageMembers && (isGroup || currentNode.session.user.username ne principal.name)}">
                                    <c:set var="principalKey" value="${isGroup ? 'g' : 'u'}:${principal.name}"/>
                                    <button class="btn btn-link btn-mini removeUserRole_${currentNode.identifier}" key="${principalKey}">
                                        <fmt:message key="wsf.label.remove"/>
                                    </button>
                                </c:if>
                            </div>

                                <%--Display user name  --%>
                            <div class="span8">
                                <h5>
                                    <c:if test="${!isGroup}">
                                        <a href="${profileLink}">${fullName}</a>
                                    </c:if>
                                    <c:if test="${isGroup}">
                                        ${fullName}
                                    </c:if>
                                </h5>

                                <c:if test="${!isGroup}">
                                    <p>
                                            ${fn:escapeXml(principal.properties['j:function'].string)}
                                    </p>
                                </c:if>
                                <c:if test="${canManageMembers && (isGroup || currentNode.session.user.username ne principal.name)}">
                                    <c:forEach items="${entry['roles']}" var="role">
                                        <fmt:message key="wsf.role.${role}.short" var="roleLabel"/>
                                        <div class="editRoles_${currentNode.identifier}" key="${principalKey}" title="<fmt:message key='wsf.label.clickToEdit'/>" data-role="${role}"><span class="muted">${roleLabel}</span></div>
                                    </c:forEach>
                                </c:if>
                                <c:if test="${!canManageMembers || (!isGroup && currentNode.session.user.username eq principal.name)}">
                                    <c:forEach items="${entry['roles']}" var="role">
                                        <span class="muted"><fmt:message key="wsf.role.${role}.short" /></span>
                                    </c:forEach>
                                </c:if>
                                <div class="clearfix"></div>
                            </div>
                        </div>
                    </li>
                </c:forEach>
            </ul>

            <c:if test="${fn:length(aclEntries) >= memberDisplayLimit}">
                <c:url var="allMembersUrl" value="${functions:escapePath(boundComponent.path)}.site-management-full.html" context="${url.context}${url.base}"/>
                <a class="pull-right" href="${allMembersUrl}">
                    <fmt:message key="jnt_membersManagement.docspace.viewAllMembers"/>
                </a>
            </c:if>
        </c:if>
    </div>
</div>