<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="acl" type="java.lang.String"--%>
<template:addResources type="css" resources="forum.css"/>
<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>
<template:addResources type="javascript" resources="bootstrap-modal.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="bootbox.min.js"/>

<script type="text/javascript">
    $(document).ready(function(){
        refreshMoment();
    });
</script>

<jcr:nodeProperty node="${currentNode}" name="jcr:title" var="title"/>
<jcr:nodeProperty node="${currentNode}" name="content" var="content"/>
<jcr:nodeProperty node="${currentNode}" name="pseudo" var="createdBy"/>
<jcr:nodeProperty node="${currentNode}" name="jcr:created" var="created"/>
<c:choose>
    <c:when test="${empty createdBy}">
        <jcr:nodeProperty node="${currentNode}" name="jcr:createdBy" var="createdBy"/>
        <jcr:node var="userNode" path="${functions:lookupUser(createdBy.string).localPath}"/>
        <jcr:sql var="numberOfPostsQuery"
                 sql="select [jcr:uuid] from [jnt:post] as p where p.[jcr:createdBy] = '${functions:sqlencode(createdBy.string)}'"/>
    </c:when>
    <c:otherwise>
        <jcr:sql var="numberOfPostsQuery"
                 sql="select [jcr:uuid] from [jnt:post] as p where p.[pseudo] = '${functions:sqlencode(createdBy.string)}'"/>
    </c:otherwise>
</c:choose>


<c:if test="${jcr:hasPermission(currentNode, 'deletePost')}">
    <template:tokenizedForm>
        <form action="<c:url value='${url.base}${functions:escapePath(currentNode.path)}'/>" method="post"
              id="jahia-forum-post-delete-${currentNode.identifier}">
            <input type="hidden" name="jcrRedirectTo"
                   value="<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}'/>"/>
                <%-- Define the output format for the newly created node by default html or by redirectTo--%>
            <input type="hidden" name="jcrNewNodeOutputFormat" value="html"/>
            <input type="hidden" name="jcrMethodToCall" value="delete"/>
        </form>
    </template:tokenizedForm>
</c:if>

<c:if test="${jcr:hasPermission(currentNode.parent.parent, 'moderatePost') and jcr:isNodeType(currentNode, 'jmix:moderated')}">
    <template:tokenizedForm>
        <form action="<c:url value='${url.base}${functions:escapePath(currentNode.path)}'/>" method="post"
              id="jahia-forum-post-moderate-${currentNode.identifier}">
            <input type="hidden" name="jcrRedirectTo"
                   value="<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}'/>"/>
                <%-- Define the output format for the newly created node by default html or by redirectTo--%>
            <input type="hidden" name="jcrNewNodeOutputFormat" value="html"/>
            <input type="hidden" name="jcrMethodToCall" value="put"/>
            <input type="hidden" name="moderated" value="true"/>
        </form>
    </template:tokenizedForm>
</c:if>
<template:option node="${currentNode}" view="hidden.plusone_minorone_form" nodetype="jmix:rating"/>
<jcr:node var="adminSite" path="/sites/wsfaccess"/>
<c:set var="numberOfPosts" value="${functions:length(numberOfPostsQuery.rows)}"/>
<div class="span2 pull-left">
    <div class="media">
        <jcr:nodeProperty var="picture" node="${userNode}" name="j:picture"/>
        <c:if test="${not empty picture}">
            <a class="pull-left"
               href="<c:url value='${url.baseLive}${functions:escapePath(functions:lookupUser(createdBy.string).localPath)}.workspace-user.html?jsite=${adminSite.identifier}'/>">

                <img class="pull-left img-polaroid img-circle" src="${picture.node.thumbnailUrls['avatar_120']}"
                     alt="${fn:escapeXml(title)} ${fn:escapeXml(userNode.properties['j:firstName'].string)} ${fn:escapeXml(userNode.properties['j:lastName'].string)}"
                     width="64"
                     height="64"/></a>
        </c:if>
        <div class="media-body">
            <h6 class="media-heading">
                <c:if test="${not empty userNode.properties['j:email']}">
                <a href=mailto:${fn:escapeXml(userNode.properties['j:email'].string)}>
                    </c:if>
                    ${user:fullName(userNode)}<c:if test="${not empty userNode.properties['j:email']}"></a></c:if></h6>

            <p>
                <small>
                    <fmt:message key="jnt_post.forum.signature">
                        <fmt:param value="${numberOfPosts}"/>
                        <fmt:param value="${userNode.properties['jcr:created'].string}"/>
                    </fmt:message>
                </small>
            </p>
        </div>
    </div>
</div>
<div id="${currentNode.name}"
     class="span9 ws-postbody<c:if test="${currentResource.moduleParams.postIsFirst}">-first</c:if>">
    <c:choose>
        <c:when test="${currentResource.moduleParams.postIsFirst}">
            <div class="triangle-topright-first"></div>
        </c:when>
        <c:otherwise>
            <div class="triangle-topright"></div>
        </c:otherwise>
    </c:choose>
    <div class="pull-right">
        <template:option node="${currentNode}" view="hidden.plusone_minorone" nodetype="jmix:rating"/>
    </div>
    <div class="pull-right">
        <%--<c:if test="${jcr:hasPermission(currentNode, 'reportPost')}">--%>
        <%--<li class="forum-report-icon"><a title="<fmt:message key='jnt_post.forum.reportPost'/>" href="#"><span><fmt:message key='jnt_post.forum.reportPost'/></span></a></li>--%>
        <%--</c:if>--%>
        <c:if test="${jcr:hasPermission(currentNode, 'createPost')}">
            <a title="<fmt:message key='jnt_post.forum.reply'/>" class="btn btn-mini"
               href="<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}.forum-topic-newPost.html?reply=${currentNode.identifier}'/>">
                <i class="fa fa-reply"></i>
            </a>
        </c:if>

        <c:if test="${jcr:hasPermission(currentNode, 'createPost')}">
            <a title="<fmt:message key='jnt_post.forum.replyWithQuote'/>" class="btn btn-mini"
               href="<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}.forum-topic-newPost.html?reply=${currentNode.identifier}&quote=true'/>">
                <i class="fa fa-quote-left"></i>
            </a>
        </c:if>

        <c:if test="${jcr:hasPermission(currentNode.parent.parent, 'moderatePost') and jcr:isNodeType(currentNode, 'jmix:moderated') and not currentNode.properties.moderated.boolean}">
            <a title="<fmt:message key='jnt_post.forum.moderatePost'/>" href="#moderate"
               onclick="document.getElementById('jahia-forum-post-moderate-${currentNode.identifier}').submit(); return false;"><i
                    class="fa fa-edit"></i></a>
        </c:if>

        <c:if test="${jcr:hasPermission(currentNode, 'editPost')}">
            <a title="<fmt:message key='jnt_post.forum.editPost'/>" href="#edit" class="btn btn-mini"
               onclick="$('#edit${currentNode.identifier}').dblclick(); return false;"><i class="fa fa-edit"></i></a>
        </c:if>

        <c:if test="${jcr:hasPermission(currentNode, 'deletePost')}">
            <fmt:message key="jnt_post.forum.confirmDeletePost" var="confirmMsg"/>
            <c:choose>
                <c:when test="${jcr:isNodeType(currentNode.parent, 'jnt:topic')}">
                    <a class="btn btn-mini" title="<fmt:message key="wsf.label.delete"/>"
                       onclick="bootbox.confirm('${functions:escapeJavaScript(confirmMsg)}', function(result){if(result){$('#jahia-forum-post-delete-${currentNode.identifier}').submit()}});return false;"><i class="fa fa-remove"></i></a>
                </c:when>
                <c:otherwise>
                    <a class="fa fa-remove pull-right cursor-pointer" title="<fmt:message key="wsf.label.delete"/>"
                       onclick="bootbox.confirm('${functions:escapeJavaScript(confirmMsg)}', function(result){if(result){$('#jahia-forum-post-delete-${currentNode.identifier}').submit()}});return false;"></a>
                </c:otherwise>
            </c:choose>
        </c:if>
    </div>
    <h4 class="margin-zero"><c:out value="${title.string}"/></h4>

    <p>
        <small>
            <fmt:message key="wsf.label.by"/>
            <strong>&nbsp;<a
                    href="<c:url value='${url.baseLive}${functions:escapePath(functions:lookupUser(createdBy.string).localPath)}.workspace-user.html?jsite=${adminSite.identifier}'/>">${createdBy.string}</a></strong>&nbsp;&raquo;&nbsp;<span class="momentToFormat"
                                                                                   data-moment="${currentNode.properties['jcr:created'].string}"
                                                                                   data-moment-display-type="calendar"></span>
        </small> </p>
    <hr/>
    <c:if test="${jcr:hasPermission(currentNode, 'editPost')}">
        <div class="content editablePost" jcr:id="content"
             id="edit${currentNode.identifier}"
             jcr:url="<c:url value='${url.base}${functions:escapePath(currentNode.path)}'/>">${content.string}</div>
    </c:if>
    <c:if test="${not jcr:hasPermission(currentNode, 'editPost')}">
        <div class="content">${content.string}</div>
    </c:if>
</div>


