<%@ page contentType="text/html; UTF-8" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="social" uri="http://www.jahia.org/tags/socialLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function() {
            refreshMoment();
        });
    </script>
</template:addResources>

<jcr:nodeProperty node="${currentNode}" name="jcr:createdBy" var="createdBy"/>
<jcr:nodeProperty node="${currentNode}" name="content" var="content"/>
<c:if test="${createdBy.string ne ' guest '}">
    <c:set var="userNode" value="${user:lookupUser(createdBy.string)}"/>
    <c:forEach items="${userNode.properties}" var="property">
        <c:if test="${property.name == 'j:firstName'}"><c:set var="firstname" value="${property.string}"/></c:if>
        <c:if test="${property.name == 'j:lastName'}"><c:set var="lastname" value="${property.string}"/></c:if>
        <c:if test="${property.name == 'j:email'}"><c:set var="email" value="${property.string}"/></c:if>
        <c:if test="${property.name == 'j:title'}"><c:set var="title" value="${property.string}"/></c:if>
    </c:forEach>
</c:if>

<jcr:node var="adminSite" path="/sites/wsfaccess"/>
<c:url var="userUrl"
       value='${url.baseLive}${functions:escapePath(userNode.path)}.workspace-public-user.html?jsite=${adminSite.identifier}'/>
<c:if test="${userNode.name eq renderContext.user.name}">
    <c:url var="userUrl"
           value='${url.baseLive}${functions:escapePath(userNode.path)}.workspace-user.html?jsite=${adminSite.identifier}'/>
</c:if>

<c:if test="${jcr:hasPermission(currentNode, 'jcr:removeNode_default')}">
    <form action="<c:url value='${url.base}${functions:escapePath(currentNode.path)}'/>" method="post" id="${currentNode.identifier}_deleteForm">
        <input type="hidden" name="jcrRedirectTo" value="<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}.workspace-document-details'/>"/>
        <input type="hidden" name="jcrNewNodeOutputFormat" value="html"/>
        <input type="hidden" name="jcrMethodToCall" value="delete"/>
    </form>
</c:if>

<div class="well no-margin-bottom" id="genericCommentBox_${currentNode.identifier}">
    <div class="row-fluid">
        <jcr:nodeProperty var="picture" node="${userNode}" name="j:picture"/>
        <span class="span3">
        <c:if test="${not empty picture}">
            <img class="img-polaroid img-circle"
                 src="${picture.node.thumbnailUrls['avatar_60']}"
                 alt="${fn:escapeXml(title)} ${fn:escapeXml(firstname)} ${fn:escapeXml(lastname)}"
                 width="40"
                 height="40"/>
        </c:if>
        <c:if test="${empty picture}">
            <img class="img-polaroid img-circle" width="40" height="40" alt=""
                 src="<c:url value='${url.currentModule}/css/img/userbig.png'/>"/>
        </c:if>
            </span>

        <span class="span3">
            <c:if test="${createdBy.string ne 'guest'}">
                <a href="${userUrl}">${createdBy.string}</a></c:if>
            <c:if test="${createdBy.string eq 'guest'}">
                ${fn:escapeXml(currentNode.properties.pseudo.string)}
            </c:if>
        </span>

        <jcr:nodeProperty node="${currentNode}" name="jcr:lastModified" var="lastModified"/>
        <span class="span5 pull-right">
            <small class="momentToFormat" data-moment-display-type="fromNow"
                   data-moment-locale="${currentResource.locale}"
                   data-moment="<fmt:formatDate value="${lastModified.time}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>"></small>
        </span>

        <c:if test="${jcr:hasPermission(currentNode, 'jcr:removeNode_default')}">
            <div class="row-fluid">
            <span class="span12">
                <a class="fa fa-remove pull-right cursor-pointer" onclick="$('#${currentNode.identifier}_deleteForm').submit()" title="<fmt:message key="wsf.label.delete"/>"></a>
            </span>
            </div>
        </c:if>

    </div>
    <br/>
    <%--<div class="row-fluid">--%>
        <%--<h5 class="commentTitle"><jcr:nodeProperty node="${currentNode}" name="jcr:title"/></h5>--%>
    <%--</div>--%>
    <div class="well background-white">
        ${fn:escapeXml(content.string)}
    </div>

    <div class='clearfix'></div>
</div>
