<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="social" uri="http://www.jahia.org/tags/socialLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="underscore-min.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>
<template:addResources type="javascript" resources="bootstrap-tooltip.js"/>
<template:addResources type="javascript" resources="bootstrap-popover.js"/>
<template:addResources type="javascript" resources="bootstrap-transition.js"/>
<template:addResources type="javascript" resources="jcrestapi.js"/>
<template:addResources type="javascript" resources="notificationsUtils.js"/>

<jcr:node var="currentUser" path="${renderContext.user.localPath}"/>
<jcr:nodeProperty node="${currentUser}" name="notificationsSubscribed" var="notificationsSubscribed"/>
<c:url var="manageNotificationsURL" value="${url.baseLive}/sites/wsfaccess/home.manageNotifications.do"/>

<script type="text/javascript">
    _.templateSettings = {
        interpolate: /\<\@\=(.+?)\@\>/gim,
        evaluate: /\<\@(.+?)\@\>/gim,
        escape: /\<\@\-(.+?)\@\>/gim
    };

    var subscriptionTemplate = _.template(
        '<div class="NotificationRow">' +
            '<div class="mobileNotificationsSubscriptionTitle">' +
                '<a href="<c:url value="${url.base}"/><@= nodePath @><@ if (type === "document") { @>.workspace-document-details.html<@ } else { @>.workspace-note-details.html<@ } @>"' +
                ' title="<@= name @>"><@= name @></a>' +
            '</div>' +
            '<div>' +
                '<a onmouseover="toggleBell(this)" onmouseout="toggleBell(this)" class="fa fa-bell text-warning no-decoration" href="#" title="' + wsfi18n['docnt_collection.unsubscribe'] + '"' +
                ' onclick="refreshSubscriptionList(\'<@= identifier @>\');return false;"></a>' +
            '</div>' +
        '</div>');

    var noSubscriptionTemplate = _.template(
        '<div>' +
            wsfi18n['jnt_socialActivitiesDisplay.notification.message.noSubscription'] +
        '</div>');

    var notificationsTemplate = _.template(
    '<div class="NotificationRow">' +
    '<div class="mobileNotificationsIcon">' +
    "<@ if (icon != 'null') {@>" +
    "<@= icon @>" +
    "<@ } @>" +
    '</div>' +
    '<div class="mobileNotificationsMessageHolder">' +
    "<@ if (heading != 'null') {@>" +
    "<@= heading @>" +
    "<@ } @>" +
    '<div class="mobileNotificationsMessage">' +
    "<@= message @>" +
    '</div>' +
    '<div class="mobileTimeHolder">' +
    '<div class="mobileClockIcon"><span class="fa fa-clock-o"></spin></div>' +
    '<div class="momentToFormat NotificationDate" data-moment-display-type="fromNow" data-moment-locale="${currentResource.locale}" data-moment="<@= lastModified @>"><@= lastModified @></div>' +
    '</div>' +
    '</div>' +
    '</div>');

    var generateSubscriptionContent = function (data) {
        $('#subscriptionListBody').empty();
        if(data !== undefined && data['subscriptionList'].length) {
            _.each(data['subscriptionList'], function (subscription) {
                $('#subscriptionListBody').append(subscriptionTemplate(subscription));
            });
        } else {
            $('#subscriptionListBody').html(noSubscriptionTemplate());
        }
    };
    var listenToCloseNotifications = false;

    $(document).ready(function() {
        $('#notificationsPopover').closest($('div.container-fluid')).children($('a.btn-navbar')).first().after($('#notificationsPopover'));
        $('#notificationsPopover').closest($('div.container-fluid')).append($('#mobileNotifications'));
        $('#mobileNotificationsWrapper').css("width", window.innerWidth);

        refreshMomentEvery(60000);

        $('#notificationsPopover').on("click", function(e) {
            e.preventDefault();

            if (!notificationsPopoverOpen) {
                $("#notificationsBody").empty();
                displayNotifications('${manageNotificationsURL}', 0, "#notificationsBody", "#notificationsCount_${currentNode.identifier}");
                notificationsPopoverOpen = true;

                setTimeout(function() {refreshMoment(); listenToCloseNotifications = true;}, 200);
            }
            else {
                updateRefreshTime('${manageNotificationsURL}');
                notificationsPopoverOpen = false;
                listenToCloseNotifications = false;
                $("#notificationsWrapper").hide();
            }
        });

        $("body").on("click", "#notificationsLoadMoreButton", function() {
            loadMoreResults('${manageNotificationsURL}', notificationsPage, "#notificationsBody", "#notificationsCount_${currentNode.identifier}");
            setTimeout(function() {refreshMoment()}, 200);
        });
        initNotificationsCount('${manageNotificationsURL}', '${currentNode.identifier}');
    });

    function refreshSubscriptionList(nodeIdentifier) {
        if ('${renderContext.mainResource.node.identifier}' === nodeIdentifier) {
            window.location.reload();
        }
        toggleNotifications('${manageNotificationsURL}', 'unsubscribe', nodeIdentifier);
        getSubscriptionList('${manageNotificationsURL}', generateSubscriptionContent);
    }

    function toggleNotificationsSettingsPanel() {
        if ($('#currentSubscribed').hasClass('hide')) {
            getSubscriptionList('${manageNotificationsURL}', generateSubscriptionContent);
            $('#currentSubscribed').removeClass('hide');
            $('#currentNotifications').addClass('hide');
        } else {
            $('#currentSubscribed').addClass('hide');
            $('#currentNotifications').removeClass('hide');
        }
    }

    function toggleBell(that) {
        $(that).toggleClass('fa-bell fa-bell-slash');
        $(that).toggleClass('text-warning text-error');
    }
</script>

<li>
    <a href="#" id="notificationsPopover"
       class="notificationsLink btn btn-navbar" data-toggle="collapse" data-target="#mobileNotifications">
        <i class="fa fa-bell"></i>
        <span class="badge badge-important" id="notificationsCount_${currentNode.identifier}"></span>
    </a>
</li>

<div class="collapse" id="mobileNotifications">
    <div id="mobileNotificationsWrapper">
        <div id="notificationsContainer">
            <div id="notificationsHeading">
                <fmt:message key="jnt_socialActivitiesDisplay.notification.notifications"/>
                <a href="#" onclick="document.getElementById('notificationsPopover').click(); return false;"
                   title="<fmt:message key="jnt_socialActivitiesDisplay.notification.closeNotifications"/>"
                   class="pull-right text-error">
                    <i class="fa fa-close"></i>
                </a>
                <a href="#" onclick="toggleNotificationsSettingsPanel();return false;"
                   title="<fmt:message key="jnt_socialActivitiesDisplay.notification.showNotificationsSettings"/>"
                   class="pull-right margin-right-10">
                    <i class="fa fa-cog"></i>
                </a>
            </div>
            <div class="notificationsContent">
                <div id="currentSubscribed" class="hide">
                    <div class="text-center row-fluid"><fmt:message key="docnt_collection.subscribe"/></div>
                    <div id="subscriptionListBody"></div>
                </div>
                <div id="currentNotifications">
                    <div id="notificationsBody"></div>
                    <div>
                        <div id="notificationsLoadMoreButton"><fmt:message key="jnt_socialActivitiesDisplay.notification.loadMore"/></div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>