<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="task" type="org.jahia.services.workflow.WorkflowTask"--%>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>
<template:addResources type="javascript" resources="jcrestapi.js"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function() {
            refreshMoment();
        });
    </script>
</template:addResources>

<jcr:node var="currentUser" path="${renderContext.user.localPath}"/>

<template:addResources>
    <script type="text/javascript">
        <c:url var="reloadurl" value="${url.base}${functions:escapePath(currentNode.path)}.taskList.docspace.html.ajax">
            <c:forEach items="${param}" var="p">
                <c:param name="${p.key}" value="${p.value}"/>
            </c:forEach>
        </c:url>

        var API_URL_START = '<c:url value="/modules/api/jcr/v1"/>';

        function updateTask(taskIdentifier, property, value){
            jahiaAPIStandardCall('default', '${currentResource.locale}', 'nodes',
                taskIdentifier + '/properties/' + property, 'PUT', JSON.stringify({value: value}),
                function() {
                    window.location.reload()
                });
        }
    </script>
</template:addResources>

<c:choose>
    <c:when test="${currentNode.properties['state'].string ne 'finished'}">
        <div class="well well-small">
            <div class="row-fluid">
                <div class="span12">
                    <div class="row-fluid">
                        <div class="span6">
                            <c:choose>
                                <c:when test="${task.properties['priority'].string eq 'low'}">
                                    <i class="fa fa-arrow-circle-o-down text-success" title="<fmt:message key="jnt_task.docspace.priority"/>&nbsp;:&nbsp;<fmt:message key="jnt_task.docspace.priority.low"/>"></i>
                                </c:when>
                                <c:when test="${task.properties['priority'].string eq 'high'}">
                                    <i class="fa fa-arrow-circle-o-up text-error" title="<fmt:message key="jnt_task.docspace.priority"/>&nbsp;:&nbsp;<fmt:message key="jnt_task.docspace.priority.high"/>"></i>
                                </c:when>
                            </c:choose>
                                ${currentNode.properties['jcr:title'].string}
                        </div>
                        <div class="span6">
                            <c:if test="${currentNode.properties.state.string eq 'started'}">
                                <span class="label label-success pull-right">
                                    <fmt:message key="jnt_task.docspace.state.${currentNode.properties.state.string}"/>
                                </span>
                            </c:if>
                            <c:if test="${currentNode.properties.state.string eq 'suspended'}">
                                <span class="label label-yellow pull-right">
                                    <fmt:message key="jnt_task.docspace.state.${currentNode.properties.state.string}"/>
                                </span>
                            </c:if>
                            <c:if test="${currentNode.properties.state.string eq 'active'}">
                                <span class="label label-warning pull-right">
                                    <fmt:message key="jnt_task.docspace.state.${currentNode.properties.state.string}"/>
                                </span>
                            </c:if>
                        </div>
                    </div>
                    <div class="row-fluid">
                        <div class="span6">
                            <c:if test="${not empty currentNode.properties['description']}">
                                <abbr title="${currentNode.properties['description'].string}"
                                      class="muted">${functions:abbreviate(currentNode.properties['description'].string, 60, 75, ' ...')}</abbr>
                            </c:if>
                        </div>
                        <div class="span6">
                            <jsp:useBean id="now" class="java.util.Date"/>
                            <c:choose>
                                <c:when test="${now.time gt currentNode.properties['dueDate'].date.time.time}">
                                    <span class="text-error pull-right">
                                        <i class="fa fa-fw fa-exclamation-triangle"></i>
                                        <fmt:message key="docnt_taskList.label.taskOverdue"/>
                                        <br />
                                        <span class="momentToFormat" data-moment-display-type="format" data-moment-format="LL"
                                              data-moment-locale="${currentResource.locale}"
                                              data-moment="<fmt:formatDate value="${currentNode.properties['dueDate'].date.time}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>">
                                        </span>
                                    </span>
                                </c:when>
                                <c:otherwise>
                                    <span class="momentToFormat pull-right" data-moment-display-type="fromNow"
                                          data-moment-locale="${currentResource.locale}"
                                          data-moment="<fmt:formatDate value="${currentNode.properties['dueDate'].date.time}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>">
                                    </span>
                                </c:otherwise>
                            </c:choose>
                        </div>
                    </div>
                    <div class="row-fluid">
                        <div class="span6">
                            <c:choose>
                                <c:when test="${not empty currentNode.properties['assigneeUserKey'].string}">
                                    <jcr:node var="assigneeToUserNode" path="${currentNode.properties['assigneeUserKey'].string}"/>
                                    <fmt:message key="jnt_task.docspace.assignTo"/>&nbsp;${assigneeToUserNode.name}
                                </c:when>
                                <c:otherwise>
                                    <fmt:message key="jnt_task.docspace.notAssign"/>
                                </c:otherwise>
                            </c:choose>
                        </div>
                        <div class="span6">
                            <c:set var="assignable" value="true"/>
                            <c:if test="${not empty currentNode.properties['candidates'] and currentNode.properties['assigneeUserKey'].string ne currentUser.path}">
                                <c:set var="assignable" value="false"/>
                                <c:set var="candidates" value=""/>
                                <c:forEach items="${currentNode.properties['candidates']}" var="candidate">
                                    <c:set var="candidates" value=" ${candidate.string} ${candidates} "/>
                                </c:forEach>
                                <c:set var="userKey" value="u:${currentUser.name}"/>
                                <c:if test="${fn:contains(candidates, userKey)}">
                                    <c:set var="assignable" value="true"/>
                                </c:if>
                                <c:if test="${not assignable}">
                                    <c:set var="groups" value="${user:getUserMembership(currentUser)}"/>
                                    <c:forEach items="${groups}" var="x">
                                        <c:if test="${fn:contains(candidates, x.key)}">
                                            <c:set var="assignable" value="true"/>
                                        </c:if>
                                    </c:forEach>
                                </c:if>
                            </c:if>
                            <div class="btn-group pull-right">
                                <c:choose>
                                    <c:when test="${currentNode.properties.state.string == 'active' and currentNode.properties['assigneeUserKey'].string ne currentUser.path and assignable eq 'true'}">
                                        <button class="taskAction btn btn-primary btn-small" type="button" title="<fmt:message key="jnt_task.docspace.assigneToMe"/>"
                                                onclick="updateTask('${currentNode.identifier}', 'assigneeUserKey', '${functions:escapeJavaScript(currentUser.path)}')">
                                            <i class="fa fa-user-plus"></i>
                                        </button>
                                    </c:when>

                                    <c:when test="${currentNode.properties.state.string == 'active' and currentNode.properties['assigneeUserKey'].string eq currentUser.path}">
                                        <button class="taskAction btn btn-small" type="button" title="<fmt:message key="jnt_task.docspace.unassign"/>"
                                                onclick="updateTask('${currentNode.identifier}', 'assigneeUserKey', '')">
                                            <i class="fa fa-user-times"></i>
                                        </button>
                                        <button class="taskAction btn btn-success btn-small" type="button" title="<fmt:message key="jnt_task.docspace.start"/>"
                                                onclick="updateTask('${currentNode.identifier}', 'state', 'started')">
                                            <i class="fa fa-play"></i>
                                        </button>
                                    </c:when>

                                    <c:when test="${currentNode.properties.state.string == 'started' and currentNode.properties['assigneeUserKey'].string eq currentUser.path}">
                                        <button class="taskAction btn btn-small" type="button" title="<fmt:message key="jnt_task.docspace.unassign"/>"
                                                onclick="updateTask('${currentNode.identifier}', 'assigneeUserKey', '')">
                                            <i class="fa fa-user-times"></i>
                                        </button>
                                        <button class="taskAction btn btn-yellow btn-small" type="button" title="<fmt:message key="jnt_task.docspace.suspend"/>"
                                                onclick="updateTask('${currentNode.identifier}', 'state', 'suspended')">
                                            <i class="fa fa-pause"></i>
                                        </button>
                                        <c:if test="${empty currentNode.properties['possibleOutcomes']}">
                                            <button class="btn btn-primary btn-small" type="button" title="<fmt:message key="jnt_task.docspace.complete"/>"
                                                    onclick="updateTask('${currentNode.identifier}', 'state', 'finished')">
                                                <i class="fa fa-flag-checkered"></i>
                                            </button>
                                        </c:if>
                                    </c:when>

                                    <c:when test="${currentNode.properties.state.string == 'suspended' and currentNode.properties['assigneeUserKey'].string eq currentUser.path}">
                                        <button class="taskAction btn btn-small" type="button" title="<fmt:message key="jnt_task.docspace.unassign"/>"
                                                onclick="updateTask('${currentNode.identifier}', 'assigneeUserKey', '')">
                                            <i class="fa fa-user-times"></i>
                                        </button>
                                        <button class="taskAction btn btn-success btn-small" type="button" title="<fmt:message key="jnt_task.docspace.resume"/>"
                                                onclick="updateTask('${currentNode.identifier}', 'state', 'started')">
                                            <i class="fa fa-play-circle"></i>
                                        </button>
                                    </c:when>
                                    <c:otherwise> <!--Default case | simply adds assign button-->
                                        <button class="taskAction btn btn-primary btn-small" type="button" title="<fmt:message key="jnt_task.docspace.assigneToMe"/>"
                                                onclick="updateTask('${currentNode.identifier}', 'assigneeUserKey', '${functions:escapeJavaScript(currentUser.path)}')">
                                            <i class="fa fa-user-plus"></i>
                                        </button>
                                    </c:otherwise>
                                </c:choose>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <template:tokenizedForm>
            <form id="tokenForm_${currentNode.identifier}" name="tokenForm_${currentNode.identifier}" method="post"
                  action="<c:url value='${url.base}${functions:escapePath(currentNode.path)}'/>">
            </form>
        </template:tokenizedForm>
    </c:when>
    <c:otherwise>
        <div class="well well-small">
            <div class="row-fluid">
                <div class="span12">
                    <div class="row-fluid">
                        <div class="span6">
                            <c:choose>
                                <c:when test="${task.properties['priority'].string eq 'low'}">
                                    <i class="fa fa-arrow-circle-o-down text-info" title="<fmt:message key="jnt_task.docspace.priority"/>"></i>
                                </c:when>
                                <c:when test="${task.properties['priority'].string eq 'high'}">
                                    <i class="fa fa-exclamation-triangle text-error" title="<fmt:message key="jnt_task.docspace.priority"/>"></i>
                                </c:when>
                                <c:otherwise>
                                    <i class="fa fa-arrow-circle-o-up text-success" title="<fmt:message key="jnt_task.docspace.priority"/>"></i>
                                </c:otherwise>
                            </c:choose>
                            ${currentNode.properties['jcr:title'].string}
                        </div>
                        <div class="span6">
                            <span class="pull-right">
                                <jcr:node var="assigneeNode" path="${currentNode.properties['assigneeUserKey'].string}"/>
                                <fmt:message key="jnt_task.docspace.assignTo"/>&nbsp;${assigneeNode.name}
                            </span>
                        </div>
                    </div>
                    <c:if test="${not empty currentNode.properties['description']}">
                        <div class="row-fluid">
                            <div class="span12">
                                <abbr title="${currentNode.properties['description'].string}"
                                      class="muted">${functions:abbreviate(currentNode.properties['description'].string, 60, 75, ' ...')}</abbr>
                            </div>
                        </div>
                    </c:if>
                </div>
            </div>
        </div>
    </c:otherwise>
</c:choose>

<div class="clearfix"></div>