<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="javascript" resources="jquery.js"/>
<template:addResources type="javascript" resources="moment-with-locales.js"/>
<template:addResources type="javascript" resources="momentUtils.js"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function() {
            refreshMoment();
        });
    </script>
</template:addResources>

<c:if test="${currentResource.moduleParams.displayFirstName == 'true' and currentResource.moduleParams.displayLastName == 'true' and currentResource.moduleParams.displayTitle == 'true'}">
    <c:if test="${not empty currentNode.properties['j:firstName'].string or not empty currentNode.properties['j:lastName'].string or not empty currentNode.properties['j:title'].string}">
        <c:set var="person" value="${title.displayName} ${currentNode.properties['j:firstName'].string} ${currentNode.properties['j:lastName'].string}"/>
    </c:if>
</c:if>
<c:if test="${currentResource.moduleParams.displayFirstName == 'true' and currentResource.moduleParams.displayLastName == 'true' and currentResource.moduleParams.displayTitle == 'false'}">
    <c:if test="${not empty currentNode.properties['j:firstName'].string or not empty currentNode.properties['j:lastName'].string}">
        <c:set var="person" value="${currentNode.properties['j:firstName'].string} ${currentNode.properties['j:lastName'].string}"/>
    </c:if>
</c:if>
<c:if test="${currentResource.moduleParams.displayFirstName == 'false' and currentResource.moduleParams.displayLastName == 'true' and currentResource.moduleParams.displayTitle == 'false' and not empty currentNode.properties['j:lastName'].string}">
    <c:set var="person" value="${currentNode.properties['j:lastName'].string}"/>
</c:if>
<c:if test="${currentResource.moduleParams.displayFirstName == 'true' and currentResource.moduleParams.displayLastName == 'false' and currentResource.moduleParams.displayTitle == 'false' and not empty currentNode.properties['j:firstName'].string}">
    <c:set var="person" value="${currentNode.properties['j:firstName'].string}"/>
</c:if>
<c:if test="${currentResource.moduleParams.displayFirstName == 'false' and currentResource.moduleParams.displayLastName == 'false' and currentResource.moduleParams.displayTitle == 'false'}">
    <c:set var="person" value=""/>
</c:if>

<jcr:nodeProperty node="${currentNode}" name="j:birthDate" var="birthDate"/>

<div class="row-fluid">
    <div class="span12">
        <div class="row-fluid">
            <div class="span4">
                <c:if test="${currentResource.moduleParams.displayPicture}">
                    <c:if test="${not empty currentNode.properties['j:picture']}">
                        <jcr:nodeProperty var="picture" node="${currentNode}" name="j:picture"/>
                        <c:if test="${not empty picture}">
                            <img class="img-circle img-polaroid pull-left" src="${picture.node.thumbnailUrls['avatar_60']}"
                                 alt="${fn:escapeXml(person)}"/>
                        </c:if>
                    </c:if>
                </c:if>
            </div>
            <div class="span8">
                <jcr:node var="wsfaccessNode" path="/sites/wsfaccess"/>
                <h5><a href="<c:url value='${url.base}${functions:escapePath(currentNode.path)}.workspace-public-user.html?jsite=${wsfaccessNode.identifier}'/>">${fn:escapeXml(person)}</a></h5>
                <c:if test="${currentResource.moduleParams.displayBirthDate}">
                    <c:if test="${not empty birthDate}">
                        <p>${renderContext.site.parent}
                            <fmt:message key="jnt_user.age"/>:
                            <span class="momentToFormat" data-moment-display-type="fromNow"
                                data-moment-format="true" data-moment-locale="${currentResource.locale}"
                                data-moment="<fmt:formatDate value="${birthDate.date.time}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>">
                            </span>
                        </p>
                    </c:if>
                </c:if>
                <c:if test="${currentResource.moduleParams.displayGender}">
                    <c:if test="${not empty currentNode.properties['j:gender'].string}">
                        <p><fmt:message key="jnt_user.j_gender"/>: ${currentNode.properties['j:gender'].string}</p>
                    </c:if>
                </c:if>
                <c:if test="${currentResource.moduleParams.displayEmail}">
                    <c:if test="${not empty currentNode.properties['j:email'].string}">
                        <p><fmt:message key="jnt_user.j_email"/>: ${fn:escapeXml(currentNode.properties['j:email'].string)}</p>
                    </c:if>
                </c:if>
                <div class="clearfix"></div>
            </div>
        </div>
        <c:if test="${currentResource.moduleParams.displayAbout}">
            <c:if test="${not empty currentNode.properties['j:about'].string}">
                <div class="row-fluid">
                    <div class="span12">
                        <c:choose>
                            <c:when test="${fn:length(currentNode.properties['j:about'].string) gt 200}">
                                <p>${functions:abbreviate(currentNode.properties['j:about'].string, 200, 225,' ...')}</p>
                            </c:when>
                            <c:otherwise>
                                <p>${currentNode.properties['j:about'].string}</p>
                            </c:otherwise>
                        </c:choose>
                    </div>
                </div>
            </c:if>
        </c:if>
    </div>
    <div class="clearfix"></div>
</div>

