<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.js"/>
<template:addResources type="javascript" resources="bootstrap-dropdown.js"/>

<c:set var="user" value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>
<c:if test="${!empty param.userUuid}">
    <jcr:node var="user" uuid="${param.userUuid}"/>
</c:if>
<c:if test="${empty user or not jcr:isNodeType(user, 'jnt:user')}">
    <jcr:node var="user" path="${renderContext.user.localPath}"/>
</c:if>

<template:addCacheDependency node="${user}"/>

<jsp:useBean id="fields" class="java.util.HashMap"/>
<c:set var="fields" value="${user.propertiesAsString}"/>

<c:if test="${currentNode.properties['j:title'].boolean}">
    <jcr:nodePropertyRenderer node="${user}" name="j:title" renderer="resourceBundle" var="title"/>
</c:if>
<c:if test="${not empty title and (not empty fields['j:firstName'] and currentNode.properties['j:firstName'].boolean) and (not empty fields['j:lastName'] and currentNode.properties['j:lastName'].boolean)}">
    <c:set var="person" value="${title.displayName} ${fields['j:firstName']} ${fields['j:lastName']}"/>
</c:if>
<c:if test="${empty title and (not empty fields['j:firstName'] and currentNode.properties['j:firstName'].boolean) and (not empty fields['j:lastName'] and currentNode.properties['j:lastName'].boolean)}">
    <c:set var="person" value="${fields['j:firstName']} ${fields['j:lastName']}"/>
</c:if>
<c:if test="${empty title and (empty fields['j:firstName'] or not currentNode.properties['j:firstName'].boolean) and (not empty fields['j:lastName'] and currentNode.properties['j:lastName'].boolean)}">
    <c:set var="person" value="${fields['j:lastName']}"/>
</c:if>
<c:if test="${empty title and (not empty fields['j:firstName'] and currentNode.properties['j:firstName'].boolean) and (empty fields['j:lastName'] or not currentNode.properties['j:lastName'].boolean)}">
    <c:set var="person" value="${fields['j:firstName']}"/>
</c:if>
<c:if test="${empty title and empty fields['j:firstName'] and empty fields['j:lastName']}">
    <c:set var="person" value=""/>
</c:if>

<div class="well">
    <div class="row">
        <div class="span12">
            <div class="span11 offset1">
                <jcr:nodeProperty var="picture" node="${user}" name="j:picture"/>
                <a href="<c:url value='${url.base}${functions:escapePath(renderContext.user.localPath)}.workspace-public-user.html?jsite=${renderContext.site.identifier}'/>"
                   title="<fmt:message key="jnt_userDetails.docspace.vCard.seePublicProfile"/>">
                    <c:choose>
                        <c:when test="${not empty picture}">
                            <img class="img-polaroid img-circle pull-left margin-right-10" src="${picture.node.thumbnailUrls['avatar_120']}"
                                 alt="${fn:escapeXml(person)}" width="50" height="50"/>
                        </c:when>
                        <c:otherwise>
                            <img class="img-polaroid img-circle pull-left margin-right-10" src="<c:url value='${url.currentModule}/img/userbig.png'/>" alt=""
                                 width="50" height="50"/>
                        </c:otherwise>
                    </c:choose>
                    <p>
                        <c:choose>
                            <c:when test="${not empty fn:trim(person)}">
                                ${fn:escapeXml(person)}
                            </c:when>
                            <c:otherwise>
                                ${fn:escapeXml(user.displayableName)}
                            </c:otherwise>
                        </c:choose>
                    </p>
                </a>
                <p class="hobbit">
                    <c:if test="${not empty fields['j:function']}">
                        ${fn:escapeXml(fields['j:function'])}
                    </c:if>

                    <c:if test="${not empty fields['j:organization'] and not empty fields['j:function']}">
                        <br/><fmt:message key="wsf.label.at"/>${' '}
                    </c:if>

                    <c:if test="${not empty fields['j:organization']}">
                        ${fn:escapeXml(fields['j:organization'])}
                    </c:if>
                </p>
            </div>
        </div>
    </div>
</div>

<c:if test="${jcr:hasPermission(renderContext.site, 'jcr:read_default')}">
    <a class="pull-right" title="<fmt:message key="jnt_userDetails.docspace.editProfile"/>"
       href="<c:url value="/cms/wsfactory/default/${currentResource.locale}/sites/wsfaccess/user-profile.html"/>">
        <fmt:message key="jnt_userDetails.docspace.editProfile"/>
    </a>
</c:if>
