<%@ page import="org.jahia.services.usermanager.JahiaUserManagerService" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>

<template:addResources type="javascript" resources="jquery.min.js"/>

<div>
    <jsp:useBean id="userSearchCriterias" class="java.util.HashMap" scope="page" />

    <c:if test="${empty param.letter}">
        <c:set value="A" var="selectedLetter"/>
    </c:if>
    <c:if test="${!empty param.letter}">
        <c:set var="selectedLetter" value="${param.letter}"/>
    </c:if>

    <c:set target="${userSearchCriterias}" property="j:lastName" value="${selectedLetter}*" />
    <c:set var="users" value="${user:searchUsers(userSearchCriterias)}"/>
    <c:set var="totalSize" value="${fn:length(users)}"/>



    <div class="pagination pagination-centered">
        <ul>
            <c:forTokens items="A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z" var="letter" delims=",">
                <c:set target="${userSearchCriterias}" property="<%=JahiaUserManagerService.COUNT_LIMIT%>" value="1" />
                <c:set target="${userSearchCriterias}" property="j:lastName" value="${letter}*" />
                <c:set var="hasUsers" value="${fn:length(user:searchUsers(userSearchCriterias)) > 0}"/>
                <c:url var="myUrl" value="${url.mainResource}">
                    <c:param name="letter" value="${letter}"/>
                </c:url>
                <c:choose>
                    <c:when test="${hasUsers}">
                        <li <c:if test='${letter eq selectedLetter}'>class="active"</c:if>><a title="${letter}" href="${myUrl}">${letter}</a></li>
                    </c:when>
                    <c:otherwise>
                        <li class="disabled"><span>${letter}</span></li>
                    </c:otherwise>
                </c:choose>
            </c:forTokens>
        </ul>
    </div>
    <div class='clearfix'></div>

    <c:set var="boostrapPagerID" value="membersFaces"/>
    <template:initPager id="${boostrapPagerID}" totalSize="${totalSize}" pageSize="25"/>

    <%@ include file="results.jspf" %>

    <%@ include file="../../includes/bootstrapPager.jspf" %>
</div>