<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>

<template:addResources type="css" resources="vendor/typeahead/typeahead.css"/>
<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js"/>
<template:addResources type="javascript" resources="jquery.jeditable.js"/>
<template:addResources type="javascript" resources="vendor/typeahead/typeahead.js"/>

<c:set var="boundComponent"
       value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>

<jcr:nodeProperty node="${currentNode}" name="rolesList" var="rolesList"/>
<jcr:nodeProperty node="${currentNode}" name="defaultRole" var="defaultRoleProp"/>
<c:set var="providedDefaultRole" value="${not empty defaultRoleProp ? defaultRoleProp.string : ''}"/>
<c:forEach items="${rolesList}" var="role" varStatus="status">
    <c:set var="roleName" value="${role.string}"/>
    <c:set var="roles" value="${roles} ${roleName}"/>
    <c:if test="${status.index>0}">
        <c:set var="rolesJs" value="${rolesJs},"/>
    </c:if>
    <fmt:message key="wsf.role.${roleName}" var="roleLabel"/>
    <c:set var="rolesJs" value="${rolesJs}'${roleName}':'${roleLabel}'"/>
    <c:if test="${status.index==0}"><c:set var="firstRole" value="${roleName}"/></c:if>
    <c:if test="${providedDefaultRole==roleName}"><c:set var="defaultRole" value="${roleName}"/></c:if>
</c:forEach>
<c:set var="defaultRole" value="${not empty defaultRole ? defaultRole : firstRole}"/>
<c:url var="postUrl" value="${url.base}${functions:escapePath(boundComponent.path)}.addMemberToAcl.do"/>

<div id="rights_${currentNode.identifier}">

<fmt:message key="jnt_membersManagement.docspace.removeMembersConfirm" var="i18nRemoveConfirm"/>
<template:addResources>
    <script type="text/javascript">
        $(document).ready(function () {
            // typeahead
            var skillSelectionTH = new Bloodhound({
                datumTokenizer: Bloodhound.tokenizers.whitespace(),
                queryTokenizer: Bloodhound.tokenizers.whitespace,
                remote: {
                    url: '<c:url value='/modules/api/jcr/v1/default/${currentResource.locale}/query?noLinks'/>',
                    wildcard: '___QUERY',
                    replace: function(url, query) {
                        this.ajax.data = JSON.stringify({
                            limit: 10,
                            queryName : 'workspaceFactorySearchSkill',
                            parameters : [query.toLowerCase() + '%','% ' + query.toLowerCase() + '%']
                        });
                        return url + "#" + query.toLowerCase() ;
                    },
                    ajax : {
                        type: 'POST',
                        contentType: 'application/json',
                        dataType: 'json',
                        processData:false
                    }
                },
                limit: 10
            });

            // Initialize the Bloodhound suggestion engine
            skillSelectionTH.initialize();

            // Instantiate the Typeahead UI
            $('#skillSelection_${currentNode.identifier}').typeahead(null, {
                source: skillSelectionTH.ttAdapter(),
                highlight: true,
                autocomplete: true,
                displayKey: function(res) {
                    return res.properties.jcr__title.value;
                }
            });

            $("#addCustomField_${currentNode.identifier}").change(function () {
                var fieldToBeDisplayed = $(this).val();
                if (fieldToBeDisplayed != "none") {
                    $("#" + fieldToBeDisplayed + "_${currentNode.identifier}").appendTo($("#searchMembersFS_${currentNode.identifier}"));
                    $("#" + fieldToBeDisplayed + "_${currentNode.identifier}").show();
                    $(this).find('[value="'+fieldToBeDisplayed+'"]').remove();
                    $(this).val("none");
                }
            });

            $("#deleteFirstnameField_${currentNode.identifier}").click(function () {
                $("#firstnameField_${currentNode.identifier}").hide();
                $("#firstnameField_${currentNode.identifier}").appendTo($("#rights_${currentNode.identifier}"));
                $("#addCustomField_${currentNode.identifier}").append($('<option>',{
                    value : 'firstnameField',
                    text : '<fmt:message key="jnt_user.j_firstName"/>'
                }));
            });

            $("#deleteGenderField_${currentNode.identifier}").click(function () {
                $("#genderField_${currentNode.identifier}").hide();
                $("#genderField_${currentNode.identifier}").appendTo($("#rights_${currentNode.identifier}"));
                $("#addCustomField_${currentNode.identifier}").append($('<option>',{
                    value : 'genderField',
                    text : '<fmt:message key="jnt_user.j_gender"/>'
                }));
            });

            $("#deleteOrganizationField_${currentNode.identifier}").click(function () {
                $("#organizationField_${currentNode.identifier}").hide();
                $("#organizationField_${currentNode.identifier}").appendTo($("#rights_${currentNode.identifier}"));
                $("#addCustomField_${currentNode.identifier}").append($('<option>',{
                    value : 'organizationField',
                    text : '<fmt:message key="jnt_user.j_organization"/>'
                }));
            });

            $("#deleteSkillField_${currentNode.identifier}").click(function () {
                $("#skillsField_${currentNode.identifier}").hide();
                $("#skillsField_${currentNode.identifier}").appendTo($("#rights_${currentNode.identifier}"));
                $("#addCustomField_${currentNode.identifier}").append($('<option>',{
                    value : 'skillsField',
                    text : '<fmt:message key="docnt_skill"/>'
                }));
            });

            <c:if test="${not empty param.fir}">
                $("#addCustomField_${currentNode.identifier}").val("firstnameField");
                $("#addCustomField_${currentNode.identifier}").change();
            </c:if>

            <c:if test="${not empty param.ski}">
                $("#addCustomField_${currentNode.identifier}").val("skillsField");
                $("#addCustomField_${currentNode.identifier}").change();
            </c:if>

            <c:if test="${not empty param.gen}">
                $("#addCustomField_${currentNode.identifier}").val("genderField");
                $("#addCustomField_${currentNode.identifier}").change();
            </c:if>

            <c:if test="${not empty param.org}">
                $("#addCustomField_${currentNode.identifier}").val("organizationField");
                $("#addCustomField_${currentNode.identifier}").change();
            </c:if>
        });
    </script>
</template:addResources>

    <div class="page-header">
        <form class="form-horizontal" action="" method="get">
            <input type="hidden" name="displayTab" value="search"/>
            <input type="hidden" name="d" value="true"/>
            <fieldset id="searchMembersFS_${currentNode.identifier}">
                <div class="control-group">
                    <label class="control-label" for="searchmemberslastname_${currentNode.identifier}">
                        <fmt:message key="jnt_user.j_lastName"/>
                    </label>
                    <div class="controls">
                        <input type="text" value="${fn:escapeXml(param.las)}" name="las" maxlength="32" size="16"
                               id="searchmemberslastname_${currentNode.identifier}"/>
                    </div>
                </div>
            </fieldset>
            <div class="control-group">
                <label class="control-label" for="addCustomField_${currentNode.identifier}">
                    <fmt:message key="jnt_usersManagement.search.addCriteria"/>
                </label>
                <div class="controls">
                    <select id="addCustomField_${currentNode.identifier}">
                        <option value="none"></option>
                        <option value="firstnameField"><fmt:message key="jnt_user.j_firstName"/></option>
                        <%--<option value="genderField"><fmt:message key="jnt_user.j_gender"/></option>--%>
                        <option value="organizationField"><fmt:message key="jnt_user.j_organization"/></option>
                        <%--<option value="skillsField"><fmt:message key="docnt_skill"/></option>--%>
                    </select>
                </div>
            </div>
            <div class="control-group">
                <div class="controls">
                    <button class="btn btn-primary" type="submit">
                        <fmt:message key="wsf.label.search"/>
                    </button>
                </div>
            </div>
        </form>
    </div>

    <div id="firstnameField_${currentNode.identifier}" class="control-group hide">
        <label class="control-label" for="searchmembersfirstname_${currentNode.identifier}">
            <fmt:message key="jnt_user.j_firstName"/>
        </label>
        <div class="controls">
            <div class="input-append">
                <input type="text" value="${fn:escapeXml(param.fir)}" name="fir" maxlength="32" size="16"
                       id="searchmembersfirstname_${currentNode.identifier}"/>
                <button type="button" class="btn btn-danger" id="deleteFirstnameField_${currentNode.identifier}">
                    <i class="fa fa-minus"></i>
                </button>
            </div>
        </div>
    </div>

    <div id="genderField_${currentNode.identifier}" class="control-group hide">
        <label class="control-label" for="searchmembersgender_${currentNode.identifier}">
            <fmt:message key="jnt_user.j_gender"/>
        </label>
        <div class="controls">
            <div class="input-append">
                <select class="field" name="gen" id="searchmembersgender_${currentNode.identifier}">
                    <option value="all"<c:if
                            test="${empty param.gen or param.gen eq 'all'}"> selected="true"</c:if>><fmt:message
                            key="wsf.label.all"/></option>
                    <option value="female"<c:if test="${param.gen eq 'female'}"> selected="true"</c:if>><fmt:message
                            key="jnt_user.j_gender.female"/></option>
                    <option value="male"<c:if test="${param.gen eq 'male'}"> selected="true"</c:if>><fmt:message
                            key="jnt_user.j_gender.male"/></option>
                </select>
                <button type="button" class="btn btn-danger" id="deleteGenderField_${currentNode.identifier}">
                    <i class="fa fa-minus"></i>
                </button>
            </div>
        </div>
    </div>

    <div id="organizationField_${currentNode.identifier}" class="control-group hide">
        <label class="control-label" for="searchmembersorganization_${currentNode.identifier}">
            <fmt:message key="jnt_user.j_organization"/>
        </label>
        <div class="controls">
            <div class="input-append">
                <input type="text" value="${fn:escapeXml(param.org)}" name="org" maxlength="32" size="16"
                       id="searchmembersorganization_${currentNode.identifier}"/>
                <button type="button" class="btn btn-danger" id="deleteOrganizationField_${currentNode.identifier}">
                    <i class="fa fa-minus"></i>
                </button>
            </div>
        </div>
    </div>

    <div id="skillsField_${currentNode.identifier}" class="control-group hide">
        <label class="control-label" for="skillSelection_${currentNode.identifier}">
            <fmt:message key="docnt_skill"/>
        </label>
        <div class="controls">
            <div class="input-append">
                <input id="skillSelection_${currentNode.identifier}" class="typeahead scrollable-dropdown-menu" type="text"
                       name="ski" maxlength="32" size="16" placeholder="${startSearching}" value="${fn:escapeXml(param.ski)}">
                <button type="button" class="btn btn-danger margin-top-2" id="deleteSkillField_${currentNode.identifier}">
                    <i class="fa fa-minus"></i>
                </button>
            </div>
        </div>
    </div>


    <c:if test="${not empty param.d}">
        <jsp:useBean id="userSearchCriterias" class="java.util.HashMap" scope="page" />
        <c:set target="${userSearchCriterias}" property="multi_criteria_search_op" value="and" />
        <c:if test="${not empty param.las}">
            <c:set target="${userSearchCriterias}" property="j:lastName" value="*${param.las}*" />
        </c:if>
        <c:if test="${not empty param.fir}">
            <c:set target="${userSearchCriterias}" property="j:firstName" value="*${param.fir}*" />
        </c:if>
        <c:if test="${not empty param.gen and param.gen != 'all'}">
            <c:set target="${userSearchCriterias}" property="j:gender" value="${param.gen}" />
        </c:if>
        <c:if test="${not empty param.org}">
            <c:set target="${userSearchCriterias}" property="j:organization" value="*${param.org}*" />
        </c:if>
        <c:if test="${not empty param.skill}">
            <c:set target="${userSearchCriterias}" property="skill" value="${param.ski}" />
        </c:if>
        <c:set var="users" value="${user:searchUsers(userSearchCriterias)}"/>
        <c:set var="totalSize" value="${fn:length(users)}"/>

        <c:set var="boostrapPagerID" value="membersSearch"/>
        <template:initPager id="${boostrapPagerID}" totalSize="${totalSize}" pageSize="25"/>

        <%@ include file="results.jspf" %>

        <%@include file="../../includes/bootstrapPager.jspf"%>
    </c:if>
</div>