<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="uiComponents" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%@ taglib prefix="query" uri="http://www.jahia.org/tags/queryLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>

<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jquery-ui.min.js"/>
<template:addResources type="javascript" resources="jquery.jeditable.js"/>

<c:set var="boundComponent"
       value="${uiComponents:getBindedComponent(currentNode, renderContext, 'j:bindedComponent')}"/>

<jcr:nodeProperty node="${currentNode}" name="rolesList" var="rolesList"/>
<jcr:nodeProperty node="${currentNode}" name="defaultRole" var="defaultRoleProp"/>
<c:set var="providedDefaultRole" value="${not empty defaultRoleProp ? defaultRoleProp.string : ''}"/>
<c:forEach items="${rolesList}" var="role" varStatus="status">
    <c:set var="roleName" value="${role.string}"/>
    <c:set var="roles" value="${roles} ${roleName}"/>
    <c:if test="${status.index>0}">
        <c:set var="rolesJs" value="${rolesJs},"/>
    </c:if>
    <fmt:message key="wsf.role.${roleName}" var="roleLabel"/>
    <c:set var="rolesJs" value="${rolesJs}'${roleName}':'${roleLabel}'"/>
    <c:if test="${status.index==0}"><c:set var="firstRole" value="${roleName}"/></c:if>
    <c:if test="${providedDefaultRole==roleName}"><c:set var="defaultRole" value="${roleName}"/></c:if>
</c:forEach>
<c:set var="defaultRole" value="${not empty defaultRole ? defaultRole : firstRole}"/>

<div id="rights_${currentNode.identifier}">
    <div class="row-fluid">
        <div class="span3">
            <form action="" method="get">
                <input type="hidden" name="displayTab" value="search"/>
                <input type="hidden" name="d" value="true"/>
                <fieldset id="searchMembersFS_${currentNode.identifier}">
                    <div class="control-group">
                        <label class="control-label">
                            <fmt:message key="jnt_user.j_firstName"/>
                        </label>
                        <div class="controls">
                            <input type="text" value="${fn:escapeXml(param.fir)}" name="fir" maxlength="32" size="16"/>
                        </div>
                    </div>

                    <div class="control-group">
                        <label class="control-label">
                            <fmt:message key="jnt_user.j_lastName"/>
                        </label>
                        <div class="controls">
                            <input type="text" value="${fn:escapeXml(param.las)}" name="las" maxlength="32" size="16"/>
                        </div>
                    </div>

                    <div class="control-group">
                        <label class="control-label">
                            <fmt:message key="jnt_user.j_organization"/>
                        </label>
                        <div class="controls">
                            <input type="text" value="${fn:escapeXml(param.org)}" name="org" maxlength="32" size="16"/>
                        </div>
                    </div>
                </fieldset>
                <div class="control-group">
                    <div class="controls">
                        <button class="btn btn-primary" type="submit">
                            <fmt:message key="wsf.label.search"/>
                        </button>
                    </div>
                </div>
            </form>
        </div>

        <div class="span9">
            <c:if test="${not empty param.d}">
                <jsp:useBean id="userSearchCriterias" class="java.util.HashMap" scope="page" />
                <c:set target="${userSearchCriterias}" property="multi_criteria_search_op" value="and" />

                <c:if test="${not empty param.las}">
                    <c:set target="${userSearchCriterias}" property="j:lastName" value="${param.las}*" />
                </c:if>
                <c:if test="${not empty param.fir}">
                    <c:set target="${userSearchCriterias}" property="j:firstName" value="${param.fir}*" />
                </c:if>
                <c:if test="${not empty param.org}">
                    <c:set target="${userSearchCriterias}" property="j:organization" value="*${param.org}*" />
                </c:if>

                <c:set var="users" value="${user:searchUsers(userSearchCriterias)}"/>
                <c:set var="totalSize" value="${fn:length(users)}"/>

                <c:set var="boostrapPagerID" value="membersSearch"/>
                <template:initPager id="${boostrapPagerID}" totalSize="${totalSize}" pageSize="25"/>

                <%@ include file="results.jspf" %>

                <%@include file="../../includes/bootstrapPager.jspf"%>
            </c:if>
        </div>
    </div>
</div>