<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="markitupStyle.css"/>
<template:addResources type="css" resources="markitupWikiStyle.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jquery.validate.js"/>
<template:addResources type="javascript" resources="jquery.markitup.js"/>
<template:addResources type="javascript" resources="markitupWikiSet.js"/>

<c:set value="${currentNode.properties['jcr:title'].string}" var="currentNodeTitle"/>

<script type="text/javascript">
    $(document).ready(function() {
        $('#formWiki_${currentNode.identifier}').validate({
            rules: {
                'jcr:title': 'required',
                'lastComment': 'required'
            },
            'messages':{
                'jcr:title': wsfi18n['wsf.label.noTitle']
            },
            errorClass: 'text-error'
        })
    });

    var confirmDeletionOfArticle = function() {
        bootbox.confirm(getMessageWithArgs(wsfi18n['jnt_wikiPage.contribute.docspace.confirmDelete'],
                                                  ['${functions:escapeJavaScript(currentNodeTitle)}']),
                function(result) {
                    if (result) {
                        document.getElementById('jahia-wiki-article-delete_${currentNode.identifier}').submit();
                    }
        });
    }
</script>
<div class="row-fluid">
    <div class="span6">
        <h2>${fn:escapeXml(currentNodeTitle)}</h2>
    </div>
    <div class="span6">
        <c:if test="${jcr:hasPermission(currentNode,'removeWikiContent')}">
            <c:set var="currentDisplayName">
                <c:out value="${currentNode.displayableName}"/>
            </c:set>
            <button class="btn btn-danger btn-mini pull-right" onclick="confirmDeletionOfArticle()"
                    title="<fmt:message key="jnt_wikiPage.contribute.docspace.deleteThisArticle"/>">
                <i class="fa fa-trash"></i>
            </button>
            <template:tokenizedForm>
                <form action="<c:url value='${url.base}${functions:escapePath(currentNode.path)}'/>" method="post"
                      id="jahia-wiki-article-delete_${currentNode.identifier}">
                    <input type="hidden" name="jcrRedirectTo"
                           value="<c:url value='${url.base}${functions:escapePath(jcr:getParentOfType(renderContext.mainResource.node, "jnt:page").path)}'/>"/>
                        <%-- Define the output format for the newly created node by default html or by jcrRedirectTo--%>
                    <input type="hidden" name="jcrNewNodeOutputFormat" value="html"/>
                    <input type="hidden" name="jcrMethodToCall" value="delete"/>
                </form>
            </template:tokenizedForm>
        </c:if>
    </div>
</div>
<div class="row-fluid">
    <div class="span12">
        <template:tokenizedForm disableXSSFiltering="true">
            <form id="formWiki_${currentNode.identifier}" name="formWiki" class="formWiki" action="<c:url value='${url.base}${functions:escapePath(currentNode.path)}'/>"
                  method="post">
                <input type="hidden" name="jcrAutoCheckin" value="true">
                <input type="hidden" name="jcrRedirectTo"
                       value="<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}'/>"/>
                <input type="hidden" name="jcrNewNodeOutputFormat" value="html"/>
                <input type="hidden" name="jcrMethodToCall" value="put"/>

                <div class="control-group">
                    <label class="control-label" id="jcr:title">
                        <fmt:message key="wsf.label.title"/>
                    </label>
                    <div class="controls">
                        <input type="text" name="jcr:title" value="<c:out value="${currentNode.properties['jcr:title'].string}" />"/>
                    </div>
                </div>

                <script type="text/javascript">
                    $(document).ready(function () {
                        // Add markItUp! to your textarea in one line
                        // $('textarea').markItUp( { Settings }, { OptionalExtraSettings } );
                        $('#text-${currentNode.identifier}').markItUp(mySettings).css("width", "90%");
                    });
                </script>
                <div class="control-group">
                    <label class="control-label" for="text-${currentNode.identifier}">
                        <fmt:message key="jnt_wikiPage.docspace.content"/>
                    </label>
                    <div class="controls">
                        <textarea class="textareawiki" name="wikiContent"
                                  id="text-${currentNode.identifier}"><c:out
                                value="${currentNode.properties['wikiContent'].string}"/></textarea>
                    </div>
                </div>

                <div class="control-group">
                    <label class="control-label" for="comment-${currentNode.identifier}">
                        <fmt:message key="jnt_wikiPage.contribute.docspace.addComment"/>
                    </label>
                    <div class="controls">
                        <input name="lastComment" type="text" id="comment-${currentNode.identifier}"/>
                    </div>
                </div>

                <div class="control-group">
                    <div class="controls">
                        <button class="btn btn-primary btn-block" type="submit">
                            <fmt:message key='wsf.label.submit'/>
                        </button>
                    </div>
                </div>
            </form>
        </template:tokenizedForm>
    </div>
</div>
