<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<template:addResources type="css" resources="wiki.css"/>
<template:addResources type="css" resources="markitupStyle.css"/>
<template:addResources type="css" resources="markitupWikiStyle.css"/>

<template:addResources type="javascript" resources="jquery.min.js"/>
<template:addResources type="javascript" resources="jquery.validate.js"/>
<template:addResources type="javascript" resources="jquery.markitup.js"/>
<template:addResources type="javascript" resources="markitupWikiSet.js"/>

<template:addResources>
    <script type="text/javascript">
        $(document).ready(function() {
            $('#formWiki_${currentNode.identifier}').validate({
                rules: {
                    'jcr:title': 'required',
                    'lastComment': 'required'
                },
                'messages':{
                    'jcr:title': wsfi18n['wsf.label.noTitle']
                },
                errorClass: 'text-error'
            })
        });
    </script>
</template:addResources>

<div class="row-fluid">
    <div class="span12">
        <c:set var="pageName" value="*"/>
        <c:if test="${not empty param.newPageName}">
            <c:set var="pageName" value="${param['newPageName']}"/>
        </c:if>
        <c:set var="pageNode" value="${jcr:getMeAndParentsOfType(renderContext.mainResource.node, 'jnt:page')[0]}"/>
        <c:if test="${jcr:isNodeType(renderContext.mainResource.node,'jnt:wikiPage')}">
            <c:set var="pageNode" value="${renderContext.mainResource.node}"/>
        </c:if>
        <template:tokenizedForm disableXSSFiltering="true">
            <form id="formWiki_${currentNode.identifier}" name="formWiki" class="formWiki" method="post"
                  action="<c:url value='${url.base}${functions:escapePath(pageNode.path)}/*'/>">
                <input type="hidden" name="jcrAutoCheckin" value="true">
                <input type="hidden" name="jcrNodeType" value="jnt:wikiPage">
                <input type="hidden" name="jcrAutoAssignRole" value="owner">
                <c:choose>
                    <c:when test="${not empty param.newPageName}">
                        <input type="hidden" name="jcrNodeName" value="${pageName}">
                        <input type="hidden" name="jcr:title" value="${param['wikiTitle']}">

                        <h2>${param['wikiTitle']}</h2>
                    </c:when>
                    <c:otherwise>
                        <div class="control-group">
                            <label class="control-label" for="title-${currentNode.identifier}">
                                <fmt:message key="wsf.label.title"/>
                            </label>
                            <div class="controls">
                                <input type="text" name="jcr:title" id="title-${currentNode.identifier}"/>
                            </div>
                        </div>
                    </c:otherwise>
                </c:choose>
                <script type="text/javascript">
                    $(document).ready(function () {
                        // Add markItUp! to your textarea in one line
                        // $('textarea').markItUp( { Settings }, { OptionalExtraSettings } );
                        $('#text-${currentNode.identifier}').markItUp(mySettings).css("width", "90%");
                    });
                </script>
                <div class="control-group">
                    <label class="control-label" for="text-${currentNode.identifier}">
                        <fmt:message key="jnt_wikiPage.docspace.content"/>
                    </label>
                    <div class="controls">
                        <textarea class="textareawiki" name="wikiContent" rows="30" cols="85"
                                  id="text-${currentNode.identifier}"><fmt:message
                                key="jnt_wiki.typeContentHere"/></textarea>
                    </div>
                </div>

                <div class="control-group">
                    <label class="control-label" for="comment-${currentNode.identifier}">
                        <fmt:message key="jnt_wikiPage.contribute.docspace.addComment"/>
                    </label>
                    <div class="controls">
                        <input name="lastComment" type="text" id="comment-${currentNode.identifier}"/>
                    </div>
                </div>

                <div class="control-group">
                    <div class="controls">
                        <button class="btn btn-primary btn-block" type="submit">
                            <fmt:message key='wsf.label.submit'/>
                        </button>
                    </div>
                </div>
            </form>
        </template:tokenizedForm>
    </div>
</div>