<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="ui" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<template:addResources type="css" resources="workspace.css"/>

<template:addResources type="javascript" resources="jquery.form.js"/>
<utility:useConstants var="jcrPropertyTypes" className="org.jahia.services.content.nodetypes.ExtendedPropertyType"
                      scope="application"/>
<utility:useConstants var="selectorType" className="org.jahia.services.content.nodetypes.SelectorType"
                      scope="application"/>
<c:set var="resourceNodeType" value="${currentResource.moduleParams.resourceNodeType}"/>
<c:if test="${empty resourceNodeType}">
    <c:set var="resourceNodeType" value="${param.resourceNodeType}"/>
</c:if>
<jcr:nodeType name="${resourceNodeType}" var="type"/>
<c:set var="scriptTypeName" value="${fn:replace(type.name,':','_')}"/>
<div class="FormContribute" id="workflowManagementForms">
    <c:choose>
        <c:when test="${not empty currentResource.moduleParams.workflowStartAction}">
            <c:set var="formAction" value="${currentResource.moduleParams.workflowStartAction}"/>
        </c:when>
        <c:when test="${not empty currentResource.moduleParams.workflowStartForm}">
            <c:set var="formAction" value="${url.base}${functions:escapePath(currentNode.path)}.startPublicationWorkflow.do"/>
        </c:when>
        <c:when test="${not empty currentResource.moduleParams.workflowTaskForm}">
            <c:set var="formAction" value="${url.base}${functions:escapePath(currentNode.path)}.executeTask.do"/>
        </c:when>
    </c:choose>
    <c:set var="jsNodeName" value="${fn:replace(fn:replace(currentNode.identifier,'-','_'),'.','_')}"/>
    <form action="<c:url value='${formAction}'/>" method="post" class="form-horizontal no-margin-bottom"
            <c:if test="${!(resourceNodeType eq 'jnt:file' || resourceNodeType eq 'jnt:folder')}">
                id="${jsNodeName}${scriptTypeName}"
            </c:if>
            <c:if test="${resourceNodeType eq 'jnt:file'}">
                enctype="multipart/form-data"
            </c:if>>
        <c:choose>
            <c:when test="${not empty currentResource.moduleParams.workflowStartForm}">
                <input type="hidden" name="process" value="${currentResource.moduleParams.workflowStartForm}"/>
            </c:when>
            <c:when test="${not empty currentResource.moduleParams.workflowTaskForm}">
                <input type="hidden" name="action" value="${currentResource.moduleParams.workflowTaskForm}"/>
                <input type="hidden" name="outcome" id="outcome"/>
            </c:when>
            <c:otherwise>
                <input type="hidden" name="jcrNodeType" value="${type.name}"/>
                <input type="hidden" name="jcrRedirectTo" value="<c:url value='${url.base}${functions:escapePath(renderContext.mainResource.node.path)}'/>"/>
                <%-- Define the output format for the newly created node by default html or by redirectTo--%>
                <input type="hidden" name="jcrNewNodeOutputFormat" value="html"/>
            </c:otherwise>
        </c:choose>
        <div class="modal-body">
            <c:forEach items="${type.propertyDefinitions}" var="propertyDefinition">
                <c:if test="${propertyDefinition.name eq 'jcr:title'}">
                    <div class="control-group">
                        <label class="control-label"
                               for="${fn:replace(propertyDefinition.name,':','_')}">${jcr:labelInNodeType(propertyDefinition,currentResource.locale,type)}</label>
                        <div class="controls">
                            <input type="text" id="${scriptTypeName}${fn:replace(propertyDefinition.name,':','_')}"
                                   name="${propertyDefinition.name}" <c:if test="${not empty workflowTaskFormTask}">value="${workflowTaskFormTask.variables[propertyDefinition.name][0].value}"</c:if>/>
                        </div>
                    </div>
                </c:if>
            </c:forEach>
            <c:if test="${not empty currentResource.moduleParams.workflowTaskNodeUuid}">
                <jcr:node var="currentNodeOverride" uuid="${currentResource.moduleParams.workflowTaskNodeUuid}"/>
            </c:if>
            <c:forEach items="${type.propertyDefinitions}" var="propertyDefinition">
                <c:if test="${!propertyDefinition.multiple and propertyDefinition.contentItem and !(propertyDefinition.name eq 'jcr:title')}">
                    <div class="control-group">
                        <c:choose>
                            <c:when test="${(propertyDefinition.requiredType == jcrPropertyTypes.REFERENCE || propertyDefinition.requiredType == jcrPropertyTypes.WEAKREFERENCE)}">
                                <c:choose>
                                    <c:when test="${propertyDefinition.selector eq selectorType.FILEUPLOAD or propertyDefinition.selector eq selectorType.CONTENTPICKER}">
                                        <%@include file="formelements/file.jsp" %>
                                    </c:when>
                                    <c:when test="${propertyDefinition.selector eq selectorType.CHOICELIST}">
                                        <%@include file="formelements/select.jsp" %>
                                    </c:when>
                                    <c:otherwise>
                                        <%@include file="formelements/reference.jsp" %>
                                    </c:otherwise>
                                </c:choose>
                            </c:when>
                            <c:when test="${propertyDefinition.requiredType == jcrPropertyTypes.DATE}">
                                <%@include file="formelements/datepicker.jsp" %>
                            </c:when>
                            <c:when test="${propertyDefinition.selector eq selectorType.CHOICELIST}">
                                <%@include file="formelements/select.jsp" %>
                            </c:when>
                            <c:when test="${propertyDefinition.selector eq selectorType.RICHTEXT}">
                                <%@include file="formelements/richtext.jsp" %>
                            </c:when>
                            <c:when test="${propertyDefinition.requiredType == jcrPropertyTypes.BOOLEAN}">
                                <label class="control-label"
                                       for="${fn:replace(propertyDefinition.name,':','_')}">${jcr:labelInNodeType(propertyDefinition,currentResource.locale,type)}</label>
                                <div class="controls">
                                    <input type="radio" value="true" class="radio"
                                           id="${scriptTypeName}${fn:replace(propertyDefinition.name,':','_')}"
                                           name="${propertyDefinition.name}" checked="true"/><fmt:message key="wsf.label.yes"/>
                                    <input type="radio" value="false" class="radio"
                                           id="${scriptTypeName}${fn:replace(propertyDefinition.name,':','_')}"
                                           name="${propertyDefinition.name}"/><fmt:message key="wsf.label.no"/>
                                </div>
                            </c:when>
                            <c:otherwise>
                                <label class="control-label"
                                       for="${fn:replace(propertyDefinition.name,':','_')}">${jcr:labelInNodeType(propertyDefinition,currentResource.locale,type)}</label>
                                <div class="controls">
                                    <input type="text" id="${scriptTypeName}${fn:replace(propertyDefinition.name,':','_')}"
                                           name="${propertyDefinition.name}"/>
                                </div>
                            </c:otherwise>
                        </c:choose>
                    </div>
                </c:if>
            </c:forEach>
        </div>
        <div class="modal-footer">
            <button class="btn" data-dismiss="modal" aria-hidden="true">
                <fmt:message key="wsf.label.close"/>
            </button>
            <button type="reset"  class="btn btn-danger">
                <span class="fa fa-remove"></span>
                <fmt:message key="wsf.label.reset"/>
            </button>
            <c:choose>
                <c:when test="${not empty currentResource.moduleParams.workflowStartForm}">
                    <button type="button" id="startWorkFlowButton" class="btn btn-primary"
                            onclick="$('.form-button').attr('disabled',true);$('.form-button').addClass('disabled');$('#${jsNodeName}${scriptTypeName}').ajaxSubmit(options${jsNodeName}${scriptTypeName});">
                        <span class="fa fa-play"></span>
                        <fmt:message key="jnt_task.docspace.start" />:&nbsp;${currentResource.moduleParams.workflowStartFormWFName}
                    </button>
                </c:when>
                <c:when test="${not empty currentResource.moduleParams.workflowTaskForm}">
                    <c:forEach items="${workflowTaskFormTask.outcomes}" var="outcome" varStatus="status">
                        <c:set var="outcomeIcon" value="${workflowTaskFormTask.outcomeIcons[status.index]}"/>
                        <button type="button" class="btn btn-primary"
                                onclick="$('#outcome').val('${outcome}');$('.form-button').attr('disabled',true);$('.form-button').addClass('disabled');$('#${jsNodeName}${scriptTypeName}').ajaxSubmit(options${jsNodeName}${scriptTypeName});"><span
                                class="fa ${empty outcomeIcon ? 'fa-check-circle ' : ''}"><c:if test="${not empty outcomeIcon}"><img src="<c:url value='${outcomeIcon}'/>" alt=" "/></c:if></span>&nbsp;${workflowTaskFormTask.displayOutcomes[status.index]}
                        </button>
                    </c:forEach>
                </c:when>
                <c:otherwise>
                    <div class="control-group">
                        <label class="control-label"
                               for="${fn:replace(propertyDefinition.name,':','_')}">${jcr:labelInNodeType(propertyDefinition,currentResource.locale,type)}</label>
                        <div class="controls">
                            <input type="text" id="${scriptTypeName}${fn:replace(propertyDefinition.name,':','_')}"
                                   name="${propertyDefinition.name}"/>
                        </div>
                    </div>
                </c:otherwise>
            </c:choose>
        </div>
    </form>
    <script type="text/javascript">
        var options${jsNodeName}${scriptTypeName} = {
            success: function() {
                window.location.reload();
            },
            dataType: "json",
            clearForm: true
        };// wait for the DOM to be loaded
    </script>
</div>
