<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="ui" uri="http://www.jahia.org/tags/uiComponentsLib" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="propertyDefinition" type="org.jahia.services.content.nodetypes.ExtendedPropertyDefinition"--%>
<%--@elvariable id="type" type="org.jahia.services.content.nodetypes.ExtendedNodeType"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>
<%--@elvariable id="selectorType" type="org.jahia.services.content.nodetypes.SelectorType"--%>

<template:addResources type="css" resources="contribute.min.css"/>
<template:addResources type="css" resources="vendor/bootstrap-datetimepicker/bootstrap-datetimepicker.min.css"/>

<template:addResources type="javascript" resources="jquery.min.js,jquery-ui.min.js"/>
<template:addResources type="javascript" resources="moment-with-locale.js"/>
<template:addResources type="javascript" resources="vendor/bootstrap-datetimepicker/bootstrap-datetimepicker.js"/>
<template:addResources type="javascript" resources="vendor/bootstrap-datetimepicker/locales/bootstrap-datetimepicker.${currentResource.locale}.js"/>

<div class="control-group">
    <label class="control-label"
           for="datePicker_${scriptTypeName}${fn:replace(propertyDefinition.name,':','_')}">
           ${jcr:labelInNodeType(propertyDefinition, currentResource.locale, type)}
    </label>
    <input type="hidden" name="${propertyDefinition.name}" id="${scriptTypeName}${fn:replace(propertyDefinition.name,':','_')}"/>

    <div class="controls">
        <div id="datePicker_${currentNode.identifier}" class="input-append">
            <input id="datePicker_${scriptTypeName}${fn:replace(propertyDefinition.name,':','_')}"
                   value="" type="text" disabled ${disabled}/>
            <span class="add-on">
                <i data-date-icon="fa fa-calendar"></i>
            </span>
        </div>
    </div>
</div>

<div class="control-group">
    <label class="control-label"
           for="timePicker_${scriptTypeName}${fn:replace(propertyDefinition.name,':','_')}">
           <fmt:message key="wsf.label.at"/>
    </label>

    <div class="controls">
        <div id="timePicker_${currentNode.identifier}" class="input-append">
            <input id="timePicker_${scriptTypeName}${fn:replace(propertyDefinition.name,':','_')}"
                   value="" type="text" disabled ${disabled}/>
            <span class="add-on">
                <i data-time-icon="fa fa-clock-o"></i>
            </span>
        </div>
    </div>
</div>

<template:addResources>
<script>
    $(document).ready(function() {
        <c:if test="${not empty now}">
            var preselectedDateTime = moment(<fmt:formatDate value="${now}" pattern="yyyy-MM-dd'T'HH:mm:ssZ"/>).locale('${currentResource.locale}');
            $('#datePicker_${scriptTypeName}${fn:replace(propertyDefinition.name,':','_')}').val(preselectedDateTime.format('L'));
            $('#timePicker_${scriptTypeName}${fn:replace(propertyDefinition.name,':','_')}').val(preselectedDateTime.format('HH:mm'));
        </c:if>

        $('#datePicker_${currentNode.identifier}').datetimepicker({
            language: '${currentResource.locale}',
            format: moment().locale('${currentResource.locale}')._locale._longDateFormat.L,
            startDate: new Date(),
            toggleActive: true,
            pickTime: false
        }).on('changeDate', function() {
            if ($('.datepicker-days').css('display') === 'block')
                $('.bootstrap-datetimepicker-widget').hide();
        });

        $('#timePicker_${currentNode.identifier}').datetimepicker({
            language: '${currentResource.locale}',
            format: 'hh:mm',
            startDate: new Date(),
            toggleActive: true,
            pickDate: false,
            pickSeconds: false
        });

        $("#"+"${jsNodeName}${scriptTypeName}").bind('form-pre-serialize', function() {
            var dateToUse;
            var datePicked = $("#datePicker_${scriptTypeName}${fn:replace(propertyDefinition.name,':','_')}").val();
            if (datePicked === '') {
                dateToUse = moment().locale('${currentResource.locale}').endOf('day').toISOString();
            } else {
                var timePicked = $('#timePicker_${scriptTypeName}${fn:replace(propertyDefinition.name,':','_')}').val();
                var dateFormat = moment().locale('${currentResource.locale}')._locale._longDateFormat.L;
                if (timePicked === '') {
                    dateToUse = moment(datePicked, dateFormat)
                            .locale('${currentResource.locale}').endOf('day').toISOString();
                } else {
                    dateToUse = moment(datePicked + " " + timePicked, dateFormat + " HH:mm").toISOString();
                    if (moment().isAfter(dateToUse)) {
                        dateToUse = moment().add(1, 'hour').toISOString();
                    }
                }
            }
            $("#"+"${scriptTypeName}${fn:replace(propertyDefinition.name,':','_')}").val(dateToUse);
            return false;
        })
    });
</script>
</template:addResources>
